(setvar "CMDECHO" 0)

		**** UTILITIES ******

(defun c:PP()
(command "PURGE" "A" "" "N"))

(defun c:3p()
(command "UCS" "3p"))

(DEFUN C:W() 
(COMMAND "ucs" "W"))

(DEFUN C:OO( / PT)
(SETQ PT (GETPOINT "\nINPUT POINT ")) 
(COMMAND "ucs" "O" PT))



(defun c:CHT()
(LOAD "C:\\PROGRAM FILES\\AUTOCAD R14\\BONUS\\CADTOOLS\\CHTEXT"))


		**** LAYER ******

(defun c:TL()

  (setvar "REGENMODE" 0)
  (setq SCALE (getreal "Nhap Ty Le Vao : "))
  (setvar "DIMCLRE" 2)      ;Color
  (setvar "DIMCLRD" 2)      ;Color
  (setvar "DIMCLRT" 2)      ;Color
  (setvar "DIMZIN" 8)       ;Trailing
(defun c:0() (command "LAYER" "T" "0" "S" "0" ""))
(defun c:1() (command "LAYER" "T" "1" "S" "1" ""))
(defun c:2() (command "LAYER" "T" "2" "S" "2" ""))
(defun c:3() (command "LAYER" "T" "3" "S" "3" ""))
(defun c:4() (command "LAYER" "T" "4" "S" "4" ""))
(defun c:5() (command "LAYER" "T" "5" "S" "5" ""))
(defun c:6() (command "LAYER" "T" "6" "S" "6" ""))
(defun c:7() (command "LAYER" "T" "7" "S" "7" ""))
(defun c:8() (command "LAYER" "T" "8" "S" "8" ""))
(defun c:9() (command "LAYER" "T" "9" "S" "9" ""))

(defun c:c0() (SSGET) (command "select" pause) (command ".chprop" "p" "" "la" "0" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c1() (SSGET) (command "select" pause) (command ".chprop" "p" "" "la" "1" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c2() (SSGET) (command "select" pause) (command ".chprop" "p" "" "la" "2" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c3() (SSGET) (command "select" pause) (command ".chprop" "p" "" "la" "3" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c4() (SSGET) (command "select" pause) (command ".chprop" "p" "" "la" "4" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c5() (SSGET) (command "select" pause) (command ".chprop" "p" "" "la" "5" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c6() (SSGET) (command "select" pause) (command ".chprop" "p" "" "la" "6" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c7() (SSGET) (command "select" pause) (command ".chprop" "p" "" "la" "7" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c8() (SSGET) (command "select" pause) (command ".chprop" "p" "" "la" "8" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c9() (SSGET) (command "select" pause) (command ".chprop" "p" "" "la" "9" "LT" "BYLAYER" "C" "BYLAYER" ""))

(defun c:f0() (command "LAYER" "F" "0" ""))
(defun c:f1() (command "LAYER" "F" "1" ""))
(defun c:f2() (command "LAYER" "F" "2" ""))
(defun c:f3() (command "LAYER" "F" "3" ""))
(defun c:f4() (command "LAYER" "F" "4" ""))
(defun c:f5() (command "LAYER" "F" "5" ""))
(defun c:f6() (command "LAYER" "F" "6" ""))
(defun c:f7() (command "LAYER" "F" "7" ""))
(defun c:f8() (command "LAYER" "F" "8" ""))
(defun c:f9() (command "LAYER" "F" "9" ""))

	**** TEXT ******


  (command "STYLE" "5" "VNI-Helve" (* 7 SCALE) "0.9" "0" "N" "N")
  (command "STYLE" "2" "vn_vni" (* 3 SCALE) "0.8" "0" "N" "N" "N")
  (command "STYLE" "4" "VN_VNI" (* 5 SCALE) "0.8" "0" "N" "N" "N")


  (setvar "DIMEXE" SCALE)             ;Extension above line
  (setvar "DIMEXO" 0)                 ;Feature offset
  (setvar "DIMASZ" 0)                 ;Arrow size 
  (setvar "DIMSE1" 0)                 ;suppress
  (setvar "DIMSE2" 0)                 ;suppress
  (setvar "DIMZIN" 8)                 ;trailing
  (setvar "DIMTSZ" (* 0.75 SCALE))     ;Tick size 
  (setvar "DIMDLE" SCALE)             ;Tick extension 
  (setvar "DIMTXT" (* 3 SCALE))       ;Text height
  (setvar "DIMTAD" 1)                 ;Verical (defauft)
  (setvar "DIMTIH" 0)                 ;Horizontal
  (setvar "DIMTOH" 0)                 ;Horizontal
  (setvar "DIMTIX" 1)                 ;Force text inside   
  (setvar "DIMSOXD" 0)                ;Force text inside
  (setvar "DIMGAP" (* 1 SCALE))
  (setvar "DIMTXSTY" "2")
  (setvar "REGENMODE" 1)
)


(defun c:T4() (setvar "TEXTSTYLE" "4")
(command "DTEXT")
)

(defun c:T2() (setvar "TEXTSTYLE" "2")
(command "DTEXT")
)

(defun c:T5() (setvar "TEXTSTYLE" "5")
(command "DTEXT")
)

		**** MODIFY ******


(DEFUN C:C() (COMMAND "COPY"))
(defun c:E() (command "ERASE"))
(defun c:EL() (command "ELLIPSE"))
(defun c:M() (command "MOVE"))
(defun c:L() (command "LINE"))
(defun c:PL() (command "PLINE"))
(defun c:R() (command "REDRAW"))
(defun c:A() (command "ARC"))
(defun c:CC() (command "CIRCLE"))
(defun c:C() (command "COPY"))
(defun c:PO() (command "POINT"))
(defun c:SC() (command "SCALE"))
(defun c:DT() (command "DTEXT"))
(defun c:MV() (command "MVIEW"))
(defun c:D() (command "DONUT"))
(defun c:QS() (command "QSAVE"))
(defun c:IN() (command "OSNAP" "INT"))
(defun c:MID() (command "OSNAP" "MID"))
(defun c:END() (command "OSNAP" "END"))
(defun c:CEN() (command "OSNAP" "CEN"))
(defun c:NO() (command "OSNAP" "NON"))
(defun c:RE() (command "REGEN"))
(defun c:RO() (command "ROTATE"))
(defun c:REC() (command "RECTANG"))
(defun c:PE() (command "PEDIT"))
(defun c:PS() (command "PSPACE"))
(defun c:MS() (command "MSPACE"))
(defun c:O() (command "OFFSET"))
(defun c:CHA() (command "CHAMFER"))
(defun c:T() (command "TRIM"))
(defun c:EX() (command "EXTEND"))
(defun c:F() (command "FILLET"))
(defun c:MI() (command "MIRROR"))
(defun c:ZA() (command "ZOOM" "A"))
(defun c:Z() (command "ZOOM"))
(defun c:ZE() (command ".ZOOM" "E"))
(defun c:Z1() (command ".ZOOM" "0.5x"))
(defun c:Z2() (command ".ZOOM" "2x"))
(defun c:ZW() (command "ZOOM" "W"))
(defun c:ZP() (command "ZOOM" "P"))
(defun c:ZD() (command "ZOOM" "D"))
(defun c:CH() (command "CHANGE"))
(defun c:CHP() (command "CHPROP"))
(defun c:EXp() (command "EXPLODE"))
(defun c:LI() (command "LIST"))
(defun c:DI() (command "DIST"))
(defun c:AR() (command "ARRAY"))
(defun c:II() (c:DDINSERT))
(defun c:I() (command "INSERT"))
(defun c:B() (command "BLOCK"))
(defun c:WB() (command "WBLOCK"))
(defun c:VP() (command "VPOINT" "R"))
(defun c:S() (command "STRETCH" "C"))
(defun c:DDD() (command "DDEDIT"))

(defun c:LTS (/ TILE )
  (setq TILE (getvar "TILEMODE"))
  (if (= #LTS_PS nil) (setq #LTS_PS 5))
  (if (= #LTS_MS nil) (setq #LTS_MS 60))
  (if (= TILE 0) 
     (progn 
        (setq #LTS_PS (getint (strcat "\nInpput LTSCALE factor for PAPER SPACE "
                                       "<" (rtos #LTS_PS 2 0) ">"))) 
        (setvar "LTSCALE" #LTS_PS)
        (command "REGENALL")
     ) 
     (progn 
        (setq #LTS_MS (getint (STRCAT "\nInpput LTSCALE factor for MODEL SPACE "
                                       "<" (rtos #LTS_MS 2 0) ">"))) 
        (setvar "LTSCALE" #LTS_MS)
        (command "REGENALL")
     ) 
  )
)
(defun c:TM( / TILE)
 (setq TILE (getvar "TILEMODE")) 
 (if #LTS_MS #LTS_MS (setq #LTS_MS 40))
 (if #LTS_PS #LTS_PS (setq #LTS_PS 4))
 (if (= TILE 0)
    (progn
      (setvar "LTSCALE" #LTS_MS)
      (setvar "TILEMODE" 1)
    )      
    (progn
      (setvar "LTSCALE" #LTS_PS)
      (setvar "TILEMODE" 0)
    )
 );if
)
(defun c:df( / kieu )
   (setq kieu (getstring "\n Plot / Draw (D):" ))
   (if (= kieu "") (setq kieu "D"))
   (if (or (= kieu "D") (= kieu "d")) (setvar "fontmap" "c:\\program files\\autocad r14\\fonts\\acad.fmp"))
   (if (or (= kieu "P") (= kieu "p")) (setvar "fontmap" "c:\\program files\\autocad r14\\support\\acad.fmp"))
   (if (and (/= kieu "D") (/= kieu "d") (/= kieu "P") (/= kieu "p")) (princ "\nInvalid key"))  
   (command "regenall" )
)                 
(defun c:ED() (command "DDEDIT"))
(defun c:UP() (command "DIM1" "UP"))
(defun c:DED() (command "DIM1" "NEW"))
(defun c:DM() (command "dim1" "tedit"))
(defun c:EDD() (COMMAND "DDATTE"))
(defun c:MO() (c:DDMODIFY))
(defun c:A1() (command "PLINE" "0,0" "817,0" "817,570" "0,570" "c"))
(defun c:A2() (command "PLINE" "0,0" "570,0" "570,396" "0,396" "c"))
(defun c:A3() (command "PLINE" "0,0" "396,0" "396,273" "0,273" "c"))
(defun c:A4() (command "PLINE" "0,0" "198,0" "198,285" "0,285" "c"))

		
		****  DIMENTION ******

(defun c:HH()
  (prompt "\nNew dim method. ")
  (setq OS (getvar "OSMODE"))
  (setq #DIM 1)
  (setq pt1 (getpoint "\nSelect first extension line origin : ")
        pt2 (getpoint "\nSelect second extension line origin : " pt1) 
  )
  (setvar "OSMODE" 0)
  (setq #pt3 (getpoint "\nExtension line origin location :")
        pt11 (list (car pt1) (cadr #pt3))
        pt22 (list (car pt2) (cadr #pt3))
  )
  (command "DIM1" "HOR" pt11 pt22)
  (setvar "OSMODE" OS)
)
(prompt "\n HH or HO to use new horizontal dim method")
(defun c:VV()
  (prompt "\nNew dim method. ")
  (setq OS (getvar "OSMODE"))
  (setq #DIM 2)
  (setq pt1 (getpoint "\nSelect first extension line origin : ")
        pt2 (getpoint "\nSelect second extension line origin : " pt1) 
  ) 
  (setvar "OSMODE" 0) 
  (setq #pt3 (getpoint "\nExtension line origin location :")
        pt11 (list (car #pt3) (cadr pt1))
        pt22 (list (car #pt3) (cadr pt2))
  )
  (command "DIM1" "VER" pt11 pt22)
  (setvar "OSMODE" OS) 
)
(prompt "\n VV or VE to use new vertical dim method")

(defun c:ALI( / pt1 pt2 pt3 pt4 pt5 pt11 dis )
   (prompt "\nNew dim method.")
   (setq #DIM 3)
   (setq pt1 (getpoint "\nSelect first extension line origin : ")
         pt2 (getpoint "\nSelect first extension line origin : " pt1)
         pt3 (getpoint "\nExtension line origin location : ")
         #A (angle pt1 pt2)
         pt4 (polar pt3 (+ #A 1.57076) 100)
         pt5 (inters pt1 pt2 pt3 pt4 seg)
         dis (distance pt3 pt5)
         pt11 (polar pt1 (+ #A 1.57076) dis)  
         #pt22 (polar pt2 (+ #A 1.57076) dis)  
   )
   (command "dim1" "ali" pt11 #pt22)
) 
(prompt "\n ALI to use new ALI dim method")

(defun c:con( / pt1 pt11 pt4 pt5 A dis pt11 pt22)
 (if (= #DIM 1)
   (progn
      (prompt "\nNew dim method.")
      (setq pt1 (getpoint "\nSelect next extension line origin : ")
            pt11 (list (car pt1) (cadr #pt3))
      )
      (command "DIM1" "CON" pt11)
   )
 )
 (if (= #DIM 2)
   (progn
     (prompt "\nNew dim method. ")
     (setq pt1 (getpoint "\nSelect next extension line origin : ")
           pt11 (list (car #pt3) (cadr pt1))
     )
     (command "DIM1" "CON" pt11)
   )
 )
 (if (= #DIM 3)
   (progn
     (prompt "\nNew dim method. ")
     (setq pt1 (getpoint "\nSelect next extension line origin : ")
           pt2 (polar #pt22 #A 100)
           pt3 (polar pt1 (+ #A 1.570796) 100)
           pt5 (inters #pt22 pt2 pt1 pt3 seg)
     )
     (command "dim1" "con" pt5)
   )
 )
)

		
		**** BLOCK******

;----------------------------------------------------------
(setq #Bacc 3)
;----------------------------------------------------------
(defun DXF (code elist)
     (cdr (assoc code elist))
)
;------------------------------------------------------------------
(defun USTR (bit msg def spflag / inp nval)
     (if (and def (/= def ""))
          (setq msg (strcat "\n" msg "<" def ">: ")
               inp (getstring spflag msg)
               inp (if (= inp "") def inp)
          )
          (progn
               (if (= " " (substr msg (strlen msg) 1))
                    (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
                    (setq msg (strcat "\n" msg ": "))
               )
               (if (= bit 1)
                    (while (= "" (setq inp (getstring spflag msg)))
                         (prompt "\nInvalid String.")
                    )
                    (setq inp (getstring spflag msg))
               )
          )
     )
     inp
)
;------------------------------------------------------------------
(defun b_get ( / ssl  nsset temp ed )
     (setq #sset (ssget))
     (setq ssl (sslength #sset) 
          nsset (ssadd)
     )
     (print ssl)
     (princ "entities found. ")  
     (princ "\nVerifying the selected entities -- please wait. ")
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl))))
               (setq ed (entget temp))
               (if (= (DXF 0 ed) "INSERT") (ssadd temp nsset))
          )
     )
     (setq ssl (sslength nsset)
          #sset nsset
     )
     (print ssl)
     (princ "INSERT entities found. ")
     (princ)
);defun b_ssget
;-----------------------------------------------------------------
(prompt "\n		BUP : Change INSERT entities to current scale")

(defun c:BUP( / ssl temp ed old new pt1 pt2 insert_pt oldscale ratio dist ang )
     (b_get)
     (if (= scale nil) (setq scale (getreal "\nInput current scale: ")))
     
     (setq ssl (sslength #sset))
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl)))
                    ed (entget temp)
                    insert_pt (dxf 10 ed)
                    
                    oldscale (dxf 41 ed) ; X_scale
                    ratio (/ scale (abs oldscale))
                    old (cons 41 (DXF 41 ed))
                    new (cons 41 (* ratio oldscale))
                    ed (subst new old ed)
                    oldscale (dxf 42 ed) ; Y_scale
                    ratio (/ scale (abs oldscale))
                    old (cons 42 (DXF 42 ed))
                    new (cons 42 (* ratio oldscale))
                    ed (subst new old ed)
                    oldscale (dxf 43 ed) ; Z_scale
                    ratio (/ scale (abs oldscale))
                    old (cons 43 (DXF 43 ed))
                    new (cons 43 (* ratio oldscale))
                    ed (subst new old ed)
               )
               (entmod ed)  
               (setq temp (entnext temp))
               
               (if (/= temp nil)
                    (progn
                         (setq ed (entget temp)
                              pt1 (dxf 10 ed)
                              pt2 (dxf 11 ed)
                         )
                         (setq TXTName (DXF 7 ed))
                         (if (OR (= TXTName "5") (= TXTName "5T"))
                              (setq  old (cons 40 (DXF 40 ed))
                                          new (cons 40 (* scale 4))
                                          ed (subst new old ed)
                                          ratio (/ scale (abs oldscale))
                               )
                              (setq  old (cons 40 (DXF 40 ed))
                                          new (cons 40 (* scale 2))
                                          ed (subst new old ed)
                                          ratio (/ scale (abs oldscale))
                               )
                          )
                          (setq  dist (distance insert_pt pt1)
                              ang (angle insert_pt pt1)
                              pt1 (polar insert_pt ang (* dist ratio))
                              dist (distance insert_pt pt2)
                              ang (angle insert_pt pt2)
                              pt2 (polar insert_pt ang (* dist ratio))
                              
                              old (cons 10 (DXF 10 ed))
                              new (cons 10 pt1)
                              ed (subst new old ed)
                              
                              old (cons 11 (DXF 11 ed))
                              new (cons 11 pt2)
                              ed (subst new old ed)
                         ); setq
                         (entmod ed)  
                         (entupd temp)
                    )
               )
          )
     )
     (princ)
);defun
;-----------------------------------------------------------------
(prompt "\n		CDU : Change CD BLOCK to current height")

(defun c:CDU( / ssl temp ed old new  insert_pt y )
     (prompt (strcat "\nYOUR CURRENT  'U C S' IS : " (getvar "UCSNAME") "\n"))
     (b_get)
     (if (= scale nil) (setq scale (getreal "\nInput current scale: ")))
     
     (setq DZ (getvar "DIMZIN"))
     (setvar "DIMZIN" 0)
     
     (setq ssl (sslength #sset))
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl)))
                    ed (entget temp)
                    insert_pt (dxf 10 ed)
                    bname (dxf 2 ed)
               )
               (if (OR (= bname "CD") (= bname "CD1") (= bname "CD2") (= bname "CD3"))
                    (progn
                         (setq temp (entnext temp)
                              ed (entget temp)
                              y (/ (cadr (trans insert_pt 0 1)) 100)
                         )
                         (cond
                              ((> y 0) (setq y (strcat "+" (rtos y 2 #Bacc))))
                              ((< y 0) (setq y (rtos y 2 #Bacc)))
                              ((= y 0) (setq y "%%p0.00"))
                         )
                         (setq old (cons 1 (DXF 1 ed))
                              new (cons 1 y)
                              ed (subst new old ed)
                         ); setq
                         (entmod ed)  
                         (entupd temp)
                    )
               )
          )
     )
     (princ)
     (setvar "DIMZIN" DZ)
);defun
;-----------------------------------------------------------------
(prompt "\n		CD : To insert a CD block")
(defun c:cd ( / DZ pt y ptside ang OT)
     (if (= scale nil)  (setq scale (getreal "\nInput current scale: ")))
;     (if (= #Bacc nil) (setq #Bacc (getint "\nInput accuracy: ")))
     (setq DZ (getvar "DIMZIN"))
     (setvar "DIMZIN" 0)
     (setq OT (getvar "ORTHOMODE"))
     (setvar "ORTHOMODE" 0)
     (setq pt (getpoint "\nPick Insertion Point")
     		 ptside (getpoint "\nPick Side Point" pt)
		 ang (angle pt ptside)
     )

     (setq y (/ (cadr pt) 1000.0))
     (cond
          ((> y 0) (setq y (strcat "+" (rtos y 2 #Bacc))))
          ((< y 0) (setq y (rtos y 2 #Bacc)))
          ((= y 0) (setq y "%%p0.00"))
     )
     (setq y (ustr 0 "Input elevation: " y T))
     ( if	 (AND (>= ang 0) (< ang 1.5708)) (command "INSERT" "CD" pt scale scale "0" y))
     ( if	 (AND (>= ang 1.5708) (< ang 3.1416)) (command "INSERT" "CD3" pt scale scale "0" y))
     ( if	 (AND (>= ang 3.1416) (< ang 4.7124)) (command "INSERT" "CD2" pt scale scale "0" y))
     ( if	 (AND (>= ang 4.7124) (< ang 6.2832)) (command "INSERT" "CD1" pt scale scale "0" y))
     (setvar "DIMZIN" DZ)
     (setvar "ORTHOMODE" OT)

)
;---------------------------------------------------------------------------
(prompt "\n		MC : To insert MC block")
(defun c:MC (/ pt1 pt2 ptside ang1 ang2)
  (if (= scale nil)
    (setq scale (getreal "/nInput current scale: "))
  )
  (if (= #MC nil)
    (setq #MC "A")
  )
  (setq	pt1  (getpoint "\nPick the first point: ")
	pt2  (getpoint "\nPick the second point: " pt1)
	#MC  (ustr 0 "Section name " #MC T)
	ang1 (/ (* (angle pt1 pt2) 180) PI)
  )
  (if (> ang1 180)
    (setq ang2 (- (- ang1 180) 90))
    (setq ang2 (- ang1 90))
  )
  (if (> ang1 180)
    (progn
      (command "INSERT" "Mc" pt1 scale scale ang2 #MC)
      (command "INSERT" "Mc" pt2 scale scale ang2 #MC)
      (setq #MC (chr (+ (ascii #MC) 1)))
    )
    (progn
      (command "INSERT" "Mc1" pt1 scale scale ang2 #MC)
      (command "INSERT" "Mc1" pt2 scale scale ang2 #MC)
      (setq #MC (chr (+ (ascii #MC) 1)))
    )
  )
)
;---------------------------------------------------------------------------
(prompt "\n		DD : To insert a DDOC block")
(defun c:DD ( / OS DZ pt1 pt2 pt x1 x2 y1 y2 y i ang )
     (if (= scale nil)
          (progn
               (setq scale (getreal "\nInput current scale: "))
          )
     )
     (setq DZ (getvar "DIMZIN"))
     (setvar "DIMZIN" 0)
     (setq pt1 (getpoint "\nPick 1st point"))
     (setq pt2 (getpoint "\nPick 2nd point" pt1))
     (setq x1 (car pt1)
          y1 (cadr pt1)
          x2 (car pt2)
          y2 (cadr pt2)
          x (/ (+ x1 x2) 2)
          y (/ (+ y1 y2) 2)
          y (+ y (* 1.5 scale))
          pt (list x y)
     )
     (setq OS (getvar "OSMODE"))
     (setvar "OSMODE" 0)
     (if (> x2 x1)
          (progn
               (setq i (* (/ (- y1 y2) (- x2 x1)) 100)
                    i (strcat (rtos i 2 2) "%")
                    i (ustr 0 "Input i%: " i T)
                    ang (/ (* (angle pt1 pt2) 180) pi)
               )
               (command "INSERT" "ddoc" pt scale scale ang i)
          )
          (progn
               (setq i (* (/ (- y1 y2) (- x1 x2)) 100)
                    i (strcat (rtos i 2 2) "%")
                    i (ustr 0 "Input i%: " i T)
                    ang (/ (* (angle pt2 pt1) 180) pi)
               )
               (command "INSERT" "ddoc1" pt scale scale ang i)
          )
     )
     (setvar "DIMZIN" DZ)
     (setvar "OSMODE" OS)
)
(princ)
;---------------------------------------------------------------------------
   	


(defun UDIST (bit kwd msg def bpt / inp)
  (if def
    (setq msg (strcat "\n" msg "<" (rtos def) ">: ")
          bit (* 2 (fix (/ bit 2)))
    )
    (if (= " " (substr msg (strlen msg) 1)) 
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
      (setq msg (strcat "\n" msg ": "))
    )
  )
  (initget bit kwd)
  (setq inp
    (if bpt
      (getdist msg bpt)
      (getdist msg)
    )
  )
  (if inp inp def)
)
;---------------------------------------------------------------
(defun DXF (code elist)
  (cdr (assoc code elist))
)
;---------------------------------------------------------------
(defun u_ssget ( / ssl  nsset temp ed ) ; Get LINE & POLYLINE only
  (setq sset (ssget))
  (setq ssl (sslength sset) 
        nsset (ssadd)
  )
  (print ssl) (princ "entities found. ")  
  (princ "\nVerifying the selected entities -- please wait. ")
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
      (if (OR (= (DXF 0 ed) "LINE") (= (DXF 0 ed) "POLYLINE") (= (DXF 0 ed) "LWPOLYLINE") ) 
        (ssadd temp nsset)
      )
    )
  )
  (setq ssl (sslength nsset)
        sset nsset
  )
  (print ssl) (princ "LINE, POLYLINE, LWPOLYLINE entities found. ")
  (princ)
);defun u_ssget
;---------------------------------------------------------------
(defun draw ( pt1 pt2 ) // For LINE
  (setq #OSMODE (getvar "OSMODE"))
  (setvar "OSMODE" 0)
  (setq x1 (car pt1)
        y1 (cadr pt1)
        a (angle pt1 pt2)
        dist (distance pt1 pt2)
  )
  (if (< dist #DL) (setq dist #DL))
  (setq times (fix (/ dist #DL))
        dl (/ dist times)
        dx (* dl (cos a))
        dy (* dl (sin a))
  );setq

  (while (> times 0)
    (setq times (1- times)
          x (+ x1 (* times dx))
          y (+ y1 (* times dy))
          p1 (list x y)
          p2 (polar p1 (+ a (/ PI 2)) #L1)
          p3 (list (+ x (/ dx 2)) (+ y (/ dy 2)))
          p4 (polar p3 (+ a (/ PI 2)) #L2)
    );setq      
    (command "LINE" p1 p2 "")
    (command "LINE" p3 p4 "")
  );while
  (setvar "OSMODE" #OSMODE)
);defun draw
;---------------------------------------------------------------

(prompt "\nTL1: draw taluy symbol for straigth line")
(defun c:TL1( )
 (prompt "\nTaluy symbol...")
 ( u_ssget )
 (setq ssl (sslength sset)
       side (getstring "\nSide <L/R>")
       #L1 (abs (UDIST 0 "" "L1= " #L1 nil))
       #L2 (abs (UDIST 0 "" "L2= " #L2 nil))
       #DL (abs (UDIST 0 "" "Interval :" #DL nil))
 );setq

 (while (> ssl 0)
  (progn
    (setq temp (ssname sset (setq ssl (1- ssl))))
    (setq ed (entget temp))
;---------------
    (if (= (DXF 0 ed) "LINE")
      (progn
         (if (< (nth 1 (nth 7 ed)) (nth 1 (nth 8 ed)))
            (setq pt1 (list (nth 1 (nth 7 ed)) (nth 2 (nth 7 ed)))      
                  pt2 (list (nth 1 (nth 8 ed)) (nth 2 (nth 8 ed))))         
            (setq pt2 (list (nth 1 (nth 7 ed)) (nth 2 (nth 7 ed)))      
                  pt1 (list (nth 1 (nth 8 ed)) (nth 2 (nth 8 ed))))         
         )    
         (if (OR (= side "L") (= side "l"))
            (draw pt1 pt2) 
            (draw pt2 pt1)
         )
      );progn if
    );if LINE
;---------------
    (if (= (DXF 0 ed) "POLYLINE")
      (progn       
        (setq en (entnext en)
              en1 (entnext en))

        (while (AND (/= (DXF 0 (entget en1)) "SEQEND") (/= (DXF (entget en1)) 16))
          (progn
            (setq ed (entget en)
                  ed1 (entget en1))
            (if (<  (nth 1 (nth 8 ed)) (nth 1 (nth 8 ed1)))
              (setq pt (list (nth 1 (nth 8 ed)) (nth 2 (nth 8 ed)))
                    pt1 (list (nth 1 (nth 8 ed1)) (nth 2 (nth 8 ed1))))
              (setq pt1 (list (nth 1 (nth 8 ed)) (nth 2 (nth 8 ed)))
                    pt (list (nth 1 (nth 8 ed1)) (nth 2 (nth 8 ed1))))
            )
            (if (OR (= side "L") (= side "l"))
               (draw pt pt1) 
               (draw pt1 pt)
            )
            (setq en en1
                  en1 (entnext en))
          );progn while
        );while
      );progn if

    );if POLYLINE  
;---------------
    (if (= (DXF 0 ed) "LWPOLYLINE")
      (progn
         (setq no_vertex (DXF 90 ed))

         (while (> no_vertex 1)
            (progn
               (setq no_vertex (- no_vertex 1)
                     d1 (nth (+ 12 (* 4 no_vertex)) ed)   
                     d2 (nth (+ 12 (* 4 (- no_vertex 1))) ed)   
               )
               (if (< (nth 1 d1) (nth 1 d2))
                  (setq pt1 (list (nth 1 d1) (nth 2 d1))
                        pt2 (list (nth 1 d2) (nth 2 d2)))
                  (setq pt2 (list (nth 1 d1) (nth 2 d1))
                        pt1 (list (nth 1 d2) (nth 2 d2)))
               )
               (if (OR (= side "L") (= side "l"))
                  (draw pt1 pt2) 
                  (draw pt2 pt1)
               )
            );progn while
         );while
      );progn if
    );if LWPOLYLINE
;---------------
  );progn while
 );while
) ; Defun taluy()

;---------------------------------------------------------------

(prompt "\nTL2: draw taluy symbol for curved line")

(defun c:TL2 ( / pt1 pt2 cen side ) ; For CIRCLE

  (setq pt1 (getpoint "\nNhap PT1 ")
        pt2 (getpoint "\nNhap PT2 ")
        cen (getpoint "\nNhap CEN ")
        side (getint "\nNhap side (1=Huong tam) ")
        #L1 (abs (UDIST 0 "" "L1= " #L1 nil))
        #L2 (abs (UDIST 0 "" "L2= " #L2 nil))
        #DL (abs (UDIST 0 "" "Interval :" #DL nil))
  )

  (setq #OSMODE (getvar "OSMODE"))
  (setvar "OSMODE" 0)

  (setq R (SQRT (+ (EXPT (- (car pt1) (car cen)) 2) (EXPT (- (cadr pt1) (cadr cen)) 2)))
        A (abs (- (angle cen pt1) (angle cen pt2))) 
        dist (* A R)
        times (fix (/ dist #DL))
        dA (/ A times) 
  );setq
  
  (command "UCS" "3p" cen pt1 pt2)

  (while (> times 0)
    (setq times (1- times)
          p1 (polar '(0 0) (* dA times) R)
          p3 (polar '(0 0) (+ (* dA times) (/ dA 2)) R)
          p2 (polar '(0 0) (* dA times) (if (= side 1) (- R #L1) (+ R #L1)))
          p4 (polar '(0 0) (+ (* dA times) (/ dA 2)) (if (= side 1) (- R #L2) (+ R #L2)))
    );setq      
    (command "LINE" p1 p2 "")
    (command "LINE" p3 p4 "")
  );while
  (setvar "OSMODE" #OSMODE)
  (command "UCS" "W")  

);defun TL2


		******* UTILITIES ***********

;------------------------------------------------------------------
(defun UKWORD (bit kwd msg def / inp)
     (if (and def (/= def ""))
          (setq msg (strcat "\n" msg "<" def ">: ")
               bit (* 2 (fix (/ bit 2)))
          )
          (if (= " " (substr msg (strlen msg) 1))
               (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
               (setq msg (strcat "\n" msg ": "))
          )
     )
     (initget bit kwd)
     (setq inp (getkword msg))
     (if inp inp def)
)
;------------------------------------------------------------------
(defun USTR (bit msg def spflag / inp nval)
     (if (and def (/= def ""))
          (setq msg (strcat "\n" msg "<" def ">: ")
               inp (getstring spflag msg)
               inp (if (= inp "") def inp)
          )
          (progn
               (if (= " " (substr msg (strlen msg) 1))
                    (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
                    (setq msg (strcat "\n" msg ": "))
               )
               (if (= bit 1)
                    (while (= "" (setq inp (getstring spflag msg)))
                         (prompt "\nInvalid String.")
                    )
                    (setq inp (getstring spflag msg))
               )
          )
     )
     inp
)
;------------------------------------------------------------------
(defun ETOS (arg / file)
     (if (= 'STR (type arg)) (setq arg (strcat "\"" arg "\"")))
     (setq file (open "TL" "w"))
     (princ arg file)
     (close file)
     (setq file (open "TL" "r"))
     (setq arg (read-line file))
     (close file)
     (close (open "TL" "w"))
     arg
)  
;------------------------------------------------------------------
(defun DXF (code elist)
     (cdr (assoc code elist))
)
;-------------------------------------------------------------
(defun Text_get ( / ssl  nsset temp ed )
     (setq #sset (ssget))
     (setq ssl (sslength #sset) 
           nsset (ssadd)
     )
     (print ssl)
     (princ "entities found. ")  
     (princ "\nVerifying the selected entities -- please wait. ")
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl))))
               (setq ed (entget temp))
               (if (= (DXF 0 ed) "TEXT") (ssadd temp nsset))
          )
     )
     (setq ssl (sslength nsset)
          #sset nsset
     )
     (print ssl)
     (princ "TEXT entities found. ")
     (princ)
);defun Text_get
;-------------------------------------------------------------
(prompt "\n		CT4, CT2, CT5, TUP : To change TEXT to style 2,4 or 5")

(defun c:CT2( / ssl temp new old ed )
     (Text_get)
     (if (= scale nil) (setq scale (getreal "\nInput current scale : ")))
     (setq ssl (sslength #sset))
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl)))
                    ed (entget temp)
                    old (cons 40 (DXF 40 ed))
                    size (* 2 scale)
                    new (cons 40 size)
                    ed (subst new old ed)
                    
                    old (cons 7 (DXF 7 ed))
                    new (cons 7 "2")
                    ed (subst new old ed)

                    old (cons 41 (DXF 41 ed))
                    new (cons 41 0.8)
                    ed (subst new old ed)
               )
               (entmod ed)  
          )
     )
     (princ)
);defun
;-------------------------------------------------------------

(defun c:CT5( / ssl temp new old ed )
     (Text_get)
     (if (= scale nil) (setq scale (getreal "\nInput current scale : ")))
     (setq ssl (sslength #sset))
     
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl)))
                    ed (entget temp)
                    old (cons 40 (DXF 40 ed))
                    size (* 5 scale)
                    new (cons 40 size)
                    ed (subst new old ed)
                    
                    old (cons 7 (DXF 7 ed))
                    new (cons 7 "5")
                    ed (subst new old ed)

                    old (cons 41 (DXF 41 ed))
                    new (cons 41 0.9)
                    ed (subst new old ed)

               )
               (entmod ed)  
          )
     )
     (princ)
);defun
;-------------------------------------------------------------------
(defun c:CT4( / ssl temp new old ed )
     (Text_get)
     (if (= scale nil) (setq scale (getreal "\NHAP VAO TY LE: ")))
     (setq ssl (sslength #sset))
     
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl)))
                    ed (entget temp)
                    old (cons 40 (DXF 40 ed))
                    size (* 4 scale)
                    new (cons 40 size)
                    ed (subst new old ed)
                    
                    old (cons 7 (DXF 7 ed))
                    new (cons 7 "4")
                    ed (subst new old ed)

                    old (cons 41 (DXF 41 ed))
                    new (cons 41 0.8)
                    ed (subst new old ed)

               )
               (entmod ed)  
          )
     )
     (princ)
);defun
(defun c:TUP( / ssl temp ed old new )
     (Text_get)
     (if (= scale nil) (setq scale (getreal "\nInput current scale : ")))
     (setq ssl (sslength #sset))
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl))))
               
               (setq ed (entget temp))
               (setq STYLE (DXF 7 ed))
               
               (if (OR  (= STYLE "5") (= STYLE "5T"))
                    (progn
                         (setq old (cons 40 (DXF 40 ed))
                              size (* 5 scale)
                              new (cons 40 size)
                              ed (subst new old ed)
                         )
                    )
               )  
               (if (OR (= STYLE "2") (= STYLE "22") (= STYLE "2D"))
                    (progn
                         (setq old (cons 40 (DXF 40 ed))
                              size (* 2 scale)
                              new (cons 40 size)
                              ed (subst new old ed)
	                      old (cons 41 (DXF 41 ed))
                	      new (cons 41 0.8)
	                      ed (subst new old ed)
                         )
                    )
               )  
               (entmod ed) 
          )
     )
     (princ)
);defun
;-------------------------------------------------------------------
(prompt "\n		ChCase: Change case")
(defun c:chcase ( / code ssl)
     (Text_get)
     (setq code (getint "\nCode <BK1=2/VNI=3>: "))
     (setq ssl (sslength #sset))
     
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl)))
                    ed (entget temp)
                    old (cons 1 (DXF 1 ed))
                    #txt (DXF 1 ed)
               )
               ( ChangeCase Code)
               (setq new (cons 1 #txt)
                    ed (subst new old ed)
               )
          )
          (entmod ed)  
     )
     (princ)
);defun
;-------------------------------------------------------------------

(defun ChangeCase ( code )
     (setq txt1 "")
     (setq len (strlen #txt))
     (setq i 1)
     (if (= Code 3);   VNI
          (progn
               (repeat len
                    (setq char (substr #txt i 1))
                    (if (OR (AND  (> (ascii char) 96) (< (ascii char) 123)) (AND (> (ascii char) 223) (< (ascii char) 253)) ) 
                                    (setq char (chr (- (ascii char) 32)))
                    )
                    (setq txt1 (strcat txt1 char))
                    (setq i (+ i 1))
              );repeat
         );progn
     );if
     (if (= Code 2);   BK1
          (progn
               (repeat len
                    (setq char (substr #txt i 1))
                    ( cond
                         ((AND  (> (ascii char) 96) (< (ascii char) 123)) (setq char (chr (- (ascii char) 32))))
                         ((= (ascii char) 222) (setq char (chr 126)))
                         ((= (ascii char) 189) (setq char (chr 125)))
                         ((= (ascii char) 251) (setq char (chr 123)))
                         ((= (ascii char) 252) (setq char (chr 94)))
                         ((= (ascii char) 253) (setq char (chr 96)))
                         ((= (ascii char) 254) (setq char (chr 124)))
                         ((= (ascii char) 255) (setq char (chr 127)))
                         ((> (ascii char) 188) (setq char (chr (- (ascii char) 62))))
                    );cond
                    (setq txt1 (strcat txt1 char))
                    (setq i (+ i 1))
              );repeat
         );progn
     );if
     (setq #txt txt1) 
);defun
;-------------------------------------------------------------------
(load "ch_code.lsp")
;-------------------------------------------------------------------
(prompt "\n		ATXT: Add something in front of text ")
(defun c:atxt ( / ssl ed No new temp old )
  (Text_get)
  (setq str (getstring "\nAdd what: "))
  (setq ssl (sslength #sset))

  (while (> ssl 0)
    (progn
      (setq temp (ssname #sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
      (setq old (cons 1 (DXF 1 ed)))
      (setq No (DXF 1 ed))
      (setq No (strcat str No))
      (setq new (cons 1 No))
      (setq ed (subst new old ed))
      (entmod ed)  
    )
  )
)
;-----------------------------------------------------------

(prompt "\n		CHNO to +-*/ text entities with a number")
(defun c:CHNO ( / No temp ed old new acc fac operator ssl )
  (Text_get)
  (setq operator (getstring "\nInput operator (+ - * /):"))
  (setq fac (getreal "\nInput a number:"))
  (setq acc (getint "\nAccuracy:"))
  (setq DZ (getvar "DIMZIN"))
  (setvar "DIMZIN" 0)
  (setq ssl (sslength #sset))

  (while (> ssl 0)
    (progn
      (setq temp (ssname #sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
      (setq old (cons 1 (DXF 1 ed)))

      (setq No (atof (DXF 1 ed)))
      (cond
         ((= operator "+") (setq No (+ No fac)))
         ((= operator "-") (setq No (- No fac)))
         ((= operator "*") (setq No (* No fac)))
         ((= operator "/") (setq No (/ No fac)))
      )
      (setq new (cons 1 (rtos No 2 acc)))
     
      (setq ed (subst new old ed))
      (entmod ed)  
    )
  )
(setvar "DIMZIN" DZ)
)
;-----------------------------------------------------------

************ DRAW UTILITIES ***************



(prompt "\n CAD Utilities For Release 14 ( AI CUNG CO THE VIET)   ")
(princ)
