(prompt "\nL O A D I N G    A C A D . L S P   (VERSION 2000)")

(setvar "CMDECHO" 0)

(defun c:ccl ()
(setq a (getint "\n For Doing, For Plotting <1/0>"))
(if (= a 0)
  (command "-layer" 
          "c" 3 "0"
          "c" 2 "1"
          "c" 1 "2"
          "c" 5 "3"
          "c" 2 "4"
          "c" 2 "5"
	  ""
  )
  (command "-layer" 
          "c" 7 "0"
          "c" 1 "1"
          "c" 5 "2"
          "c" 3 "3"
          "c" 4 "4"
          "c" 6 "5"
	  ""
  )
)
)

(defun c:acc ()
(setq #acc (getint "\nDo Chinh Xac: "))
(setvar "DIMDEC" #ACC))

(SETQ #ACC 1)

(defun c:DWG ()
(setq pt (getpoint "\nPick point :"))
(setq name (getvar "DWGNAME"))
(command "TEXT" "J" "MC" pt "0" name)
)

(defun c:LTS()
(command "LTSCALE"))

(defun c:3p()
(command "UCS" "3p"))

(DEFUN C:WW() 
(COMMAND "ucs" "W"))

(DEFUN C:OO() 
(SETQ PT (GETPOINT "\nPICK (0,0) POINT"))
(COMMAND "ucs" "O" PT))

(DEFUN C:PU() 
(COMMAND "PURGE" "A" "" "N"))

(defun c:CHT()
(LOAD "chtext.lsp"))

(defun c:ACAD()
(LOAD "ACAD.LSP"))

(defun c:uti()
(load "Draw_uti.lsp"))

(defun c:T2() (setvar "TEXTSTYLE" "2")
(command "DTEXT"))

(defun c:T5() (setvar "TEXTSTYLE" "5")
(command "DTEXT"))

(DEFUN C:CP() (COMMAND "COPY"))

(defun c:IN() (setvar "OSMODE" 32))
(defun c:MID() (setvar "OSMODE" 2))
(defun c:EN() (setvar "OSMODE" 1))
(defun c:CEN() (setvar "OSMODE" 4))
(defun c:NO() (setvar "OSMODE" 0))

(defun c:non() (setvar "OSMODE" 0))
(defun c:endp() (setvar "OSMODE" 1))
(defun c:qua() (setvar "OSMODE" 16))
(defun c:tan() (setvar "OSMODE" 256))
(defun c:per() (setvar "OSMODE" 128))
(defun c:ins() (setvar "OSMODE" 64))
(defun c:nod() (setvar "OSMODE" 8))
(defun c:nea() (setvar "OSMODE" 512))
(defun c:int() (setvar "OSMODE" 32))
(defun c:appint() (setvar "OSMODE" 2048))

(defun c:0() (command "LAYER" "T" "0" "S" "0" ""))
(defun c:1() (command "LAYER" "T" "1" "S" "1" ""))
(defun c:2() (command "LAYER" "T" "2" "S" "2" ""))
(defun c:3() (command "LAYER" "T" "3" "S" "3" ""))
(defun c:4() (command "LAYER" "T" "4" "S" "4" ""))
(defun c:5() (command "LAYER" "T" "5" "S" "5" ""))
(defun c:6() (command "LAYER" "T" "6" "S" "6" ""))
(defun c:7() (command "LAYER" "T" "7" "S" "7" ""))
(defun c:8() (command "LAYER" "T" "8" "S" "8" ""))
(defun c:9() (command "LAYER" "T" "9" "S" "9" ""))

(defun c:c0() (ssget) (command ".chprop" "p" "" "la" "0" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c1() (ssget) (command ".chprop" "p" "" "la" "1" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c2() (ssget) (command ".chprop" "p" "" "la" "2" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c3() (ssget) (command ".chprop" "p" "" "la" "3" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c4() (ssget) (command ".chprop" "p" "" "la" "4" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c5() (ssget) (command ".chprop" "p" "" "la" "5" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c6() (ssget) (command ".chprop" "p" "" "la" "6" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c7() (ssget) (command ".chprop" "p" "" "la" "7" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c8() (ssget) (command ".chprop" "p" "" "la" "8" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c9() (ssget) (command ".chprop" "p" "" "la" "9" "LT" "BYLAYER" "C" "BYLAYER" ""))

(defun c:f0() (command "LAYER" "F" "0" ""))
(defun c:f1() (command "LAYER" "F" "1" ""))
(defun c:f2() (command "LAYER" "F" "2" ""))
(defun c:f3() (command "LAYER" "F" "3" ""))
(defun c:f4() (command "LAYER" "F" "4" ""))
(defun c:f5() (command "LAYER" "F" "5" ""))
(defun c:f6() (command "LAYER" "F" "6" ""))
(defun c:f7() (command "LAYER" "F" "7" ""))
(defun c:f8() (command "LAYER" "F" "8" ""))
(defun c:f9() (command "LAYER" "F" "9" ""))


(defun c:E() (command "ERASE"))
(defun c:EL() (command "ELLIPSE"))
(defun c:M() (command "MOVE"))
(defun c:L() (command "LINE"))
(defun c:PL() (command "PLINE"))
(defun c:R() (command "REDRAW"))
(defun c:A() (command "ARC"))
(defun c:CI() (command "CIRCLE"))
(defun c:C() (command "COPY"))
(defun c:PT() (command "POINT"))
(defun c:SC() (command "SCALE"))
(defun c:DT() (command "DTEXT"))
(defun c:MV() (command "MVIEW"))
(defun c:D() (command "DONUT"))
(defun c:SA() (command "QSAVE"))
(defun c:RE() (command "REGEN"))
(defun c:RO() (command "ROTATE"))
(defun c:REC() (command "RECTANG"))
(defun c:PE() (command "PEDIT"))
(defun c:QS() (command "PSPACE"))
(defun c:AS() (command "MSPACE"))
(defun c:O() (command "OFFSET"))
(defun c:CHR() (command "CHAMFER"))
(defun c:T() (command "TRIM"))
(defun c:F() (command "FILLET"))
(defun c:MI() (command "MIRROR"))
(defun c:ZA() (command "ZOOM" "A"))
(defun c:ZE() (command ".ZOOM" "E"))
(defun c:Z1() (command ".ZOOM" "0.5x"))
(defun c:ZW() (command "ZOOM" "W"))
(defun c:ZQ() (command "ZOOM" "P"))
(defun c:ZD() (command "ZOOM" "D"))
(defun c:CH() (command "CHANGE"))
(defun c:CHP() (command "CHPROP"))
(defun c:XP() (command "EXPLODE"))
(defun c:LI() (command "LIST"))
(defun c:DI() (command "DIST"))
(defun c:AR() (command "ARRAY"))
(defun c:II() (c:DDINSERT))
(defun c:I() (command "INSERT"))
(defun c:B() (command "BLOCK"))
(defun c:WB() (command "WBLOCK"))
(defun c:VP() (command "VPOINT" "R"))
(defun c:X() (command "EXTEND"))
(defun c:S() (command "STRETCH" "C"))
(defun c:TM( / TILE)
 (setq TILE (getvar "TILEMODE")) 
 (if (= TILE 0)
    (progn
      (setvar "TILEMODE" 1)
    )      
    (progn
      (setvar "TILEMODE" 0)
    )
 );if
)
(defun c:ED() (command "DDEDIT"))
(defun c:UP() (command "DIM1" "UP"))
(defun c:DED() (command "DIM1" "NEW"))
(defun c:DM() (command "dim1" "tedit"))
(defun c:EDD() (COMMAND "DDATTE"))
(defun c:MO() (command "PROPERTIES"))
(defun c:A1() (command "PLINE" "0,0" "817,0" "817,570" "0,570" "c"))
(defun c:A2() (command "PLINE" "0,0" "570,0" "570,396" "0,396" "c"))
(defun c:A3() (command "PLINE" "0,0" "396,0" "396,273" "0,273" "c"))
(defun c:A4() (command "PLINE" "0,0" "198,0" "198,285" "0,285" "c"))

(princ)
