(setvar "CMDECHO" 0)

(defun c:PP()
(command "PURGE" "A" "" "N"))

(defun c:3p()
(command "UCS" "3p"))

(DEFUN C:W() 
(COMMAND "ucs" "W"))

(DEFUN C:OO( / PT)
(SETQ PT (GETPOINT "\nINPUT POINT ")) 
(COMMAND "ucs" "O" PT))

(defun c:TUP()
(LOAD "C:\\PROGRAM FILES\\AUTOCAD R14\\SUPPORT\\TEXT-UP.lsp"))

(defun c:TXT()
(LOAD "C:\\PROGRAM FILES\\AUTOCAD R14\\SUPPORT\\ED-TEXT.lsp"))


(defun c:CHT()
(LOAD "C:\\PROGRAM FILES\\AUTOCAD R14\\BONUS\\CADTOOLS\\CHTEXT"))

(defun c:uti()
(load "C:\\PROGRAM FILES\\AUTOCAD R14\\SUPPORT\\uti.lsp"))
(defun c:b-uti()
(load "C:\\PROGRAM FILES\\AUTOCAD R14\\SUPPORT\\b-uti.lsp"))
(defun c:Tt()
(defun c:blo()
(load "C:\\PROGRAM FILES\\AUTOCAD R14\\SUPPORT\\block.lsp"))
  (setvar "REGENMODE" 0)
  (setq SCALE (getreal "Input current scale : "))
  (setvar "DIMCLRE" 2)      ;Color
  (setvar "DIMCLRD" 2)      ;Color
  (setvar "DIMCLRT" 2)      ;Color
  (setvar "DIMZIN" 8)       ;Trailing


  (command "STYLE" "5" "VHELVEN.ttf" (* 5 SCALE) "0.9" "0" "N" "N")
  (command "STYLE" "2" "vn_vni" (* 1.8 SCALE) "0.8" "0" "N" "N" "N")
  (command "STYLE" "4" "VN_VNI" (* 3.6 SCALE) "0.8" "0" "N" "N" "N")


  (setvar "DIMEXE" SCALE)             ;Extension above line
  (setvar "DIMEXO" 0)                 ;Feature offset
  (setvar "DIMASZ" 0)                 ;Arrow size 
  (setvar "DIMSE1" 0)                 ;suppress
  (setvar "DIMSE2" 0)                 ;suppress
  (setvar "DIMZIN" 8)                 ;trailing
  (setvar "DIMTSZ" (* 0.75 SCALE))     ;Tick size 
  (setvar "DIMDLE" SCALE)             ;Tick extension 
  (setvar "DIMTXT" (* 1.8 SCALE))       ;Text height
  (setvar "DIMTAD" 1)                 ;Verical (defauft)
  (setvar "DIMTIH" 0)                 ;Horizontal
  (setvar "DIMTOH" 0)                 ;Horizontal
  (setvar "DIMTIX" 1)                 ;Force text inside   
  (setvar "DIMSOXD" 0)                ;Force text inside
  (setvar "DIMSE1" 0)
  (setvar "DIMSE2" 0) 
  (setvar "DIMGAP" SCALE)
  (setvar "DIMTXSTY" "2")
  (setvar "REGENMODE" 1)
)


(defun c:T4() (setvar "TEXTSTYLE" "4")
(command "DTEXT")
)

(defun c:T2() (setvar "TEXTSTYLE" "2")
(command "DTEXT")
)

(defun c:T5() (setvar "TEXTSTYLE" "5")
(command "DTEXT")
)




(DEFUN C:C() (COMMAND "COPY"))

(defun c:0() (command "LAYER" "T" "0" "S" "0" ""))
(defun c:1() (command "LAYER" "T" "1" "S" "1" ""))
(defun c:2() (command "LAYER" "T" "2" "S" "2" ""))
(defun c:3() (command "LAYER" "T" "3" "S" "3" ""))
(defun c:4() (command "LAYER" "T" "4" "S" "4" ""))
(defun c:5() (command "LAYER" "T" "5" "S" "5" ""))
(defun c:6() (command "LAYER" "T" "6" "S" "6" ""))
(defun c:7() (command "LAYER" "T" "7" "S" "7" ""))
(defun c:8() (command "LAYER" "T" "8" "S" "8" ""))
(defun c:9() (command "LAYER" "T" "9" "S" "9" ""))

(defun c:c0() (SSGET) (command "select" pause) (command ".chprop" "p" "" "la" "0" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c1() (SSGET) (command "select" pause) (command ".chprop" "p" "" "la" "1" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c2() (SSGET) (command "select" pause) (command ".chprop" "p" "" "la" "2" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c3() (SSGET) (command "select" pause) (command ".chprop" "p" "" "la" "3" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c4() (SSGET) (command "select" pause) (command ".chprop" "p" "" "la" "4" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c5() (SSGET) (command "select" pause) (command ".chprop" "p" "" "la" "5" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c6() (SSGET) (command "select" pause) (command ".chprop" "p" "" "la" "6" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c7() (SSGET) (command "select" pause) (command ".chprop" "p" "" "la" "7" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c8() (SSGET) (command "select" pause) (command ".chprop" "p" "" "la" "8" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c9() (SSGET) (command "select" pause) (command ".chprop" "p" "" "la" "9" "LT" "BYLAYER" "C" "BYLAYER" ""))

(defun c:f0() (command "LAYER" "F" "0" ""))
(defun c:f1() (command "LAYER" "F" "1" ""))
(defun c:f2() (command "LAYER" "F" "2" ""))
(defun c:f3() (command "LAYER" "F" "3" ""))
(defun c:f4() (command "LAYER" "F" "4" ""))
(defun c:f5() (command "LAYER" "F" "5" ""))
(defun c:f6() (command "LAYER" "F" "6" ""))
(defun c:f7() (command "LAYER" "F" "7" ""))
(defun c:f8() (command "LAYER" "F" "8" ""))
(defun c:f9() (command "LAYER" "F" "9" ""))


(defun c:E() (command "ERASE"))
(defun c:EE() (command "ELLIPSE"))
(defun c:DC() (command "MOVE"))
(defun c:AF() (command "LINE"))
(defun c:PL() (command "PLINE"))
(defun c:Red() (command "REDRAW"))
(defun c:A() (command "ARC"))
(defun c:da() (command "dimangular"))
(defun c:de() (command "dimdiameter"))
(defun c:dr() (command "dimradius"))
(defun c:CC() (command "CIRCLE"))
(defun c:C() (command "COPY"))
(defun c:PT() (command "POINT"))
(defun c:SC() (command "SCALE"))
(defun c:DT1() (command "DTEXT"))
(defun c:MV() (command "MVIEW"))
(defun c:D() (command "DONUT"))
(defun c:QS() (command "QSAVE"))
(defun c:CT() (command "OSNAP" "INT"))
(defun c:gg() (command "OSNAP" "MID"))
(defun c:ee() (command "OSNAP" "END"))
(defun c:CE() (command "OSNAP" "CEN"))
(defun c:NO() (command "OSNAP" "NON"))
(defun c:RE() (command "REGEN"))
(defun c:R() (command "ROTATE"))
(defun c:CDd() (command "DIST"))
(defun c:REC() (command "RECTANG"))
(defun c:PE() (command "PEDIT"))
(defun c:PS() (command "PSPACE"))
(defun c:MS() (command "MSPACE"))
(defun c:s() (command "OFFSET"))
(defun c:CHA() (command "CHAMFER"))
(defun c:T() (command "TRIM"))
(defun c:EX() (command "EXTEND"))
(defun c:F() (command "FILLET"))
(defun c:DX() (command "MIRROR"))
(defun c:ZA() (command "ZOOM" "A"))
(defun c:Z() (command "ZOOM"))
(defun c:ZE() (command ".ZOOM" "E"))
(defun c:Z1() (command ".ZOOM" "0.5x"))
(defun c:ZW() (command "ZOOM" "W"))
(defun c:ZQ() (command "ZOOM" "P"))
(defun c:ZD() (command "ZOOM" "D"))
(defun c:CH() (command "CHANGE"))
(defun c:CHP() (command "CHPROP"))
(defun c:X() (command "EXPLODE"))
(defun c:LI() (command "LIST"))
(defun c:AR() (command "ARRAY"))
(defun c:QQ() (command "QLEADER"))
(defun c:II() (c:DDINSERT))
(defun c:I() (command "INSERT"))
(defun c:B() (command "BLOCK"))
(defun c:WB() (command "WBLOCK"))
(defun c:VP() (command "VPOINT" "R"))
(defun c:S() (command "STRETCH" "C"))
(defun c:DDt() (command "DDEDIT"))
(defun c:LTS (/ TILE )
  (setq TILE (getvar "TILEMODE"))
  (if (= #LTS_PS nil) (setq #LTS_PS 5))
  (if (= #LTS_MS nil) (setq #LTS_MS 60))
  (if (= TILE 0) 
     (progn 
        (setq #LTS_PS (getint (strcat "\nInpput LTSCALE factor for PAPER SPACE "
                                       "<" (rtos #LTS_PS 2 0) ">"))) 
        (setvar "LTSCALE" #LTS_PS)
        (command "REGENALL")
     ) 
     (progn 
        (setq #LTS_MS (getint (STRCAT "\nInpput LTSCALE factor for MODEL SPACE "
                                       "<" (rtos #LTS_MS 2 0) ">"))) 
        (setvar "LTSCALE" #LTS_MS)
        (command "REGENALL")
     ) 
  )
)
(defun c:TM( / TILE)
 (setq TILE (getvar "TILEMODE")) 
 (if #LTS_MS #LTS_MS (setq #LTS_MS 40))
 (if #LTS_PS #LTS_PS (setq #LTS_PS 4))
 (if (= TILE 0)
    (progn
      (setvar "LTSCALE" #LTS_MS)
      (setvar "TILEMODE" 1)
    )      
    (progn
      (setvar "LTSCALE" #LTS_PS)
      (setvar "TILEMODE" 0)
    )
 );if
)
(defun c:df( / kieu )
   (setq kieu (getstring "\n Plot / Draw (D):" ))
   (if (= kieu "") (setq kieu "D"))
   (if (or (= kieu "D") (= kieu "d")) (setvar "fontmap" "c:\\program files\\autocad r14\\fonts\\acad.fmp"))
   (if (or (= kieu "P") (= kieu "p")) (setvar "fontmap" "c:\\program files\\autocad r14\\support\\acad.fmp"))
   (if (and (/= kieu "D") (/= kieu "d") (/= kieu "P") (/= kieu "p")) (princ "\nInvalid key"))  
   (command "regenall" )
)                 
(defun c:ED() (command "DDEDIT"))
(defun c:DDD() (command "DIM1" "UP"))
(defun c:DED() (command "DIM1" "NEW"))
(defun c:DM() (command "dim1" "tedit"))
(defun c:EDD() (COMMAND "DDATTE"))
(defun c:MO() (c:DDMODIFY))
(defun c:A1() (command "PLINE" "0,0" "817,0" "817,570" "0,570" "c"))
(defun c:A2() (command "PLINE" "0,0" "570,0" "570,396" "0,396" "c"))
(defun c:A3() (command "PLINE" "0,0" "396,0" "396,273" "0,273" "c"))
(defun c:A4() (command "PLINE" "0,0" "198,0" "198,285" "0,285" "c"))
(defun c:HH()
  (prompt "\nNew dim method. ")
  (setq OS (getvar "OSMODE"))
  (setq #DIM 1)
  (setq pt1 (getpoint "\nSelect first extension line origin : ")
        pt2 (getpoint "\nSelect second extension line origin : " pt1) 
  )
  (setvar "OSMODE" 0)
  (setq #pt3 (getpoint "\nExtension line origin location :")
        pt11 (list (car pt1) (cadr #pt3))
        pt22 (list (car pt2) (cadr #pt3))
  )
  (command "DIM1" "HOR" pt11 pt22)
  (setvar "OSMODE" OS)
)
(prompt "\n HH or HO to use new horizontal dim method")
(defun c:VV()
  (prompt "\nNew dim method. ")
  (setq OS (getvar "OSMODE"))
  (setq #DIM 2)
  (setq pt1 (getpoint "\nSelect first extension line origin : ")
        pt2 (getpoint "\nSelect second extension line origin : " pt1) 
  ) 
  (setvar "OSMODE" 0) 
  (setq #pt3 (getpoint "\nExtension line origin location :")
        pt11 (list (car #pt3) (cadr pt1))
        pt22 (list (car #pt3) (cadr pt2))
  )
  (command "DIM1" "VER" pt11 pt22)
  (setvar "OSMODE" OS) 
)
(prompt "\n VV or VE to use new vertical dim method")

(defun c:ALI( / pt1 pt2 pt3 pt4 pt5 pt11 dis )
   (prompt "\nNew dim method.")
   (setq #DIM 3)
   (setq pt1 (getpoint "\nSelect first extension line origin : ")
         pt2 (getpoint "\nSelect first extension line origin : " pt1)
         pt3 (getpoint "\nExtension line origin location : ")
         #A (angle pt1 pt2)
         pt4 (polar pt3 (+ #A 1.57076) 100)
         pt5 (inters pt1 pt2 pt3 pt4 seg)
         dis (distance pt3 pt5)
         pt11 (polar pt1 (+ #A 1.57076) dis)  
         #pt22 (polar pt2 (+ #A 1.57076) dis)  
   )
   (command "dim1" "ali" pt11 #pt22)
) 
(prompt "\n ALI to use new ALI dim method")

(defun c:con( / pt1 pt11 pt4 pt5 A dis pt11 pt22)
 (if (= #DIM 1)
   (progn
      (prompt "\nNew dim method.")
      (setq pt1 (getpoint "\nSelect next extension line origin : ")
            pt11 (list (car pt1) (cadr #pt3))
      )
      (command "DIM1" "CON" pt11)
   )
 )
 (if (= #DIM 2)
   (progn
     (prompt "\nNew dim method. ")
     (setq pt1 (getpoint "\nSelect next extension line origin : ")
           pt11 (list (car #pt3) (cadr pt1))
     )
     (command "DIM1" "CON" pt11)
   )
 )
 (if (= #DIM 3)
   (progn
     (prompt "\nNew dim method. ")
     (setq pt1 (getpoint "\nSelect next extension line origin : ")
           pt2 (polar #pt22 #A 100)
           pt3 (polar pt1 (+ #A 1.570796) 100)
           pt5 (inters #pt22 pt2 pt1 pt3 seg)
     )
     (command "dim1" "con" pt5)
   )
 )
)




(prompt "\Written by TRAN QUANG VUONG CAU DUONG BO 39 ")
(princ)
