
(defun DXF (code elist)
   (cdr (assoc code elist))
)

(defun refine1 ( / nsset temp ed )
   (setq ssl   (sslength sset); 
      nsset (ssadd)
   )
   (print ssl)
   (princ "entities found. ")  
   (princ "\nVerifying the selected entities -- please wait. ")
   (while (> ssl 0)
      (progn
         (setq temp (ssname sset (setq ssl (1- ssl))))
         (setq ed (entget temp))
         (if (= (DXF 0 ed) "TEXT")             
            (progn
               (if (/= (TYPE (READ (DXF 1 ed))) 'SYM) 
                  (ssadd temp nsset)  
               )
            ) 
         )        
      )
   )
   (setq ssl (sslength nsset)
      sset nsset
   )
   (print ssl)
   (princ "text entities found. ")
  (setq ac (getint "\n Input accuracy: ")) 
   (princ "\n play " )  
   (setq No 0)
   (while (> ssl 0)
      (progn
         (setq temp (ssname sset (setq ssl (1- ssl))))
         (setq ed (entget temp))
         (setq No (+ No (atof (DXF 1 ed))))       
      )
   )
   (setq old (cons 1 (DXF 1 ed)))
   (setq new (cons 1 (rtos No 2 ac)))          
   (setq ed (subst new old ed))
   (entmod ed)  
)

(defun c:CN1()
   (setq sset (ssget))
   (setq last (getvar "dimzin"))
   (setvar "dimzin" 0)
   (refine1)
   (setvar "dimzin" last)
)
