(prompt "\n Duong Cong Chuyen Tiep-Trong Le NT-TEDI South")
;--------------------------------------------------------------------
(defun DXF (code elist)
     (cdr (assoc code elist))
)
;--------------------------------------------------------------------
(defun tan ( x )
   (/ (sin x ) (cos x))
)
;--------------------------------------------------------------------
(defun XX ( S C )
   (+ S (- 0 (/ (expt S 5) (* 40 (expt C 2)))) (/ (expt S 9) (* 3456 (expt C 4))) )
)
;--------------------------------------------------------------------
(defun YY ( S C )
   (+ (/ (expt S 3) (* 6 C)) (- 0 (/ (expt S 7) (* 336 (expt C 3)))) (/ (expt S 11) (* 42240 (expt C 5))) )
)
;--------------------------------------------------------------------
(prompt "\n DCCT: Ve Duong Cong Chuyen Tiep")
(defun c:dcct ( / alpha ang1 ang2 C i L Lmin OS P phi pt1 pt1a pt2 pt2a pt3 pt3a ptlist ptorigin ptside 
                          R S sd t T1 ucsn V x0 y0 pt4 dcn )
     (setq OS (getvar "OSMODE"))
     (setvar "OSMODE" 32)
     (setq pt1 (getpoint "\nChon Dinh Duong Cong: "))
     (setvar "OSMODE" 512)
     (setq pt2 (getpoint "\nChon Canh Tuyen 1: ")
              pt3 (getpoint "\nChon Canh Tuyen 2: ")
              ptside (list (/ (+ (car pt2) (car pt3)) 2) (/ (+ (cadr pt2) (cadr pt3)) 2))
              ang1(angle pt1 pt2)
              ang2 (angle pt1 pt3)
              V (getreal "\n Nhap Van Toc Thiet Ke (km/h) : ")
              R (getreal "\n Nhap Ban Kinh Duong Cong Tron (m) : ")
              Lmin (/ (* V V V) (* 23.5 R))
              L (getreal (strcat "\n Nhap Chieu Dai DCCT <Lmin=" (rtos Lmin 2 2) "> : "))
              phi (/ L (* 2 R))
     )
     (setvar "OSMODE" 0)
     (if (> (- ang1 ang2) 0.0) 
             (setq alpha (abs (- PI (- ang1 ang2))))
             (setq alpha (abs (- PI (- ang2 ang1))))
     )
     (while (> (* 2 phi) alpha) 
          (progn             
                (prompt "\n Khong thoa man: 2*phi <= alpha : Can tang R.")
                (setq R (getreal "\n Nhap Ban Kinh Duong Cong Tron (m) : ")
                         Lmin (/ (* V V V) (* 23.5 R))
                         L (getreal (strcat "\n Nhap Chieu Dai DCCT <Lmin=" (rtos Lmin 2 2) "> : "))
                         phi (/ L (* 2 R))
                )
          )
     )
     (setq C (* R L)  S L )
     (setq y0 (YY S C) x0 (XX S C))
     (setq P (- y0 (* R (- 1 (cos phi)))) 
              t (- x0 (* R (sin phi)))     
              T1 (/ (+ R P)  (tan (/ (- PI alpha) 2)))
     )   
     (setq sd  (getreal "\n So met/1 doan : ")
              pt4 (getpoint "\n Diem Dat Cac Thong So Duong Cong: ")
              dcn (getstring "\n Ten Duong Cong: ")
               i 1
              S 0
              ptlist (list (list 0 0))
     )
     (while (< (+ S sd) L)
         (progn
              (setq S (* sd i)
                       C (* R S)
                        ptlist (append ptlist (list (list (XX S C) (YY S C))))
                        i (+ i 1)
              )
         )
     );while
    (setq  ptlist (append ptlist (list (list (XX L (* R L)) (YY L (* R L))))))

     (if (/= (tblsearch "UCS" "DCCT") nil) (command "UCS" "D" "DCCT"))
     (setq ucsn (getvar "UCSNAME"))
     (if (= ucsn "")
           (progn
                 (setq ucsn "DCCT")
                 (command "UCS" "S" ucsn)
           )
     )

    (setq pt1a (trans pt1 1 0)) ; Lay toa do diem ve WCS

    (setq ptorigin (polar pt1 ang1 (+ T1 t) ))
    (command "UCS" "3P" ptorigin pt1 ptside)
    (setq i 0)
    (command "PLINE")
    (setq sd (- (length ptlist) 1))
    (while (<= i sd)
         (progn
               (command (nth i ptlist))
               (setq i (+ 1 i))
         )
     )
    (command "")
    
    (setq pt2a (trans (nth sd ptlist) 1 0)) ; Lay toa do diem dau arc ve UCSW
    
    (command "UCS" "R" ucsn)
    (setq ptorigin (polar pt1 ang2 (+ T1 t) ))
    (command "UCS" "3P" ptorigin pt1 ptside)
    (setq i 0)
    (command "PLINE")
    (while (<= i sd)
         (progn
               (command (nth i ptlist))
               (setq i (+ 1 i))
         )
     )
    (command "")

    (setq pt3a (trans (nth sd ptlist) 1 0)) ; Lay toa do diem end arc ve UCSW
    (command "UCS" "W")
   
   (setq ptside (list (/ (+ (car pt2a) (car pt3a)) 2) (/ (+ (cadr pt2a) (cadr pt3a)) 2)))
   (setq ang1 (angle pt1a ptside))
   (setq P1 (+ (* (+ R P) (- (/ 1 (sin (/ (- PI alpha) 2))) 1)) P))
   (setq pt1a (polar pt1a ang1 P1))
   (command "ARC" pt2a pt1a pt3a)

    (command "UCS" "R" ucsn)
    (if (= ucsn "DCCT") (command "UCS" "D" ucsn))

   (if (= scale nil) (c:tl))
   (if (= #acc nil) (c:acc))
   (setq i 0)
   (setvar "DIMAUNIT" 1)

   (command "TEXT" "S" "22" pt4 "0" dcn)
   (command "TEXT" (polar pt4  4.712389 (* scale 3 (setq i (+ 1 i)))) "0" (strcat "A=" (angtos alpha 1 4)) )
   (command "TEXT" (polar pt4  4.712389 (* scale 3(setq i (+ 1 i)))) "0" (strcat "R=" (rtos R 2 #acc)) )
   (command "TEXT" (polar pt4  4.712389 (* scale 3(setq i (+ 1 i)))) "0" (strcat "T=" (rtos (+ T1 t) 2 #acc)) )
   (command "TEXT" (polar pt4  4.712389 (* scale 3(setq i (+ 1 i)))) "0" (strcat "K=" (rtos (+ (* 2 L) (* R (- alpha (* 2 phi)))) 2 #acc)))
   (command "TEXT" (polar pt4  4.712389 (* scale 3(setq i (+ 1 i)))) "0" (strcat "Lct=" (rtos L 2 #acc)))
   (command "TEXT" (polar pt4  4.712389 (* scale 3(setq i (+ 1 i)))) "0" (strcat "P" (rtos P1 2 #acc)))

    (setvar "OSMODE" OS)
); defun dcct