(prompt "\nL O A D I N G    D I M _ U T I . L S P")

(defun DXF (code elist)
  (cdr (assoc code elist))
)

;-----------------------------------------------------------------------------------------------
(defun DIM_ssget ( / ssl  nsset temp ed )
  (setq sset (ssget))
  (setq ssl (sslength sset) 
        nsset (ssadd)
  )
  (print ssl)
  (princ "entities found. ")  
  (princ "\nVerifying the selected entities -- please wait. ")
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
      (if (= (DXF 0 ed) "DIMENSION") (ssadd temp nsset))
    )
  )
  (setq ssl (sslength nsset)
        sset nsset
  )
  (print ssl)
  (princ "DIMENSION entities found. ")
  (princ)
);defun DIM_ssget
;-----------------------------------------------------------------

(prompt "\n		DUP : To change DIMENSION to its original properties")

(defun c:DUP( / sset ssl temp ed old new )
(DIM_ssget)
(setq ssl (sslength sset))
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))

      (setq ed (entget temp))
      (setq old (cons 1 (DXF 1 ed)))
      (setq new (cons 1 ""))
      (setq ed (subst new old ed))

      (setq old (cons 70 (DXF 70 ed)))
      (setq new (cons 70 0))
      (setq ed (subst new old ed))

      (entmod ed)  
    )
  )
 (princ)
);defun

;-----------------------------------------------------------------

(prompt "\n		DCL : To change the DIMENSIONS to Layer 1")

(defun c:DCL ( / sset ssl temp ed old new )
(DIM_ssget)
(setq ssl (sslength sset))
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))

      (setq ed (entget temp))
      (setq old (cons 8 (DXF 8 ed)))
      (setq new (cons 8 "1"))
      (setq ed (subst new old ed))

      (entmod ed)  
    )
  )
 (princ)
);defun
;-----------------------------------------------------------------

(prompt "\n		H: to use new horizontal dim method")
(defun c:H()
  (prompt "\nNew dim method. ")
  (setq OS (getvar "OSMODE"))
  (setq #DIM 1)
  (setq pt1 (getpoint "\nSelect first extension line origin : ")
        pt2 (getpoint "\nSelect second extension line origin : " pt1) 
  )
  (setvar "OSMODE" 0)
  (setq #pt3 (getpoint "\nExtension line origin location :")
        pt11 (list (car pt1) (cadr #pt3))
        pt22 (list (car pt2) (cadr #pt3))
  )
  (command "DIM1" "HOR" pt11 pt22)
  (setvar "OSMODE" OS)
)
;-----------------------------------------------------------------

(prompt "\n	V: to use new vertical dim method")
(defun c:V()
  (prompt "\nNew dim method. ")
  (setq OS (getvar "OSMODE"))
  (setq #DIM 2)
  (setq pt1 (getpoint "\nSelect first extension line origin : ")
        pt2 (getpoint "\nSelect second extension line origin : " pt1) 
  ) 
  (setvar "OSMODE" 0) 
  (setq #pt3 (getpoint "\nExtension line origin location :")
        pt11 (list (car #pt3) (cadr pt1))
        pt22 (list (car #pt3) (cadr pt2))
  )
  (command "DIM1" "VER" pt11 pt22)
  (setvar "OSMODE" OS) 
)
;-----------------------------------------------------------------

(prompt "\n		CON: to use new continuos dim method")
(defun c:con( / pt1 pt11 pt4 pt5 A dis pt11 pt22)
 (setq OS (getvar "OSMODE"))
 (if (= #DIM 1)
   (progn
      (prompt "\nNew dim method.")
      (setq pt1 (getpoint "\nSelect next extension line origin : ")
            pt11 (list (car pt1) (cadr #pt3))
      )
      (setvar "OSMODE" 0) 
      (command "DIM1" "CON" pt11)
   )
 )
 (if (= #DIM 2)
   (progn
     (prompt "\nNew dim method. ")
     (setq pt1 (getpoint "\nSelect next extension line origin : ")
           pt11 (list (car #pt3) (cadr pt1))
     )
     (setvar "OSMODE" 0) 
     (command "DIM1" "CON" pt11)
   )
 )
 (if (= #DIM 3)
   (progn
     (prompt "\nNew dim method. ")
     (setq pt1 (getpoint "\nSelect next extension line origin : ")
           pt2 (polar #pt22 #A 100)
           pt3 (polar pt1 (+ #A 1.570796) 100)
           pt5 (inters #pt22 pt2 pt1 pt3 seg)
     )
     (setvar "OSMODE" 0) 
     (command "dim1" "con" pt5)
   )
 )
 (setvar "OSMODE" OS) 
)
;-----------------------------------------------------------------

(defun c:ali()
(command "dim1" "ali"))
;----------------------------------------------------------------------------------------------------------

(defun c:TL()
  (setvar "REGENMODE" 0)
  (setq SCALE (getreal "Input current scale : "))
  (setvar "DIMCLRE" 2)      ;Color
  (setvar "DIMCLRD" 2)      ;Color
  (setvar "DIMCLRT" 2)      ;Color
  (setvar "DIMZIN" 8)       ;Trailing
  (command "STYLE" "5" "VNI-Times" (* 4 SCALE) "1" "0" "N" "N")
  (command "STYLE" "2" "vn_vni" (* 2 SCALE) "0.8" "0" "N" "N" "N")
  (setvar "DIMEXE" SCALE)             ;Extension above line
  (setvar "DIMEXO" 0)                 ;Feature offset
  (setvar "DIMASZ" 0)                 ;Arrow size 
  (setvar "DIMTSZ" (* 0.7 SCALE))     ;Tick size 
  (setvar "DIMDLE" SCALE)             ;Tick extension 
  (setvar "DIMTXT" (* 2 SCALE))       ;Text height
  (setvar "DIMTAD" 1)                 ;Verical (defauft)
  (setvar "DIMTIH" 0)                 ;Horizontal
  (setvar "DIMTOH" 0)                 ;Horizontal
  (setvar "DIMTIX" 1)                 ;Force text inside   
  (setvar "DIMSOXD" 0)                ;Force text inside
  (setvar "DIMDEC" 1) 		      ;
  (setvar "DIMSCALE" 0)               ;
  (setvar "DIMFIT" 5)                 ;Noleader
  (setvar "DIMGAP" SCALE)
  (setvar "DIMTXSTY" "2")
  (setvar "REGENMODE" 1)
)
