(setvar "cmdecho" 0)
(setvar "measurement" 0)
(defun DXF (code elist)
   (cdr (assoc code elist))
)

(defun ETOS (arg / file)
   (if (= 'STR (type arg)) (setq arg (strcat "\"" arg "\"")))
   (setq file (open "$" "w"))
   (princ arg file)
   (close file)
   (setq file (open "$" "r"))
   (setq arg (read-line file))
   (close file)
   (close (open "$" "w"))
   arg 
)

(defun mc ( ent loai SC)
   (cond
      ((= loai "K")(command "hatch" "ansi37" (* 10 SC) 0 ent ""))     
      ((= loai "S")(command "hatch" "ansi31" (* 10 SC) 0 ent "")) 
      ((= loai "CS")(command "hatch" "sacncr" (* 10 SC) 90 ent "")) 
      ((= loai "SC")(command "hatch" "sacncr" (* 10 SC) 0 ent "")) 
      ((= loai "B")(command "hatch" "cork" (* 10 SC) 0 ent ""))  
      ((= loai "C")(command "hatch" "ar-sand" (* 0.5 SC) 0 ent "")) 
      ((= loai "D")(command "hatch" "dolmit" (* 10 SC) 0 ent ""))  
      ((= loai "CU")(command "hatch" "HEX" (* 10 SC) 0 ent ""))  
   ) 
)

(defun rect ( s a b)
   (setq xs (car s)
      ys (cadr s) 
   ) 
   (setq s1 (list xs (- ys a))
      s2 (list (+ xs b) (- ys a))
      s3 (list (+ xs b) ys)
   )
   (command "pline" s s1 s2 s3 "c")
)

(defun tex ( m l)
   (setq d "") 
   (while (setq c (nth m l))
      (setq d (strcat d (etos c) " " ))
      (setq m (+ m 1))
   ) 
   d
)

(defun c:LK( / loaidat )
   (if (= scale nil)
      (PROGN
         (prompt "Chua dat ty le ban ve \n ")           
         (C:TL)
      )  
   )   
   (setq os (getvar "osmode")
      tr (getvar "dimzin")
   ) 
   (setvar "dimzin" 0)
   (setvar "osmode" 0)
   (initget (+ 1 2 4))
   (setq name (getstring "\n TEN FILE "))
   (setq TL (getreal "\n TY LE RUT NGAN CHIEU SAU LO KHOAN: "))
   (setq p1 (getpoint "\n NOI DAT GHI CHU: ")
      P2 (getpoint "\n TOA D0 DIEM DAT LO KHOAN DAU TIEN : ") 
      P3 (getpoint "\n TOA D0 DIEM GOC CAO DO: ") 
      cd (getreal "\n CAO DO DIEM GOC ")  
   )
   (command "layer" "s" "0" "")  
   (setq f (open name "r"))
   (while (= f nil)
      (prompt (strcat "Khong tim thay file: " name))
      (setq name (getstring "\n TEN FILE ")) 
      (setq f (open name "r")) 
   ) 
   (grtext -1 " Dang doc ,cho mot chut ") 
   (setq line (read-line f)
      line (read (strcat "(" line ")"))   
      n (read (etos (car line)))      
   ) 
   (setq k 1)
   (setq xp1 (car p1)
      yp1 (cadr p1)
   )    
   (repeat n
      (setq line (read-line f)
         line (read (strcat "(" line ")"))     
         ld (etos (nth 1 line))
         tel (etos (nth 0 line))
      ) 
      (setq pt (list xp1 (- yp1 (* 10 (- k 1) scale))))
      (rect pt (* 5 scale) (* 10 scale))
      (setq en (entlast))
      (mc en ld scale)
      (setq pt1 (list (+ xp1 (* scale 20)) (- yp1 (* 10 (- k 1) scale) (* scale 2))))
      (command "text" "J" "MC" pt1 "0" tel)
      (setq pt1 (list (+ xp1 (* scale 20)) (- yp1 (* 10 (- k 1) scale) (* scale 2))))
      (command "circle" pt1 (* scale 2)) 
      (setq pt1 (list (+ xp1 (* scale 25)) (- yp1 (* 10 (- k 1) scale) (* scale 2))))             
      (command "text" "J" "Ml" pt1 "0" (tex 2 line))      
      (setq loaidat (append loaidat (list (cons tel ld))))       ;ghi lai kieu dat      
      (setq k (+ 1 k)) 
   )                                                  ; ghi ghi chu 
   (setq xp2 (- (car p2) (/ (* scale 3) 2)) 
      yp3 (cadr p3)
   )
   (setq line (read-line f))
   (setq line (read (strcat "(" line ")")))
   (repeat (nth 0 line)
      (setq line (read-line f))
      (setq line (read (strcat "(" line ")")))
      (setq xpl (+ xp2 (* 100 (nth 0 line))))
      (setq tenlk (etos (nth 2 line)))
      (repeat (nth 1 line)
         (setq line (read-line f))
         (setq line (read (strcat "(" line ")")))
         (setq ypl (- yp3 (* 100 tl (- cd (nth 1 line)))))
         (setq b (abs (* 100 tl (- (nth 1 line) (nth 2 line)))))
         (setq pl (list xpl ypl))
         (rect pl b (* scale 4) )        
         (setq en (entlast))
         (mc en (dxf (etos (nth 0 line)) loaidat) scale)
         (setq pl1 (list (+ xpl (* scale 6)) ypl)) 
         (command "text" "J" "Ml" pl1 "0" (rtos (nth 1 line) 2 2))     
         (setq pl2 (list (- xpl (* scale 5)) (- ypl (* 100 tl (abs (/ (-(nth 1 line) (nth 2 line)) 2)))))) 
         (command "text" "J" "MC" pl2 "0" (etos (nth 0 line)))
         (setq pl2 (list (- xpl (* scale 5)) (- ypl (* 100 tl (abs (/ (-(nth 1 line) (nth 2 line)) 2)))))) 
         (command "circle" pl2 (* scale 2)) 
      )
      (setq pl1 (list (+ xpl (* scale 5)) (- yp3 (* 100 tl (- cd (nth 2 line)))) )) 
      (command "text" "J" "Ml" pl1 "0" (rtos (nth 2 line) 2 2))      
      (setq pl1 (list (+ xpl ) (- yp3 (* 100 tl (- cd (nth 2 line))) 300) )) 
      (command "text" "J" "Ml" pl1 "0" tenlk)            
   )    
   (close f) 
   (grtext -1 "")
   (setvar "osmode" os)
   (setvar "dimzin" tr)
)
