(setvar "CMDECHO" 0)

(defun C:PU ()
        (command "purge" "a" )
        (while (= (getvar "CMDNAMES") "PURGE")
                (command "y" )
        );end while
)

(defun c:LTS()
(command "LTSCALE"))

(defun c:3p()
(command "UCS" "3p"))

(DEFUN C:WW() 
(COMMAND "ucs" "W"))

(DEFUN C:OO() 
(SETQ PT (GETPOINT "\nPICK (0,0) POINT"))
(COMMAND "ucs" "O" PT))

(defun c:CHT()
(LOAD "d:\\chtext.lsp"))

(defun c:CT2()
(LOAD "d:\\atrle\\lsp\\change-t.lsp"))

(defun c:CT5()
(LOAD "d:\\atrle\\lsp\\change-t.lsp"))

(defun c:ACAD()
(LOAD "C:\\ACAD.LSP"))

(defun c:DUP()
(LOAD "d:\\ATRLE\\LSP\\DIM-UP.lsp"))

(defun c:TUP()
(LOAD "d:\\ATRLE\\LSP\\TEXT-UP.lsp"))

(defun c:uti()
(load "d:\\atrle\\lsp\\uti.lsp"))

(defun c:TL()
  (setvar "REGENMODE" 0)
  (setq SCALE (getreal "Input current scale : "))
  (setvar "DIMCLRE" 2)      ;Color
  (setvar "DIMCLRD" 2)      ;Color
  (setvar "DIMCLRT" 2)      ;Color
  (setvar "DIMZIN" 8)       ;Trailing
  (command "STYLE" "5" "VNTIME" (* 5 SCALE) "1" "0" "N" "N")
  (command "STYLE" "22" "SIMPLEX,VN" (* 2 SCALE) "1" "0" "N" "N" "N")
  (setvar "DIMEXE" SCALE)             ;Extension above line
  (setvar "DIMEXO" 0)                 ;Feature offset
  (setvar "DIMASZ" 0)                 ;Arrow size 
  (setvar "DIMTSZ" (* 0.7 SCALE))     ;Tick size 
  (setvar "DIMDLE" SCALE)             ;Tick extension 
  (setvar "DIMTXT" (* 2 SCALE))       ;Text height
  (setvar "DIMTAD" 1)                 ;Verical (defauft)
  (setvar "DIMTIH" 0)                 ;Horizontal
  (setvar "DIMTOH" 0)                 ;Horizontal
  (setvar "DIMTIX" 1)                 ;Force text inside   
  (setvar "DIMSOXD" 0)                ;Force text inside
  (setvar "DIMGAP" SCALE)
  (setvar "LTSCALE" (/ SCALE 4))
  (setvar "DIMTXSTY" "22")
  (setvar "REGENMODE" 1)
)
(defun c:T22() (setvar "TEXTSTYLE" "22")
(command "DTEXT"))

(defun c:T2() (setvar "TEXTSTYLE" "2")
(command "DTEXT"))

(defun c:T5() (setvar "TEXTSTYLE" "5")
(command "DTEXT"))

(DEFUN C:CP() (COMMAND "COPY"))

(defun c:0() (command "LAYER" "T" "0" "S" "0" ""))
(defun c:1() (command "LAYER" "T" "1" "S" "1" ""))
(defun c:2() (command "LAYER" "T" "2" "S" "2" ""))
(defun c:3() (command "LAYER" "T" "3" "S" "3" ""))
(defun c:4() (command "LAYER" "T" "4" "S" "4" ""))
(defun c:5() (command "LAYER" "T" "5" "S" "5" ""))
(defun c:6() (command "LAYER" "T" "6" "S" "6" ""))
(defun c:7() (command "LAYER" "T" "7" "S" "7" ""))
(defun c:8() (command "LAYER" "T" "8" "S" "8" ""))
(defun c:9() (command "LAYER" "T" "9" "S" "9" ""))

(defun c:c0() (ssget) (command ".chprop" "p" "" "la" "0" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c1() (ssget) (command ".chprop" "p" "" "la" "1" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c2() (ssget) (command ".chprop" "p" "" "la" "2" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c3() (ssget) (command ".chprop" "p" "" "la" "3" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c4() (ssget) (command ".chprop" "p" "" "la" "4" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c5() (ssget) (command ".chprop" "p" "" "la" "5" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c6() (ssget) (command ".chprop" "p" "" "la" "6" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c7() (ssget) (command ".chprop" "p" "" "la" "7" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c8() (ssget) (command ".chprop" "p" "" "la" "8" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c9() (ssget) (command ".chprop" "p" "" "la" "9" "LT" "BYLAYER" "C" "BYLAYER" ""))

(defun c:f0() (command "LAYER" "F" "0" ""))
(defun c:f1() (command "LAYER" "F" "1" ""))
(defun c:f2() (command "LAYER" "F" "2" ""))
(defun c:f3() (command "LAYER" "F" "3" ""))
(defun c:f4() (command "LAYER" "F" "4" ""))
(defun c:f5() (command "LAYER" "F" "5" ""))
(defun c:f6() (command "LAYER" "F" "6" ""))
(defun c:f7() (command "LAYER" "F" "7" ""))
(defun c:f8() (command "LAYER" "F" "8" ""))
(defun c:f9() (command "LAYER" "F" "9" ""))


(defun c:E() (command "ERASE"))
(defun c:EL() (command "ELLIPSE"))
(defun c:M() (command "MOVE"))
(defun c:L() (command "LINE"))
(defun c:PL() (command "PLINE"))
(defun c:R() (command "REDRAW"))
(defun c:A() (command "ARC"))
(defun c:CI() (command "CIRCLE"))
(defun c:C() (command "COPY"))
(defun c:PT() (command "POINT"))
(defun c:SC() (command "SCALE"))
(defun c:DT() (command "DTEXT"))
(defun c:MV() (command "MVIEW"))
(defun c:D() (command "DONUT"))
(defun c:SA() (command "QSAVE"))
(defun c:IN() (command "OSNAP" "INT"))
(defun c:MID() (command "OSNAP" "MID"))
(defun c:EN() (command "OSNAP" "END"))
(defun c:CEN() (command "OSNAP" "CEN"))
(defun c:NO() (command "OSNAP" "NON"))
(defun c:RE() (command "REGEN"))
(defun c:RO() (command "ROTATE"))
(defun c:REC() (command "RECTANG"))
(defun c:PE() (command "PEDIT"))
(defun c:QS() (command "PSPACE"))
(defun c:AS() (command "MSPACE"))
(defun c:O() (command "OFFSET"))
(defun c:CHR() (command "CHAMFER"))
(defun c:T() (command "TRIM"))
(defun c:F() (command "FILLET"))
(defun c:MI() (command "MIRROR"))
(defun c:ZA() (command "ZOOM" "A"))
(defun c:Z() (command "ZOOM"))
(defun c:ZE() (command ".ZOOM" "E"))
(defun c:Z1() (command ".ZOOM" "0.5x"))
(defun c:ZW() (command "ZOOM" "W"))
(defun c:ZQ() (command "ZOOM" "P"))
(defun c:ZD() (command "ZOOM" "D"))
(defun c:CH() (command "CHANGE"))
(defun c:CHP() (command "CHPROP"))
(defun c:XP() (command "EXPLODE"))
(defun c:LI() (command "LIST"))
(defun c:DI() (command "DIST"))
(defun c:AR() (command "ARRAY"))
(defun c:II() (c:DDINSERT))
(defun c:I() (command "INSERT"))
(defun c:B() (command "BLOCK"))
(defun c:WB() (command "WBLOCK"))
(defun c:VP() (command "VPOINT" "R"))
(defun c:X() (command "EXTEND"))
(defun c:S() (command "STRETCH" "C"))
(defun c:TM( / TILE)
 (setq TILE (getvar "TILEMODE")) 
 (if (= TILE 0)
    (progn
      (setvar "TILEMODE" 1)
    )      
    (progn
      (setvar "TILEMODE" 0)
    )
 );if
)
(defun c:ED() (command "DDEDIT"))
(defun c:UP() (command "DIM1" "UP"))
(defun c:DED() (command "DIM1" "NEW"))
(defun c:DM() (command "dim1" "tedit"))
(defun c:EDD() (COMMAND "DDATTE"))
(defun c:MO() (c:DDMODIFY))
(defun c:A1() (command "PLINE" "0,0" "817,0" "817,570" "0,570" "c"))
(defun c:A2() (command "PLINE" "0,0" "570,0" "570,396" "0,396" "c"))
(defun c:A3() (command "PLINE" "0,0" "396,0" "396,273" "0,273" "c"))
(defun c:A4() (command "PLINE" "0,0" "198,0" "198,285" "0,285" "c"))
(defun c:HO()
  (prompt "\nNew dim method. ")
  (setq OS (getvar "OSMODE"))
  (setq #DIM 1)
  (setq pt1 (getpoint "\nSelect first extension line origin : ")
        pt2 (getpoint "\nSelect second extension line origin : " pt1) 
  )
  (setvar "OSMODE" 0)
  (setq #pt3 (getpoint "\nExtension line origin location :")
        pt11 (list (car pt1) (cadr #pt3))
        pt22 (list (car pt2) (cadr #pt3))
  )
  (command "DIM1" "HOR" pt11 pt22)
  (setvar "OSMODE" OS)
)
(prompt "\n HOR or HO to use new horizontal dim method")
(defun c:VE()
  (prompt "\nNew dim method. ")
  (setq OS (getvar "OSMODE"))
  (setq #DIM 2)
  (setq pt1 (getpoint "\nSelect first extension line origin : ")
        pt2 (getpoint "\nSelect second extension line origin : " pt1) 
  ) 
  (setvar "OSMODE" 0) 
  (setq #pt3 (getpoint "\nExtension line origin location :")
        pt11 (list (car #pt3) (cadr pt1))
        pt22 (list (car #pt3) (cadr pt2))
  )
  (command "DIM1" "VER" pt11 pt22)
  (setvar "OSMODE" OS) 
)
(prompt "\n VER or VE to use new vertical dim method")

(defun c:ALI( / pt1 pt2 pt3 pt4 pt5 pt11 dis )
   (prompt "\nNew dim method.")
   (setq #DIM 3)
   (setq pt1 (getpoint "\nSelect first extension line origin : ")
         pt2 (getpoint "\nSelect first extension line origin : " pt1)
         pt3 (getpoint "\nExtension line origin location : ")
         #A (angle pt1 pt2)
         pt4 (polar pt3 (+ #A 1.57076) 100)
         pt5 (inters pt1 pt2 pt3 pt4 seg)
         dis (distance pt3 pt5)
         pt11 (polar pt1 (+ #A 1.57076) dis)  
         #pt22 (polar pt2 (+ #A 1.57076) dis)  
   )
   (command "dim1" "ali" pt11 #pt22)
) 
(prompt "\n ALI to use new ALI dim method")

(defun c:con( / pt1 pt11 pt4 pt5 A dis pt11 pt22)
 (if (= #DIM 1)
   (progn
      (prompt "\nNew dim method.")
      (setq pt1 (getpoint "\nSelect next extension line origin : ")
            pt11 (list (car pt1) (cadr #pt3))
      )
      (command "DIM1" "CON" pt11)
   )
 )
 (if (= #DIM 2)
   (progn
     (prompt "\nNew dim method. ")
     (setq pt1 (getpoint "\nSelect next extension line origin : ")
           pt11 (list (car #pt3) (cadr pt1))
     )
     (command "DIM1" "CON" pt11)
   )
 )
 (if (= #DIM 3)
   (progn
     (prompt "\nNew dim method. ")
     (setq pt1 (getpoint "\nSelect next extension line origin : ")
           pt2 (polar #pt22 #A 100)
           pt3 (polar pt1 (+ #A 1.570796) 100)
           pt5 (inters #pt22 pt2 pt1 pt3 seg)
     )
     (command "dim1" "con" pt5)
   )
 )
)
(prompt "\n CON to use new continuos dim method")
(defun c:V() (c:VE))
(defun c:H() (c:HO))

(prompt "\n CAD Utilities For Release 14 (Written by NTTLe) Oct. 29 '97 ")
(princ)
