(prompt "\nBlock utilities, Written by TrongLe NT- TEDI South - Last update: August 12, 1998")
;----------------------------------------------------------
(defun DXF (code elist)
     (cdr (assoc code elist))
)
;------------------------------------------------------------------
(defun USTR (bit msg def spflag / inp nval)
     (if (and def (/= def ""))
          (setq msg (strcat "\n" msg "<" def ">: ")
               inp (getstring spflag msg)
               inp (if (= inp "") def inp)
          )
          (progn
               (if (= " " (substr msg (strlen msg) 1))
                    (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
                    (setq msg (strcat "\n" msg ": "))
               )
               (if (= bit 1)
                    (while (= "" (setq inp (getstring spflag msg)))
                         (prompt "\nInvalid String.")
                    )
                    (setq inp (getstring spflag msg))
               )
          )
     )
     inp
)
;------------------------------------------------------------------
(defun b_get ( / ssl  nsset temp ed )
     (setq #sset (ssget))
     (setq ssl (sslength #sset) 
          nsset (ssadd)
     )
     (print ssl)
     (princ "entities found. ")  
     (princ "\nVerifying the selected entities -- please wait. ")
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl))))
               (setq ed (entget temp))
               (if (= (DXF 0 ed) "INSERT") (ssadd temp nsset))
          )
     )
     (setq ssl (sslength nsset)
          #sset nsset
     )
     (print ssl)
     (princ "INSERT entities found. ")
     (princ)
);defun b_ssget
;-----------------------------------------------------------------
(prompt "\n BUP : Change INSERT entities to current scale")

(defun c:BUP( / ssl temp ed old new pt1 pt2 insert_pt oldscale ratio dist ang )
     (b_get)
     (if (= scale nil) (setq scale (getreal "\nInput current scale: ")))
     
     (setq ssl (sslength #sset))
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl)))
                    ed (entget temp)
                    insert_pt (dxf 10 ed)
                    
                    oldscale (dxf 41 ed) ; X_scale
                    ratio (/ scale (abs oldscale))
                    old (cons 41 (DXF 41 ed))
                    new (cons 41 (* ratio oldscale))
                    ed (subst new old ed)
                    oldscale (dxf 42 ed) ; Y_scale
                    ratio (/ scale (abs oldscale))
                    old (cons 42 (DXF 42 ed))
                    new (cons 42 (* ratio oldscale))
                    ed (subst new old ed)
                    oldscale (dxf 43 ed) ; Z_scale
                    ratio (/ scale (abs oldscale))
                    old (cons 43 (DXF 43 ed))
                    new (cons 43 (* ratio oldscale))
                    ed (subst new old ed)
               )
               (entmod ed)  
               (setq temp (entnext temp))
               
               (if (/= temp nil)
                    (progn
                         (setq ed (entget temp)
                              pt1 (dxf 10 ed)
                              pt2 (dxf 11 ed)
                              old (cons 40 (DXF 40 ed))
                              new (cons 40 (* scale 2))
                              ed (subst new old ed)
                              ratio (/ scale (abs oldscale))
                              
                              dist (distance insert_pt pt1)
                              ang (angle insert_pt pt1)
                              pt1 (polar insert_pt ang (* dist ratio))
                              dist (distance insert_pt pt2)
                              ang (angle insert_pt pt2)
                              pt2 (polar insert_pt ang (* dist ratio))
                              
                              old (cons 10 (DXF 10 ed))
                              new (cons 10 pt1)
                              ed (subst new old ed)
                              
                              old (cons 11 (DXF 11 ed))
                              new (cons 11 pt2)
                              ed (subst new old ed)
                         ); setq
                         (entmod ed)  
                         (entupd temp)
                    )
               )
          )
     )
     (princ)
);defun
;-----------------------------------------------------------------
(prompt "\n UCD : Change CD BLOCK to current height")

(defun c:UCD( / ssl temp ed old new  insert_pt y )
     (prompt (strcat "\nYOUR CURRENT  'U C S' IS : " (getvar "UCSNAME") "\n"))
     (b_get)
     (if (= scale nil) (setq scale (getreal "\nInput current scale: ")))
;     (if (= #acc nil) (setq #acc (getint "\nInput accuracy: ")))
     
     (setq DZ (getvar "DIMZIN"))
     (setvar "DIMZIN" 0)
     
     (setq ssl (sslength #sset))
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl)))
                    ed (entget temp)
                    insert_pt (dxf 10 ed)
                    bname (dxf 2 ed)
               )
               (if (OR (= bname "CD") (= bname "CD1") (= bname "CD2") (= bname "CD3"))
                    (progn
                         (setq temp (entnext temp)
                              ed (entget temp)
                              y (/ (cadr (trans insert_pt 0 1)) 100)
                         )
                         (cond
                              ((> y 0) (setq y (strcat "+" (rtos y 2 #acc))))
                              ((< y 0) (setq y (rtos y 2 #acc)))
                              ((= y 0) (setq y "%%p0.000"))
                         )
                         (setq old (cons 1 (DXF 1 ed))
                              new (cons 1 y)
                              ed (subst new old ed)
                         ); setq
                         (entmod ed)  
                         (entupd temp)
                    )
               )
          )
     )
     (princ)
     (setvar "DIMZIN" DZ)
);defun
;-----------------------------------------------------------------
