(defun DXF (code elist)
  (cdr (assoc code elist))
)
(defun CDXF (tt elist)
  (car (nth tt elist))
)
;CDXF - xac dinh thu tu cua danh sach

(defun xdtt (code elist)
(setq i 0)
(while (/= code (cdxf i elist))
;(progn
  (setq i (+ 1 i))
);while
)

(defun xdtt10 (elist)
(setq i 0)
(while (/= 10 (cdxf i elist))
;(progn
  (setq i (+ 1 i))
);while
)
;(setq d2 (getreal "New diameter of selected donuts :"))

(defun refine ( / nsset en ed ssl)
  (setq ssl (sslength sset) 
        nsset (ssadd)
  )
  (print ssl)
  (princ "entities found. ")  
  (princ "\nVerifying the selected entities -- please wait. ")
  (while (> ssl 0)
    (progn
      (setq en (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget en))
      (if  (= (DXF 70 ed) 1)     
      (if  (= (DXF 0 ed) "LWPOLYLINE")
         (ssadd en nsset)
      )
     )
    )
  )
  (setq ssl (sslength nsset)
        sset nsset
  )
  (print ssl)
  (princ " donuts found. ")
  (print)
  (setq d2 (getreal "New diameter of selected donuts :"))
  (while (> ssl 0)
    (progn
      (setq en (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget en))
     (if (= (DXF 0 ed) "LWPOLYLINE")
      (progn
         (setq old (nth (XDTT 42 ED) ed))
         (setq new (cons 42 1))
         (setq ed (subst new old ed))
         (entmod ed)  

         (setq old (nth (XDTT 43 ED) ed))
         (setq new (cons 43 (/ d2 2)))
         (setq ed (subst new old ed))
         (entmod ed)  

         (setq old1 (nth (XDTT 10 ED) ed))
         (setq old2 (nth (+ 4 (XDTT 10 ED)) ed))
         (setq x1 (nth 1 old1)
               x2 (nth 1 old2))
        (setq cen (/ (+ x2 x1) 2))
        (setq delta2 (/ d2 4))
        (setq new1 (list (nth 0 old1) (- cen delta2) (nth 2 old1)))
        (setq new2 (list (nth 0 old2) (+ cen delta2) (nth 2 old2)))
        (setq ed (subst new1 old1 ed))
        (setq ed (subst new2 old2 ed))
        (entmod ed) 

      );progn
    );if LWPOLYLINE
 );progn
);while
(princ)
);defun

(prompt "\nCD: Change the diameter of DONUT(s)")
(prompt "\nThis util was changed for suit to AcadR.14 in 16/12/1997")
(defun c:Cd()
(setq sset (ssget))
;(setq d2 (getreal "New diameter of selected donuts :))
(refine)
(princ)
)
