(defun DXF (code elist)
  (cdr (assoc code elist))
)

(defun refine ( / nsset en ed ssl)
  (setq ssl (sslength sset) 
        nsset (ssadd)
  )
  (print ssl)
  (princ "entities found. ")  
  (princ "\nVerifying the selected entities -- please wait. ")
  (while (> ssl 0)
    (progn
      (setq en (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget en))
      (if (OR (= (DXF 0 ed) "LINE") (= (DXF 0 ed) "POLYLINE") (= (DXF 0 ed) "CIRCLE"))
         (ssadd en nsset)
      )
    )
  )
  (setq ssl (sslength nsset)
        sset nsset
  )
  (print ssl)
  (princ "Entities Found. ")

  (while (> ssl 0)
    (progn
      (setq en (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget en))
      (if (= (DXF 0 ed) "LINE") 
      (progn
        (setq old (nth 7 ed))
        (setq new (list (nth 0 old) (nth 1 old) (nth 2 old) 0.0))
        (setq ed (subst new old ed))

        (setq old (nth 8 ed))
        (setq new (list (nth 0 old) (nth 1 old) (nth 2 old) 0.0))
        (setq ed (subst new old ed))

        (entmod ed)  
      );progn
     );if LINE
     (if (= (DXF 0 ed) "POLYLINE")
      (progn
        (setq old (nth 8 ed))
        (setq new (list (nth 0 old) (nth 1 old) (nth 2 old) 0.0))
        (setq ed (subst new old ed))
        (entmod ed)  

        (setq en (entnext en))
        (while (/= (DXF 0 (entget en)) "SEQEND")
          (progn
            (setq ed (entget en))
            (setq old (nth 8 ed))
            (setq new (list (nth 0 old) (nth 1 old) (nth 2 old) 0.0))
            (setq ed (subst new old ed))
          
            (entmod ed)  
            (setq en (entnext en))
          );progn
        );while
      );progn
    );if POLYLINE
    (if (= (DXF 0 ed) "CIRCLE") 
      (progn
        (setq old (nth 3 ed))
        (setq new (list (nth 0 old) (nth 1 old) (nth 2 old) 0.0))
        (setq ed (subst new old ed))
        (entmod ed)  
      );progn
   );if CIRCLE
 );progn
);while
);defun

(prompt "\nCH: Change z coordinate to 0.0")
(defun c:ch()
(setq sset (ssget))
(refine)
)
