// Next available MSG number is     6 
// MODULE_ID DDUCSP_DCL_
/* Next available MSG number is  10 */

//----------------------------------------------------------------------------
//
//     dducsp.dcl
//
//     Copyright 1992, 1994, 1996 by Autodesk, Inc.
//
//     Permission to use, copy, modify, and distribute this software
//     for any purpose and without fee is hereby granted, provided
//     that the above copyright notice appears in all copies and
//     that both that copyright notice and the limited warranty and
//     restricted rights notice below appear in all supporting
//     documentation.
//
//     AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
//     AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
//     MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.
//     DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
//     UNINTERRUPTED OR ERROR FREE.
//
//     Use, duplication, or disclosure by the U.S. Government is subject to
//     restrictions set forth in FAR 52.227-19 (Commercial Computer
//     Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
//     (Rights in Technical Data and Computer Software), as applicable.
//
//.
//----------------------------------------------------------------------------
//
//  Dducsp.dcl - Ucs presets selection dialogue.
//
//----------------------------------------------------------------------------

//dcl_settings : default_dcl_settings { audit_level = 3; }

dducsp : dialog {
  aspect_ratio = 0;
  label = "UCS Orientation";
  initial_focus = "ucsp_front";
  : row {
    : column {
      : image_button {
        key = "ucsp_world";
        width = 7;
        aspect_ratio = 1.0;
        color = 0;
        allow_accept = true;
      }
      : image_button {
        key = "ucsp_left";
        width = 7;
        aspect_ratio = 1.0;
        color = 0;
        allow_accept = true;
      }
      : image_button {
        key = "ucsp_cview";
        width = 7;
        aspect_ratio = 1.0;
        color = 0;
        allow_accept = true;
      }
    }
    : column {
      : image_button {
        key = "ucsp_top";
        width = 7;
        aspect_ratio = 1.0;
        color = 0;
        allow_accept = true;
      }
      : image_button {
        key = "ucsp_front";
        width = 7;
        aspect_ratio = 1.0;
        color = 0;
        allow_accept = true;
      }
      : image_button {
        key = "ucsp_bottom";
        width = 7;
        aspect_ratio = 1.0;
        color = 0;
        allow_accept = true;
      }
    }
    : column {
      : image_button {
        key = "ucsp_back";
        width = 7;
        aspect_ratio = 1.0;
        color = 0;
        allow_accept = true;
      }
      : image_button {
        key = "ucsp_right";
        width = 7;
        aspect_ratio = 1.0;
        color = 0;
        allow_accept = true;
      }
      : image_button {
        key = "ucsp_prev";
        width = 7;
        aspect_ratio = 1.0;
        color = 0;
        allow_accept = true;
      }
    }
  }
  : row {
    : radio_column {
      : radio_button {
        label = "Relative to Current UCS";
        mnemonic = "R";
        key = "ucsp_r_ucs";
      }
      : radio_button {
        label = "Absolute to WCS";
        mnemonic = "A";
        key = "ucsp_a_wcs";
      }
    }
  }
  ok_cancel_help_errtile;
}
