(defun DXF (code elist)
  (cdr (assoc code elist))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun text_u_ssget ( / ssl  nsset temp ed )
  (setq sset (ssget))
  (setq ssl (sslength sset) 
        nsset (ssadd)
  )
  (print ssl)
  (princ "entities found. ")  
  (princ "\nVerifying the selected entities -- please wait. ")
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
      (if (= (DXF 0 ed) "TEXT") (ssadd temp nsset))
    )
  )
  (setq ssl (sslength nsset)
        sset nsset
  )
  (print ssl)
  (princ "TEXT entities found. ")
  (princ)
);defun u_ssget

(prompt "\nTT2 : To update TEXT to V22 style and current size")
(princ)

(defun c:TT2( / sset ssl temp ed old new )
(text_u_ssget)
(if (= scale nil) (setq scale (getreal "\nInput current scale : ")))
(setq ssl (sslength sset))
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))

      (setq ed (entget temp))
         (progn
           (setq old (cons 7 (DXF 7 ed))
                 sty "V22"
                 new (cons 7 sty)
                 ed (subst new old ed)
            )
           (setq old (cons 40 (DXF 40 ed))
                 size (* 2 scale)
                 new (cons 40 size)
                 ed (subst new old ed)
           )
      )  

      (entmod ed)  
    )
  )
 (princ)
);defun TT2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(prompt "\nTT5 : To update TEXT to V5 style and current size")
(princ)

(defun c:TT5( / sset ssl temp ed old new )
(text_u_ssget)
(if (= scale nil) (setq scale (getreal "\nInput current scale : ")))
(setq ssl (sslength sset))
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))

      (setq ed (entget temp))
         (progn
           (setq old (cons 7 (DXF 7 ed))
                 sty "V5"
                 new (cons 7 sty)
                 ed (subst new old ed)
            )
           (setq old (cons 40 (DXF 40 ed))
                 size (* 4 scale)
                 new (cons 40 size)
                 ed (subst new old ed)
           )
      )  

      (entmod ed)  
    )
  )
 (princ)
);defun TT5
