(prompt "\n\nL O A D I N G    D R A W _ U T I . L S P")

(defun ETOS (arg / file)
  (if (= 'STR (type arg)) (setq arg (strcat "\"" arg "\"")))
  (setq file (open "TL" "w"))
  (princ arg file)
  (close file)
  (setq file (open "TL" "r"))
  (setq arg (read-line file))
  (close file)
  (close (open "TL" "w"))
  arg
)  
;------------------------------------------------------------------
(defun fopen ( fname mode msg / fh )
  (setq fh (open fname mode))
  (defun *error* (msg)
     (princ msg)
     (princ)
  )
  (while (= fh nil)
    (progn
       (Prompt (strcat "\nFile " msg " Not Found !"))
       (setq fname (USTR 1 (strcat "\nInput " msg " Again  ") nil T)
             fh (open fname mode)
       ) 
    )
  )
  fh
)
;------------------------------------------------------------------
(defun UDIST (bit kwd msg def bpt / inp)
  (if def
    (setq msg (strcat "\n" msg "<" (rtos def) ">: ")
          bit (* 2 (fix (/ bit 2)))
    )
    (if (= " " (substr msg (strlen msg) 1)) 
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
      (setq msg (strcat "\n" msg ": "))
    )
  )
  (initget bit kwd)
  (setq inp
    (if bpt
      (getdist msg bpt)
      (getdist msg)
    )
  )
  (if inp inp def)
)	
;------------------------------------------------------------------
(defun UKWORD (bit kwd msg def / inp)
  (if (and def (/= def ""))
    (setq msg (strcat "\n" msg "<" def ">: ")
          bit (* 2 (fix (/ bit 2)))
    )
    (if (= " " (substr msg (strlen msg) 1))
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
      (setq msg (strcat "\n" msg ": "))
    )
  )
  (initget bit kwd)
  (setq inp (getkword msg))
  (if inp inp def)
)
;------------------------------------------------------------------
(defun USTR (bit msg def spflag / inp nval)
  (if (and def (/= def ""))
    (setq msg (strcat "\n" msg "<" def ">: ")
          inp (getstring spflag msg)
          inp (if (= inp "") def inp)
    )
    (progn
      (if (= " " (substr msg (strlen msg) 1))
        (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
        (setq msg (strcat "\n" msg ": "))
      )
      (if (= bit 1)
        (while (= "" (setq inp (getstring spflag msg)))
           (prompt "\nInvalid String.")
        )
        (setq inp (getstring spflag msg))
      )
    )
  )
  inp
)
;------------------------------------------------------------------
(defun UINT (bit kwd msg def / inp)
  (if def
    (setq msg (strcat "\n" msg "<" (itoa def) ">: ")
	  bit (* 2 (fix (/ bit 2)))
    )
    (if (= " " (substr msg (strlen msg) 1)) 
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
      (setq msg (strcat "\n" msg ": "))
    )
  )
  (initget bit kwd)
  (setq inp (getint msg))
  (if inp inp def)
)	
;------------------------------------------------------------------
(defun UREAL (bit kwd msg def / inp)
  (if def
    (setq msg (strcat "\n" msg "<" (rtos def 2) ">: ")
	  bit (* 2 (fix (/ bit 2)))
    )
    (if (= " " (substr msg (strlen msg) 1)) 
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
      (setq msg (strcat "\n" msg ": "))
    )
  )
  (initget bit kwd)
  (setq inp (getreal msg))
  (if inp inp def)
)	
;------------------------------------------------------------------
(defun UPOINT (bit kwd msg def bpt / inp)
  (if def
    (setq pts (strcat 
                 (rtos (car def)) "," (rtos (cadr def))
                 (if
                   (and (caddr def) (= 0 (getvar "FLATLAND")))
                   (strcat "," (rtos (caddr def))) 
                   ""
                 )
               )
          msg (strcat "\n" msg "<" pts ">: ")
          bit (* 2 (fix (/ bit 2)))
    ) 
    (if (= " " (substr msg (strlen msg) 1))
       (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
       (setq msg (strcat "\n" msg ": "))
    )
  )
  (initget bit kwd)
  (setq inp
    (if bpt
      (getpoint msg bpt)
      (getpoint msg)
    )
  )
  (if inp inp def)
) 
;------------------------------------------------------------------
(defun CMDECH (mode)
  (if (= mode 1)
    (setvar "CMDECHO" 0)
    (setvar "CMDECHO" 1) 
  )
  (graphscr)
  (princ)
)
;------------------------------------------------------------------
(defun DXF (code elist)
  (cdr (assoc code elist))
)
;------------------------------------------------------------------
(defun RAD (degree)
  (setq radian (/ (* degree 3.1416) 180))
  radian
)
;------------------------------------------------------------------
(defun DEG (Rad)
  (setq degree (/ (* rad 180) 3.1416))
  degree
)
;------------------------------------------------------------------
(defun OSMODE ( mode )
  ( if (= mode 1) 
       (setvar "OSMODE" #OSMODE) 
       (progn
          (setq #OSMODE (getvar "OSMODE"))
          (setvar "OSMODE" 0)
       )
  )
)
;------------------------------------------------------------------
(defun c:CUT( / pt1 pt2 pt3 pt4 pt5 pt6 x1 x2 y1 y2 dx dy xx1 yy1 
                xx2 yy2 xx3 yy3 xx4 yy4 a b)
  (prompt "\nExpansion symbol. ") 
  (OSMODE 0)
  (CMDECH 1)
  (if #dist #dist (setq #dist 0))
  (setq pt1 (getpoint "\nFirst point : ")
  	pt2 (getpoint "\nSecond point : " pt1)
  	#dist (abs (UDIST 0 "" "How big ?" #dist nil))
  	x1 (car pt1)
        y1 (cadr pt1)
	x2 (car pt2)
	y2 (cadr pt2)
        a (angle pt1 pt2)
        b (- (/ PI 2) a)
	dx (* (/ #dist 3) (cos a))
	dy (if (= (cos a) 0) (/ #dist 3) (* dx (/ (sin a) (cos a))))
        xx1 (- (/ (+ x2 x1) 2) (/ dx 2))
	yy1 (- (/ (+ y2 y1) 2) (/ dy 2))
	xx2 (+ (/ (+ x2 x1) 2) (/ dx 2))
	yy2 (+ (/ (+ y2 y1) 2) (/ dy 2))
	dx  (* (/ #dist 2) (cos b))
	dy  (* (/ #dist 2) (sin b))
	xx3 (- (/ (+ x2 x1) 2) dx)
	yy3 (+ (/ (+ y2 y1) 2) dy)
	xx4 (+ (/ (+ x2 x1) 2) dx)
	yy4 (- (/ (+ y2 y1) 2) dy)
	pt3 (list xx1 yy1)
	pt4 (list xx3 yy3)
	pt5 (list xx4 yy4)
	pt6 (list xx2 yy2)
  )
(command "PLINE" pt1 pt3 pt4 pt5 pt6 pt2 "")
(OSMODE 1)
) 
(prompt "\n CUT() : Draw expansion symbol")
;------------------------------------------------------------------
(defun c:ct( / a pt1 pt2 pt3 pt4 x1 y1 times dist dl dx dy pt)
(prompt "\nBar sections, Welding line. ")
(cmdech 1)
(if #dia dia (setq #dia 20))
(if #inter #inter (setq #inter 200))
(if #kind #kind (setq #kind "Bar"))
(setq #kind (ukword 1 "Bar Siteweld Factoryweld" " Bar, weld in Site, weld in Factory " #kind)
      pt1 (getpoint "\nFrom...")
      pt2 (getpoint "\nTo..." pt1)
      #dia (abs (UDIST 0 "" "How big :" #dia nil))
      #inter (abs (UDIST 0 "" "Interval :" #inter nil))
      x1 (car pt1)
      y1 (cadr pt1)
      a (angle pt1 pt2)
      dist (distance pt1 pt2)
      times (fix (/ dist #inter))
      dl (/ dist times)
      dx (* dl (cos a))
      dy (* dl (sin a))
)
(setq #OSMODE (getvar "OSMODE"))
(setvar "OSMODE" 0)
(while (>= times 0)
  (setq x (+ x1 (* times dx))
      y (+ y1 (* times dy))
      pt (list x y))
  (if (= #kind "Bar")
     (command "DONUT" 0 #dia pt ""))
  (if (= #kind "Factoryweld")
     (command "LINE" pt (polar pt (+ a (/ PI 2)) #dia) ""))
  (if (= #kind "Siteweld")
     (progn
        (setq pt1 (polar pt (+ a PI) (/ #dia 2))
              pt2 (polar pt a (/ #dia 2))
              pt3 (polar pt1 (+ a (/ PI 4)) (* 1.414 #dia))
              pt4 (polar pt2 (+ a (/ (* 3 PI) 4)) (* 1.414 #dia))
        )      
        (command "LINE" pt1 pt3 "")
        (command "LINE" pt2 pt4 "")
     )
  )
  (setq times (1- times))
)
(setvar "OSMODE" #OSMODE)
)
(prompt "\n ST() : Bar sections")
;------------------------------------------------------------------
(defun c:ct1( / a count pt1 pt2 x1 y1 dist dl dx dy pt)
(prompt "\nBar sections. ")
(cmdech 1)
(if #dia dia (setq #dia 20))
(if #times #Hmany (setq #times 2))
(setq pt1 (getpoint "\nFrom...")
      pt2 (getpoint "\nTo..." pt1)
      #dia (abs (UDIST 0 "" "Diameter of bar :" #dia nil))
      #times (UINT 4 "" "How many bars :" #times)
      x1 (car pt1)
      y1 (cadr pt1)
      a (angle pt1 pt2)
      dist (distance pt1 pt2)
      dl (/ dist (- #times 1))
      dx (* dl (cos a))
      dy (* dl (sin a))
      count (- #times 1)
)
(setq #OSMODE (getvar "OSMODE"))
(setvar "OSMODE" 0)
(while (>= count 0)
  (setq x (+ x1 (* count dx))
      y (+ y1 (* count dy))
      pt (list x y)
  )
  (command "DONUT" 0 #dia pt "")
  (setq count (- count 1))
)
(setvar "OSMODE" #OSMODE)
)
(prompt "\n ST1() : Bar sections ")
;------------------------------------------------------------------


;------------------------------------------------------------------


(defun c:code( / ptlist pt a b n len pt1 ptc so pt2 count ptg)
  (if (= SCALE nil) (setq SCALE (UREAL 4 "" "Scale " SCALE)))
  (setq pt (upoint 0 "" "\nPick steel position" nil nil))
  (while (/= pt nil)
     (setq ptlist (append ptlist (list pt))
           pt (upoint 0 "" "\nPick steel position" nil pt)
     )
  )
  (setq pt1 (upoint 0 "" "\nFrom..." nil (nth 0 ptlist))
        pt2 (upoint 0 "" "\nTo..." nil pt1)
        len (distance (nth 0 ptlist) pt1)
        a (angle (nth 0 ptlist) pt1)
        b (angle pt1 pt2)
        n (length ptlist)
        ptc (polar pt2 b (* SCALE 2.5))
        count 0
  )
  (setq #OSMODE (getvar "OSMODE"))
  (setvar "OSMODE" 0)
  (while (< count n)
     (progn
        (setq pt (polar (nth count ptlist) a len)
              ptg (inters pt1 pt2 (nth count ptlist) pt seg)
        )  
        (command "LINE" (nth count ptlist) ptg "")
        (setq count (+ 1 count))
     )
  )
  (command "LINE" pt1 pt2 "")
  (if #dk #dk (setq #dk "00"))
  (setq str (strcat  "%%c" (ustr 0 "Diameter " #dk T) " "))
  (setq so (ustr 0 "Number " "00" T))
  (if (>= (car pt2) (car pt1))
    (progn
     (command "TEXT" "J" "BR" pt2 (DEG b) str)
     (command "TEXT" "J" "M" ptc (DEG b) so)
    )
    (progn 
     (command "TEXT" "J" "BL" pt2 (DEG (angle pt2 pt1)) str)
     (command "TEXT" "J" "M" ptc (DEG (angle pt2 pt1)) so)
    )
  )
  (command "CIRCLE" ptc "D" (* 4.5 SCALE))
  (setvar "OSMODE" #OSMODE)
)
(prompt "\n CODE to code steels in a section")
;------------------------------------------------------------------
(rtos n 2 0)