(SETVAR "CMDECHO" 0)
(setq OSMODE (getvar "OSMODE"))
(setvar "OSMODE" 0)
(setvar "COORDS" 0)
(setq #name "NTTLe XD91CD")    
(defun UDIST (bit kwd msg def bpt / inp)
  (if def
    (setq msg (strcat "\n" msg "<" (rtos def) ">: ")
          bit (* 2 (fix (/ bit 2)))
    )
    (if (= " " (substr msg (strlen msg) 1)) 
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
      (setq msg (strcat "\n" msg ": "))
    )
  )
  (initget bit kwd)
  (setq inp
    (if bpt
      (getdist msg bpt)
      (getdist msg)
    )
  )
  (if inp inp def)
)
(setq #LH (strcat (chr 78) (chr 84) (chr 84) (chr 76) (chr 101) " "
                (chr 88) (chr 68) "91" (chr 67) (chr 68)))
(defun UKWORD (bit kwd msg def / inp)
  (if (and def (/= def ""))
    (setq msg (strcat "\n" msg "<" def ">: ")
          bit (* 2 (fix (/ bit 2)))
    )
    (if (= " " (substr msg (strlen msg) 1))
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
      (setq msg (strcat "\n" msg ": "))
    )
  )
  (initget bit kwd)
  (setq inp (getkword msg))
  (if inp inp def)
)
(defun USTR (bit msg def spflag / inp nval)
  (if (and def (/= def ""))
    (setq msg (strcat "\n" msg "<" def ">: ")
          inp (getstring spflag msg)
          inp (if (= inp "") def inp)
    )
    (progn
      (if (= " " (substr msg (strlen msg) 1))
        (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
        (setq msg (strcat "\n" msg ": "))
      )
      (if (= bit 1)
        (while (= "" (setq inp (getstring spflag msg)))
           (prompt "\nInvalid String.")
        )
        (setq inp (getstring spflag msg))
      )
    )
  )
  inp
)
(defun UINT (bit kwd msg def / inp)
  (if def
    (setq msg (strcat "\n" msg "<" (itoa def) ">: ")
          bit (* 2 (fix (/ bit 2)))
    )
    (if (= " " (substr msg (strlen msg) 1)) 
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
      (setq msg (strcat "\n" msg ": "))
    )
  )
  (initget bit kwd)
  (setq inp (getint msg))
  (if inp inp def)
)
(defun UREAL (bit kwd msg def / inp)
  (if def
    (setq msg (strcat "\n" msg "<" (rtos def 2) ">: ")
          bit (* 2 (fix (/ bit 2)))
    )
    (if (= " " (substr msg (strlen msg) 1)) 
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
      (setq msg (strcat "\n" msg ": "))
    )
  )
  (initget bit kwd)
  (setq inp (getreal msg))
  (if inp inp def)
)
(defun UPOINT (bit kwd msg def bpt / inp)
  (if def
    (setq pts (strcat 
                 (rtos (car def)) "," (rtos (cadr def))
                 (if
                   (and (caddr def) (= 0 (getvar "FLATLAND")))
                   (strcat "," (rtos (caddr def))) 
                   ""
                 )
              )
          msg (strcat "\n" msg "<" pts ">: ")
          bit (* 2 (fix (/ bit 2)))
    ) 
    (if (= " " (substr msg (strlen msg) 1))
       (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
       (setq msg (strcat "\n" msg ": "))
    )
  )
  (initget bit kwd)
  (setq inp
    (if bpt
      (getpoint msg bpt)
      (getpoint msg)
    )
  )
  (if inp inp def)
) 
(defun UANGLE (bit kwd msg def bpt / inp)
  (if def
    (setq msg (strcat "\n" msg "<" (angtos def) ">: ")
          bit (* 2 (fix (/ bit 2)))
    )
    (if (= " " (substr msg (strlen msg) 1))
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
      (setq msg (strcat "\n" msg ": "))
    )
  )
  (initget bit kwd)
  (setq inp
    (if bpt
      (getangle msg bpt)
      (getangle msg)
    )
  )
  (if inp inp def)
)
(setq #title (strcat "\n" (chr 76) (chr 111) (chr 97) (chr 100) (chr 105)
(chr 110) (chr 103) " " (chr 84) (chr 82) (chr 65) (chr 67) " " (chr 68)
(chr 79) (chr 67) " " (chr 112) (chr 114) (chr 111) (chr 103) (chr 114)
(chr 97) (chr 109) " - " (chr 87) (chr 114) (chr 105) (chr 116) (chr 116) 
(chr 101) (chr 110) " " (chr 66) (chr 121) " " #name))
(defun DXF (code elist)
  (cdr (assoc code elist))
)
(defun RAD (degree)
  (setq radian (/ (* degree PI) 180))
  radian
)
(defun DEG (Rad)
  (setq degree (/ (* rad 180) PI))
  degree
)
(prompt #title)
(defun ETOS (arg / file)
  (if (= 'STR (type arg)) (setq arg (strcat "\"" arg "\"")))
  (setq file (open "$" "w"))
  (princ arg file)
  (close file)
  (setq file (open "$" "r"))
  (setq arg (read-line file))
  (close file)
  (close (open "$" "w"))
  arg
)  
(GRTEXT -1 "Chuong Trinh ve TRAC DOC")
(GRTEXT -2 #LH)

(defun fopen ( fname mode msg / fh )
  (setq fh (open fname mode))
  (defun *error* (msg)
     (princ msg)
     (princ)
  )
  (while (= fh nil)
    (progn
       (Prompt (strcat "\nFile " msg " Not Found !"))
       (setq fname (USTR 1 (strcat "\nInput " msg " Again : ") nil T)
             fh (open fname mode)
       ) 
    )
  )
  fh
)
(defun round (number accuracy)
  (atof (rtos number 2 accuracy))
)
(defun c:pre ( / fin fout fhout fhin str strtemp TenCoc lst KC_le CDTN CDTK
CDTKNS TNNS CDTKList TNlist fh tga count dem tana KC11 KC1 CD11 CD1 KC22 KC2 
CD22 CD2 Sin Sout dataf KCCD )
  (defun *error* (msg)
     (princ msg)
     (princ)
  )
  (GRTEXT -1 "Chuong Trinh Noi Suy Cao Do")
  (GRTEXT -2 #lh)
  (setq fin (etos (nth 0 (getdata)))
        fout (etos (nth 1 (getdata)))
        fhin (fopen fin "r" fin)
        KCCD 0
        str (read-line fhin)
  )
  (while (/= str nil)
     (progn
        (setq strtemp (strcat "(" str ")")
              lst (read strtemp)
              TenCoc (nth 0 lst)
              KC_le (nth 1 lst)
              CDTN (nth 2 lst)
              CDTK (nth 3 lst)
              KCCD (+ KCCD KC_le)
        )
        (if (/= (type CDTK) 'SYM) (setq CDTKList (append CDTKList (list (list KCCD CDTK)))))
        (if (/= (type CDTN) 'SYM) (setq TNList (append TNList (list (list KCCD CDTN)))))
        (setq str (read-line fhin))
     )
  )
  (close fhin)
  (setq fh (fopen fin "r" fin)
        fhout (fopen fout "w" fout)
        Sin (read-line fh)
        KCCD 0
        KC2 0
        KC22 0
        count 0
        dem 0
  )
  (while (/= Sin nil)
     (progn
        (setq strtemp (strcat "(" Sin ")" )
              lst (read strtemp)
              TenCoc (nth 0 lst)
              KC_le (nth 1 lst)
              KCCD (+ KCCD KC_le)
        )
        (if (AND (>= KCCD KC2) (/= (nth (+ 1 count) CDTKList) nil))
           (setq KC1 (nth 0 (nth count CDTKList))
                 CD1 (nth 1 (nth count CDTKList))
                 KC2 (nth 0 (nth (+ 1 count) CDTKList))
                 CD2 (nth 1 (nth (+ 1 count) CDTKList))
                 tga (/ (float (- CD1 CD2)) (float(- KC1 KC2)))
                 count (+ 1 count)
           )
        )

        (if (AND (>= KCCD KC22) (/= (nth (+ 1 dem) TNList) nil))
           (setq KC11 (nth 0 (nth dem TNList))
                 CD11 (nth 1 (nth dem TNList))
                 KC22 (nth 0 (nth (+ 1 dem) TNList))
                 CD22 (nth 1 (nth (+ 1 dem) TNList))
                 tana (/ (float (- CD11 CD22)) (float(- KC11 KC22)))
                 dem (+ 1 dem)
           )
        )

       (setq CDTKNS (+ CD1 (* tga (- KCCD KC1)))
             TNNS (+ CD11 (* tana (- KCCD KC11)))
             Sout (strcat (etos TENCOC) "\t" (etos KC_le) "\t" 
                          (etos KCCD) "\t" (etos (round TNNS 2)) "\t" (etos (round CDTKNS 2))) 
       )
       (write-line Sout fhout)
       (setq Sin (read-line fh))
       (prompt ".")      
    )
  )
  (close fh)
  (close fhout)
)
(defun c:td( / fout fhandle H_scale V_scale V_origin accuracyTk accuracy_TN
accuracyCD str PT_TN_1 PT_TK_1 KCCD TenCoc KC_le CDTN CDTK strtemp lst CDTC
x TENCOC_PT KCCD_PT KC_LE_PT CDTN_PT CDTK_PT CDTC_PT PT_TN PT_TK PT1 PT2 
fhandle n count KC1 CD1 KC2 CD2 PT i )
  (command "LIMITS" "0,0" "2000,1500")
  (command "ZOOM" "A")
  (defun *error* (msg)
     (princ msg)
     (princ)
  )
  (GRTEXT -1 "Chuong Trinh Tien xu ly")
  (GRTEXT -2 #LH)
  (command "STYLE" "V2" "SIMPLEX,HANOI" "2.5" "" "" "" "" "")
  (command "LAYER" "M" "CHUSO" "C" "1" "CHUSO" "")
  (command "LAYER" "M" "KHUNG" "C" "2" "KHUNG" "")
  (command "LAYER" "M" "DUONGDEN" "C" "7" "DUONGDEN" "")
  (command "LAYER" "M" "DUONGDO" "C" "1" "DUONGDO" "")
  (command "LAYER" "M" "DUONGGIONG" "C" "4" "DUONGGIONG" "")

  (setq fout (etos (nth 1 (getdata)))
        fhandle (fopen fout "r" fout)
        H_scale (nth 2 (getdata))
        V_scale (nth 3 (getdata))
        V_origin (nth 4 (getdata))
        accuracyTK (nth 5 (getdata))
        accuracyTN (nth 6 (getdata))
        accuracyCD (nth 7 (getdata))
        str (read-line fhandle)
        PT_TN_1 (list 0 80)
        PT_TK_1 PT_TN_1
        KCCD 0
  )
  (prompt "\n Cho 1 chut \n Dang Ve")
  (while (/= str nil)
     (progn
        ( setq strtemp (strcat "(" str ")" )
               lst (read strtemp)
               TenCoc (nth 0 lst)
               KC_le (nth 1 lst)
               CDTN (nth 3 lst)
               CDTK (nth 4 lst)
               KCCD (+ KCCD KC_le)
               x (/ KCCD H_scale)
               Tencoc_PT (list x -15)
               KCCD_PT (list x 22.5)
               KC_le_PT (list (- x (/ (/ KC_le H_scale) 2)) 32.5)
               CDTN_PT (list x 42.5)
               CDTK_PT (list x 57.5)
               PT_TN (list x (+ 80 (/ (- CDTN V_origin) V_scale)))
               PT_TK (list x (+ 80 (/ (- CDTK V_origin) V_scale)))
               pt1 (list x 30)
               pt2 (list x 35)
        )
        (command "LAYER" "S" "CHUSO" "")
        (command "TEXT" "J" "MC" Tencoc_PT "0" (etos TenCoc))
        (command "TEXT" "J" "MC" KCCD_PT "90" (rtos KCCD 2 accuracyCD))
        (command "TEXT" "J" "MC" KC_le_PT "0" (rtos KC_le 2 accuracyCD))
        (command "TEXT" "J" "MC" CDTN_PT "90" (rtos CDTN 2 accuracyTN))
        (command "TEXT" "J" "MC" CDTK_PT "90" (rtos CDTK 2 accuracyTK))
        (command "LAYER" "S" "KHUNG" "")
        (command "LINE" pt1 pt2 "")
        (command "LAYER" "S" "DUONGDEN" "")
        (command "LINE" PT_TN_1 PT_TN "")
        (command "LAYER" "S" "DUONGDO" "")
        (command "PLINE" PT_TK_1 PT_TK "")
        (command "LAYER" "S" "DUONGGIONG" "")
        (command "LINE" PT_TN (list x 80) "")
        (setq PT_TN_1 PT_TN
              PT_TK_1 PT_TK
        )
        (setq str (read-line fhandle))
     )
  )
  (close fhandle)
  (setq pt1 (list -70 0)
        pt2 (list (+ 5 (/ KCCD H_scale)) 0)
  )
  (command "LAYER" "S" "KHUNG" "")
  (command "LINE" pt1 pt2 (polar pt2 (/ PI 2) 80) (polar pt1 (/ PI 2) 80) "C")
  (command "LINE" (polar pt1 (/ PI 2) 15) (polar pt2 (/ PI 2) 15) "")
  (command "LINE" (polar pt1 (/ PI 2) 30) (polar pt2 (/ PI 2) 30) "")
  (command "LINE" (polar pt1 (/ PI 2) 35) (polar pt2 (/ PI 2) 35) "")
  (command "LINE" (polar pt1 (/ PI 2) 50) (polar pt2 (/ PI 2) 50) "")
  (command "LINE" (polar pt1 (/ PI 2) 65) (polar pt2 (/ PI 2) 65) "")
  (command "LINE" (polar pt1 0 65) (polar (polar pt1 0 65) (/ PI 2) 80) "")

  (command "TEXT" "J" "ML" "-60,84" "0" "M`5`8AT C`1`8AT SO S`1ANH :+0.00 (M)")
  (command "TEXT" "J" "ML" "-60,72.5" "0" "`9D`7U`7`2ONG CONG `9D`1`7UNG (M)")
  (command "TEXT" "J" "ML" "-60,57.5" "0" "CAO `9D`5`6O THI`1`6ET K`1`6E (M)") 
  (command "TEXT" "J" "ML" "-60,42.5" "0" "CAO `9D`6`5O THI`6EN NHI`6EN (M)")
  (command "TEXT" "J" "ML" "-60,32.5" "0" "KHO`3ANG C`1ACH L`3E (M)")
  (command "TEXT" "J" "ML" "-60,22.5" "0" "C`7`5U LY C`6`5ONG D`2`6ON (M)")
  (command "TEXT" "J" "ML" "-60,7.5" "0" "`9D`7U`7`2ONG CONG B`2`8ANG")
  (command "REDRAW")	
  (command "ZOOM" "A")	
)
(defun c:check()
  (if (/= #name #LH) (command "quit" "y"))
)
(defun c:dtdc( / dc A TD TC T K B dclist count pt1 pt2 pt3 pt4 pt5 pt 
ptt ptd accuracyCD line fh str lst )
  (defun *error* (msg)
     (princ msg)
     (princ)
  )
  (if (= #dir nil) (setq #dir (USTR 1 "\n Nhap Thu Muc Lam Viec " nil T)))
  (setq test (findfile (strcat #dir "dtdc.dat")))
  (if (= test nil)
     (progn
        (Prompt "\nBan Phai Nhap So Lieu DTDC truoc")
        (c:input)
     )
  )
  (setq fh (fopen (strcat #dir "dtdc.dat") "r" "dtdc.dat")
        line (read-line fh)
        accuracyCD (nth 7 (getdata))
  )
  (while (/= line nil)
     (progn
        (setq str (strcat "(" line ")" )
              lst (read str)
              A (nth 0 lst)
              R (nth 1 lst)
              TD (nth 2 lst)
              TC (nth 3 lst)
        )
        (if (> A 180) 
           (setq B 1.5708
                 A (- 360 A)
           )
           (setq B -1.5708)
        ) 
        (setq T (* R (/ (sin (/ (RAD A) 2)) (cos (/ (RAD A) 2))))
              K (* (RAD A) R)
              P (* R (- (/ 1 (cos (/ (RAD A) 2))) 1))
              dclist (append dclist (list (list A R TD TC T K P B)))
              line (read-line fh)
        )
     )
  )
  (setq count 0
        pt1 (list 0 7.5)
  )
  (setq H_scale (nth 2 (getdata)))
  (while (< count (length dclist))
    (progn
       (setq dc (nth count dclist)) 
       (setq pt2 (polar (list 0 7.5) 0 (/ (nth 2 dc) H_scale))
             pt3 (polar pt2 (nth 7 dc) 6.5)
             pt4 (polar pt3 0 (/ (- (nth 3 dc) (nth 2 dc)) H_scale))
             pt5 (polar pt4 (- 0 (nth 7 dc)) 6.5)
             ptt (polar (list 0 7.5) 0 (/ (/ (+ (nth 3 dc) (nth 2 dc)) 2) H_scale))
             ptd (polar (list 0 6) 0 (/ (/ (+ (nth 3 dc) (nth 2 dc)) 2) H_scale))
       )
       (command "LAYER" "S" "DUONGDO" "")
       (command "PLINE" pt1 pt2 pt3 pt4 pt5 "")
       (command "LAYER" "S" "CHUSO" "")
       (command "TEXT" "J" "BC" ptt "0" (strcat "A=" (etos (nth 0 dc)) 
                                             " R=" (etos (nth 1 dc))))
       (command "TEXT" "J" "TC" ptd "0" (strcat "T=" (rtos (nth 4 dc) 2 accuracyCD) 
                                " K=" (rtos (nth 5 dc) 2 accuracyCD) 
                                " P=" (rtos (nth 6 dc) 2 accuracyCD)))
       (setq pt1 pt5
             count (+ 1 count)
       )   
    )
  )
  (command "LINE" pt1 (polar (list 0 7.5) 0 (nth 8 (getdata))) "")
  (setvar "OSMODE" OSMODE)
)

(defun c:Input( / dai fin fout H_scale V_scale V_def V_origin accuracyTK
accuracyTN accuracyCD fh )
  (defun *error* (msg)
     (princ msg)
     (princ)
  )
  (GRTEXT -1 "Chuong Trinh Nhap So Lieu")
  (GRTEXT -2 #LH)
  (setq #dir (USTR 1 "\n Nhap Thu Muc Lam Viec " nil T) 
        fin (strcat #dir (USTR 1 "\n Nhap Ten File Du Lieu " nil T)) 
        fout (strcat #dir (USTR 1 "\n Nhap Ten File Ket Qua " nil T)) 
        H_scale (/ (UINT 4 "" " Ti Le Ngang " 1000) 1000.00)
        V_def (FIX (* H_scale 100))    
        V_scale (/ (UINT 4 "" " Ti Le Dung " V_def) 1000.00)
        V_origin (UINT 1 "" " Goc Cao Do " 0)
        accuracyTK (UINT 4 "" " Do Chinh Xac Cua CD Thiet Ke " 2) 
        accuracyTN (UINT 4 "" " Do Chinh Xac Cua CD Tu Nhien " 2) 
        accuracyCD (UINT 4 "" " Do Chinh Xac Cua KCCD " 0) 
        Dai (UINT 4 "" " Tong Chieu Dai " 2000) 
        fh (fopen (strcat #dir "tracdoc.dat") "w" (strcat #dir "tracdoc.dat"))
  )
  (write-line (strcat "DataFileName\t" fin) fh) 
  (write-line (strcat "ResultFileName\t" fout) fh) 
  (write-line (strcat "HorizontalScale\t" (etos H_scale)) fh)
  (write-line (strcat "VerticalScale\t" (etos V_scale)) fh)
  (write-line (strcat "OriginalHeigh\t" (etos V_origin)) fh)
  (write-line (strcat "AccuracyOfDesigned\t" (etos accuracyTK)) fh)
  (write-line (strcat "AccuracyOfGround\t" (etos accuracyTN)) fh)
  (write-line (strcat "AccuracyOfDistance\t" (etos accuracyCD)) fh)
  (write-line (strcat "TotalDistance\t" (etos Dai)) fh)
  (close fh)
  (setq dai (UKWORD 1 "Yes No" "Co nhap so lieu cua DTDC khong? <Y/N> " "Yes"))
  (if (= dai "Yes")
    (progn
      (setq fh (fopen (strcat #dir "dtdc.dat") "w" "dtdc.dat")
            A (ureal 0 "" "\nGoc ngoac Enter for none" nil)
      ) 
      (while (/= A nil)
        (progn
           (setq R (ureal 0 "" "Ban kinh duong cong " nil) 
                 TD (ureal 0 "" "Tiep dau duong cong " nil)
                 TC (ureal 0 "" "Tiep cuoi duong cong " nil)
           )
           (write-line (strcat (etos A) " " (etos R) " " (etos TD) " " (etos TC)) fh)
           (setq A (ureal 0 "" "\nGoc ngoac Enter for none" nil))
        )
      )
    (close fh)
    )
  )
)
(defun getdata ( / line fh i aaa parameter)
  (defun *error* (msg)
     (princ msg)
     (princ)
  )
  (if (= #dir nil) (setq #dir (USTR 1 "\n Nhap Thu Muc Lam Viec " nil T)))
  (setq fh (fopen (strcat #dir "tracdoc.dat") "r" "tracdoc.dat")
        line (read-line fh)
  )

  (while (/= line nil)
     (progn
        (setq aaa (nth 1 (read (strcat "(" line ")")))
              parameter (append parameter (list aaa))
              line (read-line fh)
        )
     )
  )
 (close fh)
 parameter
 )
(c:check)
(defun c:tracdoc()
  (defun *error* (msg)
     (princ msg)
     (princ)
  )
  (SETVAR "cmdecho" 0)
  (c:input)
  (c:pre)
  (c:td)
)

