

(defun DXF (code elist)
  (cdr (assoc code elist))
)

(defun CDXF (tt elist)
  (car (nth tt elist))
)
;CDXF - xac dinh thu tu cua danh sach

(defun xdtt (code elist)
(setq i 0)
(while (/= code (cdxf i elist))
;(progn
  (setq i (+ 1 i))
);while
)

(defun RAD (degree)
  (setq radian (/ (* degree 3.141592654) 180))
  radian
)

(defun DEG (Rad)
  (setq degree (/ (* rad 180) 3.141592654))
  degree
)

(defun tangent (Rad)
  (setq tang (/ (sin rad) (cos rad)))
  tang
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun text_u_ssget ( / ssl  nsset temp ed )
  (setq sset (ssget))
  (setq ssl (sslength sset) 
        nsset (ssadd)
  )
  (print ssl)
  (princ "entities found. ")  
  (princ "\nVerifying the selected entities -- please wait. ")
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
      (if (= (DXF 0 ed) "TEXT") (ssadd temp nsset))
    )
  )
  (setq ssl (sslength nsset)
        sset nsset
  )
  (print ssl)
  (princ "TEXT entities found. ")
  (princ)
  (print)
);defun u_ssget

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(prompt "\nTO : To oblique or straighten up TEXT entities")
(princ)

(defun c:TO( / sset ssl temp ed old new )
(text_u_ssget)
(setq ob_angle (getreal "New oblique angle of selected texts : "))
(setq ssl (sslength sset))
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))

       (setq old (cons 51 (DXF 51 ed))
             new (cons 51 (tangent (rad ob_angle)))
             ed (subst new old ed)
           )
      (entmod ed)  
      )  
  )

 (princ)
);defun