; Text utilities by Trong Le NT- May 26, 1998
(prompt "\nText utilities by TrongLe NT")
(prompt "\nLoading...")
;------------------------------------------------------------------
(defun UKWORD (bit kwd msg def / inp)
     (if (and def (/= def ""))
          (setq msg (strcat "\n" msg "<" def ">: ")
               bit (* 2 (fix (/ bit 2)))
          )
          (if (= " " (substr msg (strlen msg) 1))
               (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
               (setq msg (strcat "\n" msg ": "))
          )
     )
     (initget bit kwd)
     (setq inp (getkword msg))
     (if inp inp def)
)
;------------------------------------------------------------------
(defun USTR (bit msg def spflag / inp nval)
     (if (and def (/= def ""))
          (setq msg (strcat "\n" msg "<" def ">: ")
               inp (getstring spflag msg)
               inp (if (= inp "") def inp)
          )
          (progn
               (if (= " " (substr msg (strlen msg) 1))
                    (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
                    (setq msg (strcat "\n" msg ": "))
               )
               (if (= bit 1)
                    (while (= "" (setq inp (getstring spflag msg)))
                         (prompt "\nInvalid String.")
                    )
                    (setq inp (getstring spflag msg))
               )
          )
     )
     inp
)
;------------------------------------------------------------------
(defun ETOS (arg / file)
     (if (= 'STR (type arg)) (setq arg (strcat "\"" arg "\"")))
     (setq file (open "TL" "w"))
     (princ arg file)
     (close file)
     (setq file (open "TL" "r"))
     (setq arg (read-line file))
     (close file)
     (close (open "TL" "w"))
     arg
)  
;------------------------------------------------------------------
(defun DXF (code elist)
     (cdr (assoc code elist))
)
;-------------------------------------------------------------
(defun Text_get ( / ssl  nsset temp ed )
     (setq #sset (ssget))
     (setq ssl (sslength #sset) 
          nsset (ssadd)
     )
     (print ssl)
     (princ "entities found. ")  
     (princ "\nVerifying the selected entities -- please wait. ")
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl))))
               (setq ed (entget temp))
               (if (= (DXF 0 ed) "TEXT") (ssadd temp nsset))
          )
     )
     (setq ssl (sslength nsset)
          #sset nsset
     )
     (print ssl)
     (princ "TEXT entities found. ")
     (princ)
);defun Text_get
;-------------------------------------------------------------
(prompt "\nCT2, CT22, CT5, TUP : To change TEXT to "2" or "5" style")

(defun c:CT2( / ssl temp new old ed )
     (Text_get)
     (if (= scale nil) (setq scale (getreal "\nInput current scale : ")))
     (setq ssl (sslength #sset))
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl)))
                    ed (entget temp)
                    old (cons 40 (DXF 40 ed))
                    size (* 2 scale)
                    new (cons 40 size)
                    ed (subst new old ed)
                    
                    old (cons 7 (DXF 7 ed))
                    new (cons 7 "2")
                    ed (subst new old ed)
               )
               (entmod ed)  
          )
     )
     (princ)
);defun
;-------------------------------------------------------------
(defun c:CT22( / ssl temp new old ed )
     (Text_get)
     (if (= scale nil) (setq scale (getreal "\nInput current scale : ")))
     (setq ssl (sslength #sset))
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl)))
                    ed (entget temp)
                    old (cons 40 (DXF 40 ed))
                    size (* 2 scale)
                    new (cons 40 size)
                    ed (subst new old ed)
                    
                    old (cons 7 (DXF 7 ed))
                    new (cons 7 "22")
                    ed (subst new old ed)
               )
               (entmod ed)  
          )
     )
     (princ)
);defun

;-------------------------------------------------------------
(defun c:CT5( / ssl temp new old ed )
     (Text_get)
     (if (= scale nil) (setq scale (getreal "\nInput current scale : ")))
     (setq ssl (sslength #sset))
     
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl)))
                    ed (entget temp)
                    old (cons 40 (DXF 40 ed))
                    size (* 5 scale)
                    new (cons 40 size)
                    ed (subst new old ed)
                    
                    old (cons 7 (DXF 7 ed))
                    new (cons 7 "5")
                    ed (subst new old ed)
               )
               (entmod ed)  
          )
     )
     (princ)
);defun
;-------------------------------------------------------------------
(defun c:TUP( / ssl temp ed old new )
     (Text_get)
     (if (= scale nil) (setq scale (getreal "\nInput current scale : ")))
     (setq ssl (sslength #sset))
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl))))
               
               (setq ed (entget temp))
               (setq STYLE (DXF 7 ed))
               
               (if (OR (= STYLE "55") (= STYLE "5") (= STYLE "5T"))
                    (progn
                         (setq old (cons 40 (DXF 40 ed))
                              size (* 5 scale)
                              new (cons 40 size)
                              ed (subst new old ed)
                         )
                    )
               )  
               (if (OR (= STYLE "2") (= STYLE "22"))
                    (progn
                         (setq old (cons 40 (DXF 40 ed))
                              size (* 2 scale)
                              new (cons 40 size)
                              ed (subst new old ed)
                         )
                    )
               )  
               (entmod ed) 
          )
     )
     (princ)
);defun
;-------------------------------------------------------------------
(prompt "\nCC: Change code BigFont <-> BK1 <-> VNI")
(defun c:CC ( / ssl temp ed  old new )
     (Text_get)
     (setq Code1 (getint "\nSource code <BF=1 / BK1=2 / VNI=3>: "))
     (setq Code2 (getint "\nDestination code <BF=1 / BK1=2 / VNI=3>: "))
     (setq ssl (sslength #sset))
     
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl)))
                    ed (entget temp)
                    old (cons 1 (DXF 1 ed))
                    #txt (DXF 1 ed)
               )
               ( ChangeCode Code1 Code2 )
               (setq new (cons 1 #txt)
                    ed (subst new old ed)
               )
          )
          (entmod ed)  
     )
     (princ)
);defun

;-------------------------------------------------------------------
(defun ChangeCode ( Code1 code2 / char char1 len txt1 i )
     (setq txt1 "")
     (setq len (strlen #txt))
     (setq i 1)
     
     (if (AND (= Code1 2) (= Code2 3)) ;   BK1 -> VNI
          (progn
               (repeat len
                    (setq char (substr #txt i 1))
                    (cond
                         ((= (ascii char) 125) (setq char ""))
                         
                         ((= (ascii char) 123) (setq char "Y")) 
                         ((= (ascii char) 94) (setq char "Y"))
                         ((= (ascii char) 96) (setq char "Y"))
                         ((= (ascii char) 124) (setq char "Y"))
                         ((= (ascii char) 127) (setq char ""))
                         
                         ((= (ascii char) 128) (setq char "A"))
                         ((= (ascii char) 129) (setq char "A"))
                         ((= (ascii char) 130) (setq char "A"))
                         ((= (ascii char) 131) (setq char "A"))
                         ((= (ascii char) 132) (setq char "A"))
                         
                         ((= (ascii char) 133) (setq char "E"))
                         ((= (ascii char) 134) (setq char "E"))
                         ((= (ascii char) 135) (setq char "E"))
                         ((= (ascii char) 136) (setq char "E"))
                         ((= (ascii char) 137) (setq char "E"))
                         
                         ((= (ascii char) 138) (setq char ""))
                         ((= (ascii char) 139) (setq char ""))
                         ((= (ascii char) 140) (setq char ""))
                         ((= (ascii char) 141) (setq char ""))
                         ((= (ascii char) 142) (setq char ""))
                         
                         ((= (ascii char) 143) (setq char "O"))
                         ((= (ascii char) 144) (setq char "O"))
                         ((= (ascii char) 145) (setq char "O"))
                         ((= (ascii char) 146) (setq char "O"))
                         ((= (ascii char) 147) (setq char "O"))
                         
                         ((= (ascii char) 148) (setq char "U"))
                         ((= (ascii char) 149) (setq char "U"))
                         ((= (ascii char) 150) (setq char "U"))
                         ((= (ascii char) 151) (setq char "U"))
                         ((= (ascii char) 152) (setq char "U"))
                         
                         ((= (ascii char) 153) (setq char "A"))
                         ((= (ascii char) 154) (setq char "A"))
                         ((= (ascii char) 155) (setq char "A"))
                         ((= (ascii char) 156) (setq char "A"))
                         ((= (ascii char) 157) (setq char "A"))
                         ((= (ascii char) 158) (setq char "A"))
                         
                         ((= (ascii char) 159) (setq char "A"))
                         ((= (ascii char) 126) (setq char "A"))
                         ((= (ascii char) 161) (setq char "A"))
                         ((= (ascii char) 162) (setq char "A"))
                         ((= (ascii char) 163) (setq char "A"))
                         ((= (ascii char) 164) (setq char "A"))
                         
                         ((= (ascii char) 165) (setq char "E"))
                         ((= (ascii char) 166) (setq char "E"))
                         ((= (ascii char) 167) (setq char "E"))
                         ((= (ascii char) 168) (setq char "E"))
                         ((= (ascii char) 169) (setq char "E"))
                         ((= (ascii char) 170) (setq char "E"))
                         
                         ((= (ascii char) 171) (setq char "O"))
                         ((= (ascii char) 172) (setq char "O"))
                         ((= (ascii char) 173) (setq char "O"))
                         ((= (ascii char) 174) (setq char "O"))
                         ((= (ascii char) 175) (setq char "O"))
                         ((= (ascii char) 176) (setq char "O"))
                         
                         ((= (ascii char) 177) (setq char ""))
                         ((= (ascii char) 178) (setq char ""))
                         ((= (ascii char) 179) (setq char ""))
                         ((= (ascii char) 180) (setq char ""))
                         ((= (ascii char) 181) (setq char ""))
                         ((= (ascii char) 182) (setq char ""))
                         
                         ((= (ascii char) 183) (setq char ""))
                         ((= (ascii char) 184) (setq char ""))
                         ((= (ascii char) 185) (setq char ""))
                         ((= (ascii char) 186) (setq char ""))
                         ((= (ascii char) 187) (setq char ""))
                         ((= (ascii char) 188) (setq char ""))
                         
                         ((= (ascii char) 189) (setq char ""))
                         
                         ((= (ascii char) 190) (setq char "a"))
                         ((= (ascii char) 191) (setq char "a"))
                         ((= (ascii char) 192) (setq char "a"))
                         ((= (ascii char) 193) (setq char "a"))
                         ((= (ascii char) 194) (setq char "a"))
                         
                         ((= (ascii char) 195) (setq char "e"))
                         ((= (ascii char) 196) (setq char "e"))
                         ((= (ascii char) 197) (setq char "e"))
                         ((= (ascii char) 198) (setq char "e"))
                         ((= (ascii char) 199) (setq char "e"))
                         
                         ((= (ascii char) 200) (setq char ""))
                         ((= (ascii char) 201) (setq char ""))
                         ((= (ascii char) 202) (setq char ""))
                         ((= (ascii char) 203) (setq char ""))
                         ((= (ascii char) 204) (setq char ""))
                         
                         ((= (ascii char) 205) (setq char "o"))
                         ((= (ascii char) 206) (setq char "o"))
                         ((= (ascii char) 207) (setq char "o"))
                         ((= (ascii char) 208) (setq char "o"))
                         ((= (ascii char) 209) (setq char "o"))
                         
                         ((= (ascii char) 210) (setq char "u"))
                         ((= (ascii char) 211) (setq char "u"))
                         ((= (ascii char) 212) (setq char "u"))
                         ((= (ascii char) 213) (setq char "u"))
                         ((= (ascii char) 214) (setq char "u"))
                         
                         ((= (ascii char) 215) (setq char "a"))
                         ((= (ascii char) 216) (setq char "a"))
                         ((= (ascii char) 217) (setq char "a"))
                         ((= (ascii char) 218) (setq char "a"))
                         ((= (ascii char) 219) (setq char "a"))
                         ((= (ascii char) 220) (setq char "a"))
                         
                         ((= (ascii char) 221) (setq char "a"))
                         ((= (ascii char) 222) (setq char "a"))
                         ((= (ascii char) 223) (setq char "a"))
                         ((= (ascii char) 224) (setq char "a"))
                         ((= (ascii char) 225) (setq char "a"))
                         ((= (ascii char) 226) (setq char "a"))
                         
                         ((= (ascii char) 227) (setq char "e"))
                         ((= (ascii char) 228) (setq char "e"))
                         ((= (ascii char) 229) (setq char "e"))
                         ((= (ascii char) 230) (setq char "e"))
                         ((= (ascii char) 231) (setq char "e"))
                         ((= (ascii char) 232) (setq char "e"))
                         
                         ((= (ascii char) 233) (setq char "o"))
                         ((= (ascii char) 234) (setq char "o"))
                         ((= (ascii char) 235) (setq char "o"))
                         ((= (ascii char) 236) (setq char "o"))
                         ((= (ascii char) 237) (setq char "o"))
                         ((= (ascii char) 238) (setq char "o"))
                         
                         ((= (ascii char) 239) (setq char ""))
                         ((= (ascii char) 240) (setq char ""))
                         ((= (ascii char) 241) (setq char ""))
                         ((= (ascii char) 242) (setq char ""))
                         ((= (ascii char) 243) (setq char ""))
                         ((= (ascii char) 244) (setq char ""))
                         
                         ((= (ascii char) 245) (setq char ""))
                         ((= (ascii char) 246) (setq char ""))
                         ((= (ascii char) 247) (setq char ""))
                         ((= (ascii char) 248) (setq char ""))
                         ((= (ascii char) 249) (setq char ""))
                         ((= (ascii char) 250) (setq char ""))
                         
                         ((= (ascii char) 251) (setq char "y"))
                         ((= (ascii char) 252) (setq char "y"))
                         ((= (ascii char) 253) (setq char "y"))
                         ((= (ascii char) 254) (setq char "y"))
                         ((= (ascii char) 255) (setq char ""))
                         
                    );cond
                    (setq i (+ i 1))
                    (setq txt1 (strcat txt1 char))
               );repeat
          );progn
     ) ;if
     
     (if (AND (= Code1 3) (= Code2 2)) ; VNI -> BK1
          (progn
               (repeat len
                    (setq char (substr #txt i 1))
                    (setq char1 (substr #txt (+ i 1) 1))
                    (cond
                         ((AND (= (ascii char1) 217) (= char "Y")) (setq char (chr 123) i (+ i 2))) 
                         ((AND (= (ascii char1) 217) (= char "A")) (setq char (chr 128) i (+ i 2))) 
                         ((AND (= (ascii char1) 217) (= char "E")) (setq char (chr 133) i (+ i 2))) 
                         ((AND (= (ascii char1) 217) (= char "O")) (setq char (chr 143) i (+ i 2))) 
                         ((AND (= (ascii char1) 217) (= char "U")) (setq char (chr 148) i (+ i 2))) 
                         ((AND (= (ascii char1) 217) (= char "")) (setq char (chr 178) i (+ i 2))) 
                         ((AND (= (ascii char1) 217) (= char "")) (setq char (chr 184) i (+ i 2))) 
                         
                         ((AND (= (ascii char1) 216) (= char "Y")) (setq char (chr 94) i (+ i 2))) 
                         ((AND (= (ascii char1) 216) (= char "A")) (setq char (chr 129) i (+ i 2))) 
                         ((AND (= (ascii char1) 216) (= char "E")) (setq char (chr 134) i (+ i 2))) 
                         ((AND (= (ascii char1) 216) (= char "O")) (setq char (chr 144) i (+ i 2))) 
                         ((AND (= (ascii char1) 216) (= char "U")) (setq char (chr 149) i (+ i 2))) 
                         ((AND (= (ascii char1) 216) (= char "")) (setq char (chr 179) i (+ i 2))) 
                         ((AND (= (ascii char1) 216) (= char "")) (setq char (chr 185) i (+ i 2))) 
                         
                         ((AND (= (ascii char1) 219) (= char "Y")) (setq char (chr 96) i (+ i 2))) 
                         ((AND (= (ascii char1) 219) (= char "A")) (setq char (chr 130) i (+ i 2))) 
                         ((AND (= (ascii char1) 219) (= char "E")) (setq char (chr 135) i (+ i 2))) 
                         ((AND (= (ascii char1) 219) (= char "O")) (setq char (chr 145) i (+ i 2))) 
                         ((AND (= (ascii char1) 219) (= char "U")) (setq char (chr 150) i (+ i 2))) 
                         ((AND (= (ascii char1) 219) (= char "")) (setq char (chr 180) i (+ i 2))) 
                         ((AND (= (ascii char1) 219) (= char "")) (setq char (chr 186) i (+ i 2))) 
                         
                         ((AND (= (ascii char1) 213) (= char "Y")) (setq char (chr 124) i (+ i 2))) 
                         ((AND (= (ascii char1) 213) (= char "A")) (setq char (chr 131) i (+ i 2))) 
                         ((AND (= (ascii char1) 213) (= char "E")) (setq char (chr 136) i (+ i 2))) 
                         ((AND (= (ascii char1) 213) (= char "O")) (setq char (chr 146) i (+ i 2))) 
                         ((AND (= (ascii char1) 213) (= char "U")) (setq char (chr 151) i (+ i 2))) 
                         ((AND (= (ascii char1) 213) (= char "")) (setq char (chr 181) i (+ i 2))) 
                         ((AND (= (ascii char1) 213) (= char "")) (setq char (chr 187) i (+ i 2))) 
                         
                         ((AND (= (ascii char1) 207) (= char "A")) (setq char (chr 132) i (+ i 2))) 
                         ((AND (= (ascii char1) 207) (= char "E")) (setq char (chr 137) i (+ i 2))) 
                         ((AND (= (ascii char1) 207) (= char "O")) (setq char (chr 147) i (+ i 2))) 
                         ((AND (= (ascii char1) 207) (= char "U")) (setq char (chr 152) i (+ i 2))) 
                         ((AND (= (ascii char1) 207) (= char "")) (setq char (chr 182) i (+ i 2))) 
                         ((AND (= (ascii char1) 207) (= char "")) (setq char (chr 188) i (+ i 2))) 
                         
                         ((AND (= (ascii char1) 202) (= char "A")) (setq char (chr 153) i (+ i 2))) 
                         ((AND (= (ascii char1) 201) (= char "A")) (setq char (chr 154) i (+ i 2))) 
                         ((AND (= (ascii char1) 200) (= char "A")) (setq char (chr 155) i (+ i 2))) 
                         ((AND (= (ascii char1) 218) (= char "A")) (setq char (chr 156) i (+ i 2))) 
                         ((AND (= (ascii char1) 220) (= char "A")) (setq char (chr 157) i (+ i 2))) 
                         ((AND (= (ascii char1) 203) (= char "A")) (setq char (chr 158) i (+ i 2))) 
                         
                         ((AND (= (ascii char1) 194) (= char "A")) (setq char (chr 159) i (+ i 2))) 
                         ((AND (= (ascii char1) 193) (= char "A")) (setq char (chr 126) i (+ i 2))) 
                         ((AND (= (ascii char1) 192) (= char "A")) (setq char (chr 161) i (+ i 2))) 
                         ((AND (= (ascii char1) 197) (= char "A")) (setq char (chr 162) i (+ i 2))) 
                         ((AND (= (ascii char1) 195) (= char "A")) (setq char (chr 163) i (+ i 2))) 
                         ((AND (= (ascii char1) 196) (= char "A")) (setq char (chr 164) i (+ i 2))) 
                         
                         ((AND (= (ascii char1) 194) (= char "E")) (setq char (chr 165) i (+ i 2))) 
                         ((AND (= (ascii char1) 193) (= char "E")) (setq char (chr 166) i (+ i 2))) 
                         ((AND (= (ascii char1) 192) (= char "E")) (setq char (chr 167) i (+ i 2))) 
                         ((AND (= (ascii char1) 197) (= char "E")) (setq char (chr 168) i (+ i 2))) 
                         ((AND (= (ascii char1) 195) (= char "E")) (setq char (chr 169) i (+ i 2))) 
                         ((AND (= (ascii char1) 196) (= char "E")) (setq char (chr 170) i (+ i 2))) 
                         
                         ((AND (= (ascii char1) 194) (= char "O")) (setq char (chr 171) i (+ i 2))) 
                         ((AND (= (ascii char1) 193) (= char "O")) (setq char (chr 172) i (+ i 2))) 
                         ((AND (= (ascii char1) 192) (= char "O")) (setq char (chr 173) i (+ i 2))) 
                         ((AND (= (ascii char1) 197) (= char "O")) (setq char (chr 174) i (+ i 2))) 
                         ((AND (= (ascii char1) 195) (= char "O")) (setq char (chr 175) i (+ i 2))) 
                         ((AND (= (ascii char1) 196) (= char "O")) (setq char (chr 176) i (+ i 2))) 
                         
                         ((AND (= (ascii char1) 249) (= char "a")) (setq char (chr 190) i (+ i 2))) 
                         ((AND (= (ascii char1) 248) (= char "a")) (setq char (chr 191) i (+ i 2))) 
                         ((AND (= (ascii char1) 251) (= char "a")) (setq char (chr 192) i (+ i 2))) 
                         ((AND (= (ascii char1) 245) (= char "a")) (setq char (chr 193) i (+ i 2))) 
                         ((AND (= (ascii char1) 239) (= char "a")) (setq char (chr 194) i (+ i 2))) 
                         
                         ((AND (= (ascii char1) 249) (= char "e")) (setq char (chr 195) i (+ i 2))) 
                         ((AND (= (ascii char1) 248) (= char "e")) (setq char (chr 196) i (+ i 2))) 
                         ((AND (= (ascii char1) 251) (= char "e")) (setq char (chr 197) i (+ i 2))) 
                         ((AND (= (ascii char1) 245) (= char "e")) (setq char (chr 198) i (+ i 2))) 
                         ((AND (= (ascii char1) 239) (= char "e")) (setq char (chr 199) i (+ i 2))) 
                         
                         ((AND (= (ascii char1) 249) (= char "o")) (setq char (chr 205) i (+ i 2))) 
                         ((AND (= (ascii char1) 248) (= char "o")) (setq char (chr 206) i (+ i 2))) 
                         ((AND (= (ascii char1) 251) (= char "o")) (setq char (chr 207) i (+ i 2))) 
                         ((AND (= (ascii char1) 245) (= char "o")) (setq char (chr 208) i (+ i 2))) 
                         ((AND (= (ascii char1) 239) (= char "o")) (setq char (chr 209) i (+ i 2))) 
                         
                         ((AND (= (ascii char1) 249) (= char "u")) (setq char (chr 210) i (+ i 2))) 
                         ((AND (= (ascii char1) 248) (= char "u")) (setq char (chr 211) i (+ i 2))) 
                         ((AND (= (ascii char1) 251) (= char "u")) (setq char (chr 212) i (+ i 2))) 
                         ((AND (= (ascii char1) 245) (= char "u")) (setq char (chr 213) i (+ i 2))) 
                         ((AND (= (ascii char1) 239) (= char "u")) (setq char (chr 214) i (+ i 2))) 
                         
                         ((AND (= (ascii char1) 234) (= char "a")) (setq char (chr 215) i (+ i 2))) 
                         ((AND (= (ascii char1) 233) (= char "a")) (setq char (chr 216) i (+ i 2))) 
                         ((AND (= (ascii char1) 232) (= char "a")) (setq char (chr 217) i (+ i 2))) 
                         ((AND (= (ascii char1) 250) (= char "a")) (setq char (chr 218) i (+ i 2))) 
                         ((AND (= (ascii char1) 252) (= char "a")) (setq char (chr 219) i (+ i 2))) 
                         ((AND (= (ascii char1) 235) (= char "a")) (setq char (chr 220) i (+ i 2))) 
                         
                         ((AND (= (ascii char1) 226) (= char "a")) (setq char (chr 221) i (+ i 2))) 
                         ((AND (= (ascii char1) 225) (= char "a")) (setq char (chr 222) i (+ i 2))) 
                         ((AND (= (ascii char1) 224) (= char "a")) (setq char (chr 223) i (+ i 2))) 
                         ((AND (= (ascii char1) 229) (= char "a")) (setq char (chr 224) i (+ i 2))) 
                         ((AND (= (ascii char1) 227) (= char "a")) (setq char (chr 225) i (+ i 2))) 
                         ((AND (= (ascii char1) 228) (= char "a")) (setq char (chr 226) i (+ i 2))) 
                         
                         ((AND (= (ascii char1) 226) (= char "e")) (setq char (chr 227) i (+ i 2))) 
                         ((AND (= (ascii char1) 225) (= char "e")) (setq char (chr 228) i (+ i 2))) 
                         ((AND (= (ascii char1) 224) (= char "e")) (setq char (chr 229) i (+ i 2))) 
                         ((AND (= (ascii char1) 229) (= char "e")) (setq char (chr 230) i (+ i 2))) 
                         ((AND (= (ascii char1) 227) (= char "e")) (setq char (chr 231) i (+ i 2))) 
                         ((AND (= (ascii char1) 228) (= char "e")) (setq char (chr 232) i (+ i 2))) 
                         
                         ((AND (= (ascii char1) 226) (= char "o")) (setq char (chr 233) i (+ i 2))) 
                         ((AND (= (ascii char1) 225) (= char "o")) (setq char (chr 234) i (+ i 2))) 
                         ((AND (= (ascii char1) 224) (= char "o")) (setq char (chr 235) i (+ i 2))) 
                         ((AND (= (ascii char1) 229) (= char "o")) (setq char (chr 236) i (+ i 2))) 
                         ((AND (= (ascii char1) 227) (= char "o")) (setq char (chr 237) i (+ i 2))) 
                         ((AND (= (ascii char1) 228) (= char "o")) (setq char (chr 238) i (+ i 2))) 
                         
                         ((AND (= (ascii char1) 249) (= char "")) (setq char (chr 240) i (+ i 2))) 
                         ((AND (= (ascii char1) 248) (= char "")) (setq char (chr 241) i (+ i 2))) 
                         ((AND (= (ascii char1) 251) (= char "")) (setq char (chr 242) i (+ i 2))) 
                         ((AND (= (ascii char1) 245) (= char "")) (setq char (chr 243) i (+ i 2))) 
                         ((AND (= (ascii char1) 239) (= char "")) (setq char (chr 244) i (+ i 2))) 
                         
                         ((AND (= (ascii char1) 249) (= char "")) (setq char (chr 246) i (+ i 2))) 
                         ((AND (= (ascii char1) 248) (= char "")) (setq char (chr 247) i (+ i 2))) 
                         ((AND (= (ascii char1) 251) (= char "")) (setq char (chr 248) i (+ i 2))) 
                         ((AND (= (ascii char1) 245) (= char "")) (setq char (chr 249) i (+ i 2))) 
                         ((AND (= (ascii char1) 239) (= char "")) (setq char (chr 250) i (+ i 2))) 
                         
                         ((AND (= (ascii char1) 249) (= char "y")) (setq char (chr 251) i (+ i 2))) 
                         ((AND (= (ascii char1) 248) (= char "y")) (setq char (chr 252) i (+ i 2))) 
                         ((AND (= (ascii char1) 251) (= char "y")) (setq char (chr 253) i (+ i 2))) 
                         ((AND (= (ascii char1) 245) (= char "y")) (setq char (chr 254) i (+ i 2))) 
                         
                         ((= char "") (setq char (chr 125) i (+ i 1)))
                         ((= char "") (setq char (chr 127) i (+ i 1)))
                         ((= char "")  (setq char (chr 138) i (+ i 1)))
                         ((= char "")  (setq char (chr 139) i (+ i 1)))
                         ((= char "")  (setq char (chr 140) i (+ i 1)))
                         ((= char "")  (setq char (chr 141) i (+ i 1)))
                         ((= char "")  (setq char (chr 142) i (+ i 1)))
                         ((= char "") (setq char (chr 177) i (+ i 1)))
                         ((= char "") (setq char (chr 183) i (+ i 1)))
                         ((= char "") (setq char (chr 189) i (+ i 1)))
                         ((= char "") (setq char (chr 200) i (+ i 1)))
                         ((= char "") (setq char (chr 201) i (+ i 1)))
                         ((= char "") (setq char (chr 202) i (+ i 1)))
                         ((= char "") (setq char (chr 203) i (+ i 1)))
                         ((= char "") (setq char (chr 204) i (+ i 1)))
                         ((= char "") (setq char (chr 239) i (+ i 1)))
                         ((= char "") (setq char (chr 245) i (+ i 1)))
                         ((= char "") (setq char (chr 238) i (+ i 1)))
                         
                         ((setq i (+ i 1)))
                    );cond
                    (setq txt1 (strcat txt1 char))
               );repeat
          );progn
     ) ;if
     (setq #txt txt1) 
);defun ChangeCode
;-------------------------------------------------------------------
(prompt "\n ChCase: Change case")
(defun c:chcase ( / code ssl)
     (Text_get)
     (setq code (getint "\nCode <BK1=2/VNI=3>: "))
     (setq ssl (sslength #sset))
     
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl)))
                    ed (entget temp)
                    old (cons 1 (DXF 1 ed))
                    #txt (DXF 1 ed)
               )
               ( ChangeCase Code)
               (setq new (cons 1 #txt)
                    ed (subst new old ed)
               )
          )
          (entmod ed)  
     )
     (princ)
);defun
;-------------------------------------------------------------------
(defun ChangeCase ( code )
(setq txt1 "")
     (setq len (strlen #txt))
     (setq i 1)
     
     (if (= Code 3);   VNI
          (progn
               (repeat len
                    (setq char (substr #txt i 1))
                    (cond
                         ((= (ascii char) 125) (setq char ""))
                         
                         ((= (ascii char) 123) (setq char "Y")) 
                     );cond
              );repeat
         );progn
     );if
           
