; Text utilities by Trong Le NT- May 26, 1998
(prompt "\nL O A D I N G    T E X T _ U T I . L S P")

;------------------------------------------------------------------
(defun UKWORD (bit kwd msg def / inp)
     (if (and def (/= def ""))
          (setq msg (strcat "\n" msg "<" def ">: ")
               bit (* 2 (fix (/ bit 2)))
          )
          (if (= " " (substr msg (strlen msg) 1))
               (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
               (setq msg (strcat "\n" msg ": "))
          )
     )
     (initget bit kwd)
     (setq inp (getkword msg))
     (if inp inp def)
)
;------------------------------------------------------------------
(defun USTR (bit msg def spflag / inp nval)
     (if (and def (/= def ""))
          (setq msg (strcat "\n" msg "<" def ">: ")
               inp (getstring spflag msg)
               inp (if (= inp "") def inp)
          )
          (progn
               (if (= " " (substr msg (strlen msg) 1))
                    (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
                    (setq msg (strcat "\n" msg ": "))
               )
               (if (= bit 1)
                    (while (= "" (setq inp (getstring spflag msg)))
                         (prompt "\nInvalid String.")
                    )
                    (setq inp (getstring spflag msg))
               )
          )
     )
     inp
)
;------------------------------------------------------------------
(defun ETOS (arg / file)
     (if (= 'STR (type arg)) (setq arg (strcat "\"" arg "\"")))
     (setq file (open "TL" "w"))
     (princ arg file)
     (close file)
     (setq file (open "TL" "r"))
     (setq arg (read-line file))
     (close file)
     (close (open "TL" "w"))
     arg
)  
;------------------------------------------------------------------
(defun DXF (code elist)
     (cdr (assoc code elist))
)
;-------------------------------------------------------------
(defun Text_get ( / ssl  nsset temp ed )
     (setq #sset (ssget))
     (setq ssl (sslength #sset) 
           nsset (ssadd)
     )
     (print ssl)
     (princ "entities found. ")  
     (princ "\nVerifying the selected entities -- please wait. ")
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl))))
               (setq ed (entget temp))
               (if (= (DXF 0 ed) "TEXT") (ssadd temp nsset))
          )
     )
     (setq ssl (sslength nsset)
          #sset nsset
     )
     (print ssl)
     (princ "TEXT entities found. ")
     (princ)
);defun Text_get
;-------------------------------------------------------------
(prompt "\nCT2, CT22, CT5, TUP : To change TEXT to "2" or "5" style")

(defun c:CT2( / ssl temp new old ed )
     (Text_get)
     (if (= scale nil) (setq scale (getreal "\nInput current scale : ")))
     (setq ssl (sslength #sset))
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl)))
                    ed (entget temp)
                    old (cons 40 (DXF 40 ed))
                    size (* 2 scale)
                    new (cons 40 size)
                    ed (subst new old ed)
                    
                    old (cons 7 (DXF 7 ed))
                    new (cons 7 "2")
                    ed (subst new old ed)
               )
               (entmod ed)  
          )
     )
     (princ)
);defun
;-------------------------------------------------------------
(defun c:CT22( / ssl temp new old ed )
     (Text_get)
     (if (= scale nil) (setq scale (getreal "\nInput current scale : ")))
     (setq ssl (sslength #sset))
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl)))
                    ed (entget temp)
                    old (cons 40 (DXF 40 ed))
                    size (* 2 scale)
                    new (cons 40 size)
                    ed (subst new old ed)
                    
                    old (cons 7 (DXF 7 ed))
                    new (cons 7 "22")
                    ed (subst new old ed)
               )
               (entmod ed)  
          )
     )
     (princ)
);defun

;-------------------------------------------------------------
(defun c:CT5( / ssl temp new old ed )
     (Text_get)
     (if (= scale nil) (setq scale (getreal "\nInput current scale : ")))
     (setq ssl (sslength #sset))
     
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl)))
                    ed (entget temp)
                    old (cons 40 (DXF 40 ed))
                    size (* 4 scale)
                    new (cons 40 size)
                    ed (subst new old ed)
                    
                    old (cons 7 (DXF 7 ed))
                    new (cons 7 "5")
                    ed (subst new old ed)
               )
               (entmod ed)  
          )
     )
     (princ)
);defun
;-------------------------------------------------------------------
(defun c:TUP( / ssl temp ed old new )
     (Text_get)
     (if (= scale nil) (setq scale (getreal "\nInput current scale : ")))
     (setq ssl (sslength #sset))
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl))))
               
               (setq ed (entget temp))
               (setq STYLE (DXF 7 ed))
               
               (if (OR (= STYLE "55") (= STYLE "5") (= STYLE "5T"))
                    (progn
                         (setq old (cons 40 (DXF 40 ed))
                              size (* 4 scale)
                              new (cons 40 size)
                              ed (subst new old ed)
                         )
                    )
               )  
               (if (OR (= STYLE "2") (= STYLE "22"))
                    (progn
                         (setq old (cons 40 (DXF 40 ed))
                              size (* 2 scale)
                              new (cons 40 size)
                              ed (subst new old ed)
                         )
                    )
               )  
               (entmod ed) 
          )
     )
     (princ)
);defun
;-------------------------------------------------------------------
(prompt "\n ChCase: Change case")
(defun c:chcase ( / code ssl)
     (Text_get)
     (setq code (getint "\nCode <BK1=2/VNI=3>: "))
     (setq ssl (sslength #sset))
     
     (while (> ssl 0)
          (progn
               (setq temp (ssname #sset (setq ssl (1- ssl)))
                    ed (entget temp)
                    old (cons 1 (DXF 1 ed))
                    #txt (DXF 1 ed)
               )
               ( ChangeCase Code)
               (setq new (cons 1 #txt)
                    ed (subst new old ed)
               )
          )
          (entmod ed)  
     )
     (princ)
);defun
;-------------------------------------------------------------------
(defun ChangeCase ( code )
     (setq txt1 "")
     (setq len (strlen #txt))
     (setq i 1)
     (if (= Code 3);   VNI
          (progn
               (repeat len
                    (setq char (substr #txt i 1))
                    (if (OR (AND  (> (ascii char) 96) (< (ascii char) 123)) (AND (> (ascii char) 223) (< (ascii char) 253)) ) 
                                    (setq char (chr (- (ascii char) 32)))
                    )
                    (setq txt1 (strcat txt1 char))
                    (setq i (+ i 1))
              );repeat
         );progn
     );if
     (if (= Code 2);   BK1
          (progn
               (repeat len
                    (setq char (substr #txt i 1))
                    ( cond
                         ((AND  (> (ascii char) 96) (< (ascii char) 123)) (setq char (chr (- (ascii char) 32))))
                         ((= (ascii char) 222) (setq char (chr 126)))
                         ((= (ascii char) 189) (setq char (chr 125)))
                         ((= (ascii char) 251) (setq char (chr 123)))
                         ((= (ascii char) 252) (setq char (chr 94)))
                         ((= (ascii char) 253) (setq char (chr 96)))
                         ((= (ascii char) 254) (setq char (chr 124)))
                         ((= (ascii char) 255) (setq char (chr 127)))
                         ((> (ascii char) 188) (setq char (chr (- (ascii char) 62))))
                    );cond
                    (setq txt1 (strcat txt1 char))
                    (setq i (+ i 1))
              );repeat
         );progn
     );if
     (setq #txt txt1) 
);defun
;-------------------------------------------------------------------
(prompt "\nATEXT: Add something in front of text ")
(defun c:atxt ( / ssl ed No new temp old )
  (Text_get)
  (setq str (getstring "\nAdd what: "))
  (setq ssl (sslength #sset))

  (while (> ssl 0)
    (progn
      (setq temp (ssname #sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
      (setq old (cons 1 (DXF 1 ed)))
      (setq No (DXF 1 ed))
      (setq No (strcat str No))
      (setq new (cons 1 No))
      (setq ed (subst new old ed))
      (entmod ed)  
    )
  )
)
;-----------------------------------------------------------
(prompt "\n CHNO to +-*/ text entities with a number")
(defun c:CHNO ( / No temp ed old new acc fac operator ssl )
  (Text_get)
  (setq operator (getstring "\nInput operator (+ - * /):"))
  (setq fac (getreal "\nInput a number:"))
  (setq acc (getint "\nAccuracy:"))
  (setq DZ (getvar "DIMZIN"))
  (setvar "DIMZIN" 0)
  (setq ssl (sslength #sset))

  (while (> ssl 0)
    (progn
      (setq temp (ssname #sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
      (setq old (cons 1 (DXF 1 ed)))

      (setq No (atof (DXF 1 ed)))
      (cond
         ((= operator "+") (setq No (+ No fac)))
         ((= operator "-") (setq No (- No fac)))
         ((= operator "*") (setq No (* No fac)))
         ((= operator "/") (setq No (/ No fac)))
      )
      (setq new (cons 1 (rtos No 2 acc)))
     
      (setq ed (subst new old ed))
      (entmod ed)  
    )
  )
(setvar "DIMZIN" DZ)
)
;-----------------------------------------------------------

(prompt "\n sub: subtract")
(defun c:sub ( / No ed1 ed2 pt No1 No2 )
  (setq txt1 (car (entsel "\nText 1 :")))
  (setq txt2 (car (entsel "\nText 2 :")))
  (setq pt (getpoint "\Pick point"))

  (setq DZ (getvar "DIMZIN"))
  (setvar "DIMZIN" 0)

  (setq ed1 (entget txt1))
  (setq ed2 (entget txt2))

  (setq No1 (atof (DXF 1 ed1)))
  (setq No2 (atof (DXF 1 ed2)))

  (setq no (- No1 No2))

  (command "TEXT" pt "" (rtos No 2 3))

  (setvar "DIMZIN" DZ)
)
;-----------------------------------------------------------
