(defun DXF (code elist)
  (cdr (assoc code elist))
)

(defun tlen ( / nsset en ed ssl)
  (if (= tl nil) (setq tl (getreal "Input current scale : ")))
  (setq llon 0.0)
  (setq ssl (sslength sset) 
        nsset (ssadd)
  )
  (print ssl)
  (princ "entities found. ")  
  (princ "\nVerifying the selected entities -- please wait. ")
  (while (> ssl 0)
    (progn
      (setq en (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget en))
      (if (OR (= (DXF 0 ed) "LINE") (= (DXF 0 ed) "ARC"))
         (ssadd en nsset)
      )
    )
  )
  (setq ssl (sslength nsset)
        sset nsset
  )
  (print ssl)
  (princ "Entities Found. ")


  (while (> ssl 0)
    (progn
      (setq en (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget en))
      (if (= (DXF 0 ed) "LINE") 
      (progn
        (setq lcon 0.0)
        (setq STAPT (dxf 10 ed)
              ENDPT (dxf 11 ed))
        (setq deltaX (abs (- (nth 0 STAPT) (nth 0 ENDPT))))
        (setq deltaY (abs (- (nth 1 STAPT) (nth 1 ENDPT))))
        (setq lcon (sqrt (+ (* deltaX deltaX) (* deltaY deltaY))))
        (setq  lcon (* tl lcon))
        (setq  llon (+ llon lcon))
      );progn
     );if LINE

    (if (= (DXF 0 ed) "ARC") 
      (progn
        (setq lcon 0.0)
        (setq radi (DXF 40 ed))
        (setq deltaAng (abs (- (DXF 51 ed) (DXF 50 ed))))
        (setq lcon (* deltaAng radi))
        (setq  lcon (* tl lcon))
        (setq  llon (+ llon lcon))
      );progn
   );if CIRCLE
 );progn
);while
(prompt (strcat "\nTotal length of selected entities : " (rtos llon 2 4)))
(princ)
);defun

(prompt "\nTOTAL: Calculate total length of ARC and LINE entities")
(defun c:total()
(setq sset (ssget))
(tlen)
)
