
;---------------------------------------------------------------
;---------------------------------------------------------------

(PROMPT "\NLOADING ACAD.LSP (2002) of Pham Ngoc Tuan ...")
(setvar "CMDECHO" 0)

(setq T2_H 3
	T2_W 0.7
	T3_H 3
	T3_W 1
	T5_H 5
	T5_W 1
	T7_H 10
	T7_W 1
)

(defun c:ccl ()
(setq a (getint "\n For Doing, For Plotting <1/0>"))
(if (= a 0)
  (command "-layer" 
          "c" 3 "0"
          "c" 2 "1"
          "c" 1 "2"
          "c" 5 "3"
          "c" 2 "4"
          "c" 2 "5"
	  ""
  )
  (command "-layer" 
          "c" 7 "0"
          "c" 1 "1"
          "c" 5 "2"
          "c" 3 "3"
          "c" 4 "4"
          "c" 6 "5"
	  ""
  )
)
)

(defun c:acc ()
(setq #acc (getint "\nDo Chinh Xac (Bao nhieu so thap phan) :"))
(setvar "DIMDEC" #ACC))

(SETQ #ACC 1)

(defun c:DWG ()
(setq pt (getpoint "\nPick point :"))
(setq name (getvar "DWGNAME"))
(command "TEXT" "J" "MC" pt "0" name)
)

(defun c:LTS()
(command "LTSCALE"))

(defun c:LAYO()
(command "LAYER" "N" "1" "C" "1" "1" "L" "CONTINUOUS" "1" "LW" "0.15" "1" "")
(command "LAYER" "N" "2" "C" "2" "2" "L" "CONTINUOUS" "2" "LW" "0.15" "2" "")
(command "LAYER" "N" "3" "C" "3" "3" "L" "GROUND" "3" "LW" "0.5" "3" "")
(command "LAYER" "N" "4" "C" "4" "4" "L" "HIDDEN2" "4" "LW" "0.35" "4" "")
(command "LAYER" "N" "5" "C" "5" "5" "L" "CONTINUOUS" "5" "LW" "0.1" "5" "")
(command "LAYER" "N" "6" "C" "6" "6" "L" "CONTINUOUS" "6" "LW" "0.2" "6" "")
(command "LAYER" "N" "8" "C" "8" "8" "L" "CENTER2" "8" "LW" "0.18" "8" "")
(command "LAYER" "N" "9" "C" "9" "9" "L" "CONTINUOUS" "9" "LW" "0.3" "9" "")
(command "LAYER" "N" "7" "C" "white" "7" "L" "CONTINUOUS" "7" "LW" "0.4" "7" ""))

(defun c:3p()
(command "UCS" "3p"))

(DEFUN C:WW() 
(COMMAND "ucs" "W"))

(DEFUN C:OO() 
(SETQ PT (GETPOINT "\nPICK (0,0) POINT"))
(COMMAND "ucs" "O" PT))

(DEFUN C:PU() 
(COMMAND "PURGE" "A" "" "N"))

(defun c:DTICH()
(LOAD "DTICH1.LSP"))

(defun c:TALUY()
(LOAD "TALUY.LSP")
)

(defun c:tinhtoan()
(LOAD "tinhtoan.LSP"))

(defun c:T2() (setvar "TEXTSTYLE" "2")
(command "DTEXT"))

(defun c:T3() (setvar "TEXTSTYLE" "3")
(command "DTEXT"))

(defun c:T5() (setvar "TEXTSTYLE" "5")
(command "DTEXT"))

(defun c:T7() (setvar "TEXTSTYLE" "7")
(command "DTEXT"))

(DEFUN C:CP() (COMMAND "COPYBASE"))

(defun c:IN() (setvar "OSMODE" 32))
(defun c:MID() (setvar "OSMODE" 2))
(defun c:EN() (setvar "OSMODE" 1))
(defun c:CEN() (setvar "OSMODE" 4))

(defun c:NO() (setvar "OSMODE" 0))
(defun c:OM() (setvar "OSMODE" 6207))

(defun c:endp() (setvar "OSMODE" 1))
(defun c:qua()  (setvar "OSMODE" 16))
(defun c:tan()  (setvar "OSMODE" 256))
(defun c:per()  (setvar "OSMODE" 128))
(defun c:ins()  (setvar "OSMODE" 64))
(defun c:nod()  (setvar "OSMODE" 8))
(defun c:nea()  (setvar "OSMODE" 512))
(defun c:int()  (setvar "OSMODE" 32))
(defun c:appint() (setvar "OSMODE" 2048))

(defun c:0() (command "LAYER" "T" "0" "S" "0" ""))
(defun c:1() (command "LAYER" "T" "1" "S" "1" ""))
(defun c:2() (command "LAYER" "T" "2" "S" "2" ""))
(defun c:3() (command "LAYER" "T" "3" "S" "3" ""))
(defun c:4() (command "LAYER" "T" "4" "S" "4" ""))
(defun c:5() (command "LAYER" "T" "5" "S" "5" ""))
(defun c:6() (command "LAYER" "T" "6" "S" "6" ""))
(defun c:7() (command "LAYER" "T" "7" "S" "7" ""))
(defun c:8() (command "LAYER" "T" "8" "S" "8" ""))
(defun c:9() (command "LAYER" "T" "9" "S" "9" ""))

(defun c:c0() (ssget) (command ".chprop" "p" "" "la" "0" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c1() (ssget) (command ".chprop" "p" "" "la" "1" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c2() (ssget) (command ".chprop" "p" "" "la" "2" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c3() (ssget) (command ".chprop" "p" "" "la" "3" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c4() (ssget) (command ".chprop" "p" "" "la" "4" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c5() (ssget) (command ".chprop" "p" "" "la" "5" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c6() (ssget) (command ".chprop" "p" "" "la" "6" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c7() (ssget) (command ".chprop" "p" "" "la" "7" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c8() (ssget) (command ".chprop" "p" "" "la" "8" "LT" "BYLAYER" "C" "BYLAYER" ""))
(defun c:c9() (ssget) (command ".chprop" "p" "" "la" "9" "LT" "BYLAYER" "C" "BYLAYER" ""))

(defun c:f0() (command "LAYER" "F" "0" ""))
(defun c:f1() (command "LAYER" "F" "1" ""))
(defun c:f2() (command "LAYER" "F" "2" ""))
(defun c:f3() (command "LAYER" "F" "3" ""))
(defun c:f4() (command "LAYER" "F" "4" ""))
(defun c:f5() (command "LAYER" "F" "5" ""))
(defun c:f6() (command "LAYER" "F" "6" ""))
(defun c:f7() (command "LAYER" "F" "7" ""))
(defun c:f8() (command "LAYER" "F" "8" ""))
(defun c:f9() (command "LAYER" "F" "9" ""))


(defun c:E() (command "ERASE"))
(defun c:EL() (command "ELLIPSE"))
(defun c:M() (command "MOVE"))
(defun c:L() (command "LINE"))
(defun c:PL() (command "PLINE"))
(defun c:R() (command "REDRAW"))
(defun c:A() (command "ARC"))
(defun c:CI() (command "CIRCLE"))
(defun c:C() (command "COPY"))
(defun c:PT() (command "POINT"))
(defun c:SC() (command "SCALE"))
(defun c:DT() (command "DTEXT"))
(defun c:MV() (command "MVIEW"))
(defun c:D() (command "DONUT"))
(defun c:SA() (command "QSAVE"))
(defun c:RE() (command "REGEN"))
(defun c:RO() (command "ROTATE"))
(defun c:REE() (command "RECTANG"))
(defun c:PE() (command "PEDIT"))
(defun c:QS() (command "PSPACE"))
(defun c:AS() (command "MSPACE"))
(defun c:O() (command "OFFSET"))
(defun c:CHR() (command "CHAMFER"))
(defun c:T() (command "TRIM"))
(defun c:F() (command "FILLET"))
(defun c:MI() 
(setvar "mirrtext" 0)
(command "MIRROR"))
(defun c:ZA() (command "ZOOM" "A"))
(defun c:ZE() (command ".ZOOM" "E"))
(defun c:Z1() (command ".ZOOM" "0.5x"))
(defun c:Zzz() (command ".ZOOM" "0.3x"))
(defun c:Zzzz() (command ".ZOOM" "0.5x"))
(defun c:Zzzzz() (command ".ZOOM" "0.5x"))
(defun c:Zz() (command ".ZOOM" "0.5x"))
(defun c:ZW() (command "ZOOM" "W"))
(defun c:ZQ() (command "ZOOM" "P"))
(defun c:ZD() (command "ZOOM" "D"))
(defun c:CH() (command "CHANGE"))
(defun c:CHP() (command "CHPROP"))
(defun c:XP() (command "EXPLODE"))
(defun c:LI() (command "LIST"))
(defun c:DI() (command "DIST"))
(defun c:ARR() (command "ARRAY"))
(defun c:II() (command "DDINSERT"))
(defun c:I() (command "INSERT"))
(defun c:B() (command "BLOCK"))
(defun c:WB() (command "WBLOCK"))
(defun c:VP() (command "VPOINT" "R"))
(defun c:X() (command "EXTEND"))
(defun c:S() (command "STRETCH" "C"))
(defun c:lo() (c:layon))
(defun c:ff() (c:layoff))
(defun c:tt() (c:extrim))
(defun c:ss() (c:MSTRETCH))
(defun c:fd() (command "find"))
;(defun c:fd() (c:find))
(defun c:bt() (c:btrim))
(defun c:bx() (c:bextend))
(defun c:mpe() (c:mpedit))
(defun c:lc() (c:laycur))
(defun c:ol() (c:layiso))
(defun c:lf() (c:layfrz))
(defun c:cb() (command "copybase"))
(defun c:le() (command "LENGTHEN" "DEL"))
(defun c:len() (command"LENGTHEN"))
(defun c:TM( / TILE)
 (setq TILE (getvar "TILEMODE")) 
 (if (= TILE 0)
    (progn
      (setvar "TILEMODE" 1)
    )      
    (progn
      (setvar "TILEMODE" 0)
    )
 );if
)
(defun c:ED() (command "DDEDIT"))
(defun c:UP() (command "DIM1" "UP"))
(defun c:DED() (command "DIM1" "NEW"))
(defun c:DM() (command "dim1" "tedit"))
(defun c:LEA() (command "dim1" "LEA"))
(defun c:EDD() (COMMAND "DDATTE"))
(defun c:MO()	(command "_properties"))
(defun c:A1() (command "PLINE" "0,0" "817,0" "817,570" "0,570" "c"))
(defun c:A2() (command "PLINE" "0,0" "570,0" "570,396" "0,396" "c"))
(defun c:A3() (command "PLINE" "0,0" "396,0" "396,273" "0,273" "c"))
(defun c:A4() (command "PLINE" "0,0" "198,0" "198,285" "0,285" "c"))
;*--------------------------------------------------------------------
(LOAD "Block_UTI.lsp")
(LOAD "DIM_Uti.lsp")
(LOAD "TEXT_UTI.lsp")
(LOAD "DRAW_UTI.lsp")

(princ)

;*--------------------------------------------------------------------
;(prompt "\n KT: To insert KHUNGTEN ")
(defun c:KT( / pt1)	
	(setq pt1 (getpoint "\nPick the insert point :"))
	(command "INSERT" "KT" pt1 "1" "1" "0")
	
);defun
;*--------------------------------------------------------------------
;(prompt "\n	dahoc : To insert Dahoc ")
(defun c:dahoc( / pt)
	(if (= scale nil)  (setq scale (getreal "\nInput current scale: ")))
	(setq pt (getpoint "\nPick the insert point :"))
        (command "INSERT" "dahoc" pt (* 1.6 scale) (* 1.6 scale) "0")
		
);defun
;*--------------------------------------------------------------------


;(prompt "\n	        B2,B3 : To insert BA block")
(defun c:B2()
	(if (= scale nil)  (setq scale (getreal "\nInput current scale: ")))
	
	(setq pt (getpoint "\nPick the insert point :"))
        (command "INSERT" "BA" pt scale scale "0")
		
);defun
;*--------------------------------------------------------------------
(defun c:B3()
	(if (= scale nil)  (setq scale (getreal "\nInput current scale: ")))
	
	(setq pt (getpoint "\nPick the insert point :"))
        (command "INSERT" "BA1" pt scale scale "0")
	;(setq #BA (chr (+ (ascii #BA1) 1)))
		
);defun
;*--------------------------------------------------------------------
(defun c:MT()
	(if (= scale nil)  (setq scale (getreal "\nInput current scale: ")))
	
	(setq pt1 (getpoint "\nPick the insert point :"))
        (setq pt2 (getpoint "\nPick the second point for rotate arrow :"))
	(setq ang (/ (* (angle pt1 pt2) 180) pi))
	(command "INSERT" "MT" pt1 (* 1.6 scale) (* 1.6 scale) ang)
);defun
;*--------------------------------------------------------------------
(defun c:FN( / fn last pt dtime yy mm dd h m ed new old newlay oldlay)
   ;(setq fn (getvar "dwgNAME"))
   (setq fN (getvar "SAVENAME"))
   (setq oLAST (getvar "OSMODE"))
   ;(setq fn (strcat FP fn))
   ;(setq fm (strcat "Ten file la :" fn))
   ;(princ fm)
   ;(princ "\n")
   (setq dat (getvar "cdate"))
   (setq date (rtos dat 2 8))
   ;(princ date)
   ;(princ "\n")
   (setq yy (substr date 3 2))
   (setq mm (substr date 5 2))
   (setq dd (substr date 7 2))
   (setq h (substr date 10 2))
   (setq m (substr date 12 2))
   (setq pt (getpoint "Diem viet ten file :"))
   ;(command "text" "style" "kt" pt "2" "0" fn)
   (setq dtime (strcat dd "/" mm "/" yy "-" h ":" m))
   (command "OSMODE" "0")
   (command "text" "style" "v2" "r" (list (- ( car pt) 1) (+ (cadr pt) 1)) "0" (strcat fn "-" dtime))
   (setq ed (entget (entlast)))
   (setq old (cons 40 (DXF 40 ed))
      new (cons 40 1.6)
      ed (subst new old ed)
   );setq
   (setq oldlay (cons 8 (DXF 8 ed))
      newlay (cons 8 "6")
      ed (subst newlay oldlay ed)
   );setq
   (entmod ed) 
   (princ)
   (command "OSMODE" OLAST)
   
);defun FN
;*--------------------------------------------------------------------
;*--------------------------------------------------------------------
