
(defun DXF (code elist)
  (cdr (assoc code elist))
)

;-------------------------------------------------------------
(defun t_u_ssget ( / ssl  nsset temp ed )
  (setq sset (ssget))
  (setq ssl (sslength sset) 
        nsset (ssadd)
  )
  (print ssl)
  (princ "entities found. ")  
  (princ "\nVerifying the selected entities -- please wait. ")
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
      (if (= (DXF 0 ed) "TEXT") (ssadd temp nsset))
    )
  )
  (setq ssl (sslength nsset)
        sset nsset
  )
  (print ssl)
  (princ "TEXT entities found. ")
  (princ)
);defun u_ssget

;-------------------------------------------------------------
(prompt "\nCT2, CT5, TUP : To change TEXT to "2" or "5" style")

(defun c:CT2( / sset ssl temp new old ed )
(t_u_ssget)
(if (= scale nil) (setq scale (getreal "\nInput current scale : ")))
(setq ssl (sslength sset))
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl)))
            ed (entget temp)
            old (cons 40 (DXF 40 ed))
            size (* 2 scale)
            new (cons 40 size)
            ed (subst new old ed)
      
            old (cons 7 (DXF 7 ed))
            new (cons 7 "22")
            ed (subst new old ed)
      )
      (entmod ed)  
    )
  )
 (princ)
);defun

;-------------------------------------------------------------
(defun c:CT5( / sset ssl temp new old ed )
(t_u_ssget)
(if (= scale nil) (setq scale (getreal "\nInput current scale : ")))
(setq ssl (sslength sset))

(while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl)))
            ed (entget temp)
            old (cons 40 (DXF 40 ed))
            size (* 5 scale)
            new (cons 40 size)
            ed (subst new old ed)

            old (cons 7 (DXF 7 ed))
            new (cons 7 "5")
            ed (subst new old ed)
      )
      (entmod ed)  
    )
  )
 (princ)
);defun

;-------------------------------------------------------------------
(defun c:TUP( / sset ssl temp ed old new )
(t_u_ssget)
(if (= scale nil) (setq scale (getreal "\nInput current scale : ")))
(setq ssl (sslength sset))
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))

      (setq ed (entget temp))
      (setq STYLE (DXF 7 ed))

      (if (OR (= STYLE "55") (= STYLE "5"))
         (progn
           (setq old (cons 40 (DXF 40 ed))
                 size (* 5 scale)
                 new (cons 40 size)
                 ed (subst new old ed)
           )
         )
      )  
      (if (OR (= STYLE "2") (= STYLE "22"))
         (progn
           (setq old (cons 40 (DXF 40 ed))
                 size (* 2 scale)
                 new (cons 40 size)
                 ed (subst new old ed)
           )
         )
      )  

      (entmod ed)  
    )
  )
 (princ)
);defun