
(setvar "cmdecho" 0)
(defun DXF (code elist)
   (cdr (assoc code elist))
)

;-------------------------------------------------------------------
(defun USTR (bit msg def spflag / inp nval)
  (if (and def (/= def ""))
    (setq msg (strcat "\n" msg "<" def ">: ")
          inp (getstring spflag msg)
          inp (if (= inp "") def inp)
    )
    (progn
      (if (= " " (substr msg (strlen msg) 1))
        (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": "))
        (setq msg (strcat "\n" msg ": "))
      )
      (if (= bit 1)
        (while (= "" (setq inp (getstring spflag msg)))
           (prompt "\nInvalid String.")
        )
        (setq inp (getstring spflag msg))
      )
    )
  )
  inp
)
;------------------------------------------------------------------
(Defun c:dhf( / pt X Y )
  (setq fn (getstring "\nInput Data file name: "))
  (setq file (open fn "w"))
  (write-line  "MC \t F \t Yc \t Xc \t Sx \t Sy \t Jx \t Jy"  file)
  (setq k 1)
  (setq name (ustr 0 "\nInput group name: " (rtos k 2 0) T))  
  (while (/= name "0")
        (setq Org (getpoint "\ninput point to origin ")) 
        (command "ucs" "O" Org)  
        (setq pt (getpoint "\n Select internal point"))
        (command "-boundary" pt "")
        (setq ed (entget (entlast)))  
        (command "erase" "l" "")
        (setq n 1)
        (while (< n (length ed))
          (if (= (car (nth n ed)) 10)
            (progn 
               (setq pt (nth n ed)) 
               (setq X (append X (list (cadr pt))))
               (setq Y (append Y (list (nth 2 pt))))
            ) 
          )
        (setq n (+ n 1))
      )
      (setq X (append X (list (car X))))
      (setq Y (append Y (list (car Y))))
      (setq F1 0.0
               X1 0.0
               y1 0.0  
              Jx1 0.0
              Jy1 0.0
              i 0
              j 1
     )
    (while (< j (length X))
         ;----------------------------------------------tinh dien tich
         (setq F1 (+ F1 (* (- (nth i X) (nth j X)) (+ (nth i Y) (nth j Y)))))
         ;----------------------------------------------Tinh toa do trong tam theo phuong y
         (setq y1 (+ y1 (* (- (nth i X) (nth j X)) (+ (expt (nth i Y) 2) (* (nth i Y) (nth j Y)) (expt (nth j Y) 2))))) 
         ;----------------------------------------------Tinh toa do trong tam theo phuong x
         (setq x1 (+ x1 (* (- (nth j Y) (nth i Y)) (+ (expt (nth i X) 2) (* (nth i X) (nth j X)) (expt (nth j X) 2))))) 
         ;----------------------------------------------Tinh mo men quan tinh theo phuong x
         (setq Jx1 (+ Jx1 (* (- (nth i X) (nth j X)) (+ (expt (nth i Y) 3) (* (expt (nth i Y) 2) (nth j Y)) (* (nth i Y) (expt (nth j Y) 2)) (expt (nth j Y) 3))))) 
         ;----------------------------------------------Tinh mo men quan tinh theo phuong y
         (setq Jy1 (+ Jy1 (* (- (nth J Y) (nth i Y)) (+ (expt (nth i X) 3) (* (expt (nth i X) 2) (nth j X)) (* (nth i X) (expt (nth j X) 2)) (expt (nth j X) 3)))))
         (setq i (+ i 1)
                  j (+ j 1)
         )
    ) 
    (setq pt2 (getvar "ucsorg"))
    (setq F (/ F1 2))
    (setq Yc2 (/ y1 (* 6 F)))  
    (setq Xc2 (/ x1 (* 6 F)))  
    (setq Yc  (- Yc2 (cadr pt2)))
    (setq Xc  (- Xc2 (car pt2)))
    (setq Sx (* Yc F))  
    (setq Sy (* Xc F))  
    (setq Jx (- (/ Jx1 12) (* (expt Yc2 2) F)))
    (setq Jy (- (/ Jy1 12) (* (expt Xc2 2) F)))
    (setq F (rtos F 2 4))
    (setq Yc (rtos Yc 2 4))
    (setq Xc (rtos Xc 2 4))
    (setq Sx (rtos Sx 2 4))
    (setq Sy (rtos Sy 2 4))
    (setq Jx (rtos Jx 2 4))
    (setq Jy (rtos Jy 2 4))
    (setq ki (rtos k 2 4))
    (write-line (strcat  ki "\t" F "\t" Yc "\t" Xc "\t" Sx "\t" Sy "\t" Jx "\t" Jy ) file)
    (setq X  nil)
    (setq Y nil ) 
    (setq k (+ 1 k))
    (setq name (ustr 0 "\nInput group name: " (rtos k 2 0) T))  
  )
(close file)
);defun
(prompt "\n Dhf : Tinh dac trung hinh hoc cua cac hnh da giac (khong tnh duoc cac hinh tao thanh tu mot phan la cac cung tron")





