(prompt "\nLoading CAD Utilities Written by NTTLe XD91CD Ver 1.1 ")
(prompt "\nThank you for using these utilities. Please donot change!")
;--------------------------------------------
(defun fopen ( fname mode msg / fh )
  (setq fh (open fname mode))
  (while (= fh nil)
    (progn
       (Prompt (strcat "\nFile " msg " Not Found !"))
       (setq fname (USTR 1 (strcat "\nInput " msg " Again : ") nil T)
             fh (open fname mode)
       ) 
    )
  )
  fh
)
;---------------------------------------------
(prompt "\n VE : Ve khung theo toa do cho san")
(defun c:VE()
  (setq fn (getstring "\nNhap Ten File So Lieu: ")
        fh (fopen fn "r" fn)
  )
  (setq SoNut (nth 0 (read (strcat "(" (read-line fh) ")")))
        SoPhanTu (nth 0 (read (strcat "(" (read-line fh) ")")))
        i 0
  )
  (while (< i SoNut)
     (progn
        (setq line (read (strcat "(" (read-line fh) ")")))
        (setq PT (list (nth 1 line) (nth 2 line) (nth 3 line)))
        (setq NODES (append NODES (list PT))
              i (+ 1 i)
        )
     )
  )
  (setq i 0)
  (while (< i SoPhanTu)
     (progn
        (setq line (read (strcat "(" (read-line fh) ")"))
              ELEMENTS (append ELEMENTS (list (list (nth 1 line) (nth 2 line)))) 
              i (+ 1 i)
        )
     )
  )
  (setq pt1 (nth 0 NODES))
  (setq str (read-line fh))
  (setq i 0)
  (command "LAYER" "M" "1" "C" "1" "1" "")
  (command "LAYER" "M" "2" "C" "2" "2" "")
  (while (< i SoPhanTu) 
     (progn
        (setq nutI (nth 0 (nth i ELEMENTS)))
        (setq pt (nth (- nutI 1) NODES))
        (setq nutK (nth 1 (nth i ELEMENTS)))
        (setq pt2 (nth (- nutK 1) NODES))
        (setq mid (list (/ (+ (car pt) (car pt2)) 2.0) 
                        (/ (+ (nth 1 pt) (nth 1 pt2)) 2.0)
                        (/ (+ (nth 2 pt) (nth 2 pt2)) 2.0)
                  )
        )
        (command "LAYER" "S" "0" "")
        (command "LINE" pt pt2 "")
        (command "LAYER" "S" "1" "")
        (command "TEXT" "J" "BR" pt "0" (rtos nutI 2 0))
        (command "TEXT" "J" "BR" pt2 "0" (rtos nutK 2 0))
        (command "LAYER" "S" "2" "")
        (command "TEXT" "J" "BC" mid "0" (rtos (+ i 1) 2 0))
        (setq i (+ 1 i))
     )
  ) 
  (close fh)
)

