(defun DXF (code elist)
  (cdr (assoc code elist))
)
;--------------------------------------------------------------------
(defun refined ( / nsset en ed ssl)
  (setq ssl (sslength sset) 
        nsset (ssadd)
  )
  (print ssl)
  (princ "entities found. ")  
  (princ "\nVerifying the selected entities -- please wait. ")
  (while (> ssl 0)
    (progn
      (setq en (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget en))
      (if (and (= (DXF 0 ed) "LWPOLYLINE") (= (dxf 90 ed) 2) (= (abs (dxf 42 ed)) 1))       
         (ssadd en nsset)
      )
    )
  )
  (setq ssl (sslength nsset)
        sset nsset
  )
  (print ssl)
  (princ "\nEntities Found. ")
  (setq nd (getreal "\nInput new diameter:"))

  (while (> ssl 0)
    (progn
      (setq en (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget en))     
            (setq old1 (nth 12 ed))
            (setq old2 (nth 16 ed))            
            (setq old3 (nth 9 ed))
            (setq center (/ (+ (cadr old2) (cadr old1)) 2))                           
            (setq ne12 (- center (/ nd 4)))  
            (setq ne22 (+ center (/ nd 4)))  
            (setq new1 (cons (car old1) (list ne12 (nth 2 old1))))  
            (setq new2 (cons (car old2) (list ne22 (nth 2 old2))))  
            (setq new3 (cons (car old3) (/ nd 2)))                
            (setq ed (subst new1 old1 ed))
            (setq ed (subst new2 old2 ed))
            (setq ed (subst new3 old3 ed))
            (entmod ed)  

 );progn
);while
);defun
;---------------------------------------------------------------------
(prompt "\nCHD: Change diameter of donut")
(defun c:chd()
(setq sset (ssget))
(refined)
)
