
(defun DXF (code elist)
  (cdr (assoc code elist))
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun u_ssget ( / ssl  nsset temp ed )
  (setq sset (ssget))
  (setq ssl (sslength sset) 
        nsset (ssadd)
  )
  (print ssl)
  (princ "entities found. ")  
  (princ "\nVerifying the selected entities -- please wait. ")
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
      (if (= (DXF 0 ed) "DIMENSION") (ssadd temp nsset))
    )
  )
  (setq ssl (sslength nsset)
        sset nsset
  )
  (print ssl)
  (princ "DIMENSION entities found. ")
  (princ)
);defun u_ssget

;-----------------------------------------------------------------

(prompt "\nDUP : To change DIMENSION to its original properties")

(defun c:DUP( / sset ssl temp ed old new )
(u_ssget)
(setq ssl (sslength sset))
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))

      (setq ed (entget temp))
      (setq old (cons 1 (DXF 1 ed)))
      (setq new (cons 1 ""))
      (setq ed (subst new old ed))

      (setq old (cons 70 (DXF 70 ed)))
      (setq new (cons 70 0))
      (setq ed (subst new old ed))

      (entmod ed)  
    )
  )
 (princ)
);defun

;-----------------------------------------------------------------

(prompt "\nDCL : To change ALL DIMENSIONS to Layer 1")

(defun c:DCL ( / sset ssl temp ed old new )
(u_ssget)
(setq ssl (sslength sset))
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))

      (setq ed (entget temp))
      (setq old (cons 8 (DXF 8 ed)))
      (setq new (cons 8 "1"))
      (setq ed (subst new old ed))

      (entmod ed)  
    )
  )
 (princ)
);defun
