(SETVAR "CMDECHO" 0)
(setq OSMODE (getvar "OSMODE"))
(setvar "OSMODE" 0)
(setvar "COORDS" 0)
;--------------------------------------------------------------------
(defun round (number accuracy)
  (atof (rtos number 2 accuracy))
)
;--------------------------------------------------------------------
(defun DXF (code elist)
  (cdr (assoc code elist))
)
;--------------------------------------------------------------------
(defun RAD (degree)
  (setq radian (/ (* degree PI) 180))
  radian
)
;--------------------------------------------------------------------
(defun DEG (Rad)
  (setq degree (/ (* rad 180) PI))
  degree
)
;--------------------------------------------------------------------
(defun ETOS (arg / file)
  (if (= 'STR (type arg)) (setq arg (strcat "\"" arg "\"")))
  (setq file (open "$" "w"))
  (princ arg file)
  (close file)
  (setq file (open "$" "r"))
  (setq arg (read-line file))
  (close file)
  (close (open "$" "w"))
  arg
)  
;--------------------------------------------------------------------
(defun fopen ( fname mode msg / fh )
  (setq fh (open fname mode))
  (defun *error* (msg)
     (princ msg)
     (princ)
  )
  (while (= fh nil)
    (progn
       (Prompt (strcat "\nFile " msg " Not Found !"))
       (setq fname (USTR 1 (strcat "\nInput " msg " Again : ") nil T)
             fh (open fname mode)
       ) 
    )
  )
  fh
)
;--------------------------------------------------------------------
(defun c:pre ( / fhout fhin str strtemp TenCoc lst KC_le CDTN CDTK
CDTKNS TNNS CDTKList TNlist fh tga count dem tana KC11 KC1 CD11 CD1 KC22 KC2 
CD22 CD2 Sin Sout dataf KCCD )
  (defun *error* (msg)
     (princ msg)
     (princ)
  )
  (setq fhin (fopen fin "r" fin)
        KCCD 0
        str (read-line fhin)
  )
  (while (/= str nil)
     (progn
        (setq strtemp (strcat "(" str ")")
              lst (read strtemp)
              TenCoc (nth 0 lst)
              KC_le (nth 1 lst)
              CDTN (nth 2 lst)
              CDTK (nth 3 lst)
              KCCD (+ KCCD KC_le)
        )
        (if (/= (type CDTK) 'SYM) (setq CDTKList (append CDTKList (list (list KCCD CDTK)))))
        (if (/= (type CDTN) 'SYM) (setq TNList (append TNList (list (list KCCD CDTN)))))
        (setq str (read-line fhin))
     )
  )
  (close fhin)
  (setq fh (fopen fin "r" fin)
        fhout (fopen fout "w" fout)
        Sin (read-line fh)
        KCCD 0
        KC2 0
        KC22 0
        count 0
        dem 0
  )
  (while (/= Sin nil)
     (progn
        (setq strtemp (strcat "(" Sin ")" )
              lst (read strtemp)
              TenCoc (nth 0 lst)
              KC_le (nth 1 lst)
              KCCD (+ KCCD KC_le)
        )
        (if (AND (>= KCCD KC2) (/= (nth (+ 1 count) CDTKList) nil))
           (setq KC1 (nth 0 (nth count CDTKList))
                 CD1 (nth 1 (nth count CDTKList))
                 KC2 (nth 0 (nth (+ 1 count) CDTKList))
                 CD2 (nth 1 (nth (+ 1 count) CDTKList))
                 tga (/ (float (- CD1 CD2)) (float(- KC1 KC2)))
                 count (+ 1 count)
           )
        )

        (if (AND (>= KCCD KC22) (/= (nth (+ 1 dem) TNList) nil))
           (setq KC11 (nth 0 (nth dem TNList))
                 CD11 (nth 1 (nth dem TNList))
                 KC22 (nth 0 (nth (+ 1 dem) TNList))
                 CD22 (nth 1 (nth (+ 1 dem) TNList))
                 tana (/ (float (- CD11 CD22)) (float(- KC11 KC22)))
                 dem (+ 1 dem)
           )
        )

       (setq CDTKNS (+ CD1 (* tga (- KCCD KC1)))
             TNNS (+ CD11 (* tana (- KCCD KC11)))
             Sout (strcat (etos TENCOC) "\t" (etos KC_le) "\t" 
                          (etos KCCD) "\t" (etos (round TNNS 2)) "\t" (etos (round CDTKNS 2))) 
       )
       (write-line Sout fhout)
       (setq Sin (read-line fh))
       (prompt ".")      
    )
  )
  (close fh)
  (close fhout)
)
;--------------------------------------------------------------------
(defun c:td ( / fhandle str KCCD TenCoc KC_le CDTN CDTK strtemp lst CDTC
x TENCOC_PT KCCD_PT KC_LE_PT CDTN_PT CDTK_PT CDTC_PT PT_TN PT_TK PT1 PT2 
fhandle n count PT i TK_list TN_list )
  (defun *error* (msg)
     (princ msg)
     (princ)
  )
  (setq fhandle (fopen fout "r" fout)
        str (read-line fhandle)
        KCCD 0
  )
  (prompt "\n Cho 1 chut \n Dang Ve")
  (while (/= str nil)
     (progn
        ( setq strtemp (strcat "(" str ")" )
               lst (read strtemp)
               TenCoc (nth 0 lst)
               KC_le (nth 1 lst)
               KC_le_PT (list (+ KCCD (/ KC_le 2.0)) (- 0 (* H_scale 37.5)))
               KCCD (nth 2 lst)
               CDTN (nth 3 lst)
               CDTK (nth 4 lst)
               Tencoc_pt (list KCCD (- 0 (* H_scale 57.5)))
               KCCD_PT (list KCCD (- 0 (* H_scale 47.5)))
               CDTN_PT (list KCCD (- 0 (* H_scale 27.5)))
               CDTK_PT (list KCCD (- 0 (* H_scale 12.5)))
               pt1 (list KCCD (- 0 (* H_scale 35.0)))
               pt2 (list KCCD (* H_scale V_origin))
               ptTN (list KCCD (* (- CDTN V_origin) (/ H_scale V_scale)))
               ptTK (list KCCD (* (- CDTK V_origin) (/ H_scale V_scale)))   
               TN_list (append (list ptTN) TN_list)
               TK_list (append (list ptTK) TK_list)
        )
        (command "TEXT" "J" "MC" Tencoc_PT "0" (etos TenCoc))
        (command "TEXT" "J" "MC" KCCD_PT "90" (rtos KCCD 2 acc_KC))
        (command "TEXT" "J" "MC" KC_le_PT "0" (rtos KC_le 2 acc_KC))
        (command "TEXT" "J" "MC" CDTN_PT "90" (rtos CDTN 2 acc_CD))
        (command "TEXT" "J" "MC" CDTK_PT "90" (rtos CDTK 2 acc_CD))
        (command "LINE" pt1 (polar pt1 (- 0 (/ PI 2)) (* H_scale 5)) "")
        (command "LINE" pt2 ptTN "") 
 
        (setq str (read-line fhandle))
     )
  )
  (close fhandle)
  (setq len (length TK_list))
  (setq i 0)
  (command "PLINE")
  (while (< i len)
    (progn
      (setq pt (nth i TN_list))
      (command pt)
      (setq i (+ i 1))
    )
  )
  (command "")
  (setq i 0)
  (command "PLINE")
  (while (< i len)
    (progn
      (setq pt (nth i TK_list))
      (command pt)
      (setq i (+ i 1))
    )
  )
  (command "")

  (setq pt1 (list (- 0 (* H_scale 60.0)) (- 0 (* H_scale 5.0))))
  (setq pt2 (list (- 0 (* H_scale 60.0)) (- 0 (* H_scale 20.0))))
  (setq pt3 (list (- 0 (* H_scale 60.0)) (- 0 (* H_scale 35.0))))
  (setq pt4 (list (- 0 (* H_scale 60.0)) (- 0 (* H_scale 40.0))))
  (setq pt5 (list (- 0 (* H_scale 60.0)) (- 0 (* H_scale 55.0))))
  (setq pt6 (list (- 0 (* H_scale 60.0)) (- 0 (* H_scale 60.0))))
  
  (command "LINE" pt1 (polar pt1 0 (+ KCCD (* H_scale 60.0))) "")
  (command "LINE" pt2 (polar pt2 0 (+ KCCD (* H_scale 60.0))) "")
  (command "LINE" pt3 (polar pt3 0 (+ KCCD (* H_scale 60.0))) "")
  (command "LINE" pt4 (polar pt4 0 (+ KCCD (* H_scale 60.0))) "")
  (command "LINE" pt5 (polar pt5 0 (+ KCCD (* H_scale 60.0))) "")
  (command "LINE" pt6 (polar pt6 0 (+ KCCD (* H_scale 60.0))) "")
  (command "LINE" pt6 pt1 "")
  (command "LINE" (polar pt1 0 (+ KCCD (* H_scale 60.0))) 
                  (polar pt6 0 (+ KCCD (* H_scale 60.0))) "")
  (command "TEXT" "J" "ML" (list (- 0 (* H_scale 50.0)) (- 0 (* H_scale 12.5)))
                  0 "CAO } THIT K")

  (command "TEXT" "J" "ML" (list (- 0 (* H_scale 50.0)) (- 0 (* H_scale 27.5)))
                  0 "CAO } T NHIN")

  (command "TEXT" "J" "ML" (list (- 0 (* H_scale 50.0)) (- 0 (* H_scale 37.5)))
                  0 "KHONG CCH L")

  (command "TEXT" "J" "ML" (list (- 0 (* H_scale 50.0)) (- 0 (* H_scale 47.5)))
                  0 "KHONG CCH CNG DN")

  (command "TEXT" "J" "ML" (list (- 0 (* H_scale 50.0)) (- 0 (* H_scale 57.5)))
                  0 "TN CC")
)
;--------------------------------------------------------------------
(defun c:Input ()
  (setq fin (getstring "\n Nhap Ten File Du Lieu :") 
        fout (getstring "\n Nhap Ten File Ket Qua :") 
        H_scale (getreal "\n Nhap Ti Le Ngang :")
        V_scale (getreal "\n Nhap Ti Le Dung :")
        V_origin (getreal "\n Goc Cao Do :")
        acc_CD (getint "\n Do Chinh Xac Cua Cao Do :") 
        acc_KC (getint "\n Do Chinh Xac Cua Khoang Cach :") 
  )
)
;--------------------------------------------------------------------
(defun c:tracdoc()
  (defun *error* (msg)
     (princ msg)
     (princ)
  )
  (SETVAR "cmdecho" 0)
  (SETQ DZIN (GETVAR "DIMZIN"))
  (SETVAR "DIMZIN" 0)
  (c:input)
  (c:pre)
  (c:td)
  (SETVAR "DIMZIN" DZIN)
)