(defun DXF (code elist)
  (cdr (assoc code elist))
);dxf

(defun c:ARR(/ dtl dtcon pt1 pt2 ss et oslast vsize)
  (if (= tl nil) (progn
    (setq tl (getreal "\nDrawing scale : "))
    (setq ntl (/ 1000 tl))
    (setq tl2 (* ntl ntl))
    )
  )
  (setq dtl 0)
  (setq ss (ssadd))
  (setq oslast (getvar "OSMODE"))
  (command "osnap" "")
  (print)
  (print)
  (setq pt1 (getpoint "\nPick internal point : "))
  (while (/= pt1 nil)
    (command "-boundary" pt1 "")
    (setq et (entlast))
    (ssadd et ss)
    (command "area" "e" "last")
    (setq vsize ( /(getvar "VIEWSIZE") 5))
    (command "hatch" "ANSI31" vsize "0" "last" "")
    (setq et (entlast))
    (ssadd et ss)
    (setq dtcon (/ (getvar "AREA") tl2))
    (setq dtl (+ dtcon dtl))
    (prompt (strcat "\nComponent area : " (rtos dtcon 2 4)))
    (print)
    (print)
    (setq pt1 (getpoint "\nPick internal point : "))
  )
  (command "setvar" "OSMODE" oslast)
  (command "erase" ss "")
  (setq ss nil)
  (command "redraw")
  (setq dtl (/ dtl 2))
  (print)
  (prompt (strcat "\nHaft total area : " (rtos dtl 2 4)))
  (print)
  (setq pt2 (getpoint "\nPoint to write: "))
  (if (/= 0 (DXF 40 (tblsearch "STYLE" (getvar "TEXTSTYLE"))))
    (command "text" pt2  "0" (strcat (rtos dtl 2 2) " M2"))
    (command "text" pt2 "2" "0" (strcat (rtos dtl 2 2) " M2" ))
  );if
  (princ)
);defun ARR
(prompt "\n Start with ARR to calculate area by pick points method")
(prompt "\n This version was improved by N.Q.C - 02nd Feb. 1998")
(princ)
