
(defun DXF (code elist)
  (cdr (assoc code elist))
)

(defun refine1 ( / nsset temp ed )
  (setq ssl   (sslength sset); 
        nsset (ssadd)
  )
  (print ssl)
  (princ "entities found. ")  
  (princ "\nVerifying the selected entities -- please wait. ")
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
      (if (= (DXF 0 ed) "TEXT")             
        (progn
         (if (/= (TYPE (READ (DXF 1 ed))) 'SYM) 
           (ssadd temp nsset)  
         )
        ) 
      )        
    )
  )
  (setq ssl (sslength nsset)
        sset nsset
  )
  (print ssl)
  (princ "text entities found. ")
  (princ "\n play " )
  (setq PT (getstring "\n Input operator (+,-,*,/): "))
  (setq tl (getreal "\n Input number: ")) 
  (setq ac (getint "\n Input accuracy: ")) 
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
      (setq old (cons 1 (DXF 1 ed)))
      (setq No (atof (DXF 1 ed)))       
      (cond    
            ((= PT "+") (setq No (+ No tl)))
            ((= PT "-") (setq No (- No tl)))
            ((= PT "*") (setq No (* No tl)))
            ((= PT "/") (setq No (/ No tl)))
      )      
      (setq new (cons 1 (rtos No 2 ac)))          
      (setq ed (subst new old ed))

      (entmod ed)  
    )
  )
)

(defun c:CNo()
(setq sset (ssget))
(setq last (getvar "dimzin"))
(setvar "dimzin" 0)
(refine1)
(setvar "dimzin" last)
)
