// Next available MSG number is    16 
// MODULE_ID APPLOAD_DCL_
/* Next available MSG number is  16 */

//----------------------------------------------------------------------------
//
//   APPLOAD.DCL   Version 13.0
//
//   Copyright 1991, 1992, 1993, 1994, 1996 by Autodesk, Inc.
//
//     Permission to use, copy, modify, and distribute this software
//     for any purpose and without fee is hereby granted, provided
//     that the above copyright notice appears in all copies and
//     that both that copyright notice and the limited warranty and
//     restricted rights notice below appear in all supporting
//     documentation.
//
//     AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
//     AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
//     MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.
//     DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
//     UNINTERRUPTED OR ERROR FREE.
//
//     Use, duplication, or disclosure by the U.S. Government is subject to
//     restrictions set forth in FAR 52.227-19 (Commercial Computer
//     Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
//     (Rights in Technical Data and Computer Software), as applicable.
//
//.  
//----------------------------------------------------------------------------
//
//    APPLOAD.DCL - Dialogue definitions for APPLOAD.LSP 
//
//----------------------------------------------------------------------------

//dcl_settings : default_dcl_settings { audit_level = 3; }

appload : dialog        {
        aspect_ratio = 0;
        label = "Load AutoLISP, ADS, and ARX Files";
        : row {
            : column {
                   : list_box {
                       label = "Files to Load" ;
                 mnemonic = "i";
                       key = "fp_list";
                       width =  50;
                       height = 10;
                       multiple_select = true;
                   }
             }
          : column {
              spacer_1;
                 : button {
                  label = "File...";
                  key = "add_to_list";
                  mnemonic = "F";
              }
                    : button {
                        label = "Remove" ;
                           key   = "remove_item" ;
                  mnemonic = "R";
                        }
                    : toggle {
                        label = "Save List" ;
                           key   = "save_list" ;
                  mnemonic = "S";
                        }
               spacer_1;
                }
     }
     spacer_1;
     : row {
         spacer_1;
         : button {
             label = "Load";
             key = "load";
             fixed_width     = true;
             width           = 8;
             alignment = centered;
             mnemonic = "L";
         }
         : button {
             label = "Unload";
             key = "unload";
             fixed_width     = true;
             width           = 8;
             alignment = centered;
             mnemonic = "U";
         }
         : button {
             label = "Exit";
             key = "cancel";
             fixed_width     = true;
             width           = 8;
             alignment = centered;
             is_cancel       = true;
             mnemonic = "E";
         }
         help_button;
         spacer_1;
     }
        errtile;
}


