// Next available MSG number is    13 
// MODULE_ID DDVPOINT_DCL_
/* Next available MSG number is  13 */

//----------------------------------------------------------------------------
//
//     ddvpoint.dcl   
//
//     Copyright 1992, 1994, 1996 by Autodesk, Inc.
//
//     Permission to use, copy, modify, and distribute this software
//     for any purpose and without fee is hereby granted, provided
//     that the above copyright notice appears in all copies and
//     that both that copyright notice and the limited warranty and
//     restricted rights notice below appear in all supporting
//     documentation.
//
//     AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
//     AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
//     MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.
//     DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
//     UNINTERRUPTED OR ERROR FREE.
//
//     Use, duplication, or disclosure by the U.S. Government is subject to
//     restrictions set forth in FAR 52.227-19 (Commercial Computer
//     Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
//     (Rights in Technical Data and Computer Software), as applicable.
//
//.
//----------------------------------------------------------------------------
//
//  Ddvpoint.dcl - 3D View direction specification tool
//
//----------------------------------------------------------------------------


//dcl_settings : default_dcl_settings { audit_level = 3; }

ddvpoint : dialog {
  aspect_ratio = 0;
  label        = "Viewpoint Presets";
  fixed_height = true;
  fixed_width  = true;
  : column {
    : row {
      : text {
        label = "Set Viewing Angles";
        key   = "ddvp_header";
      }
    }
    : row {
      : radio_row {
        : radio_button {
          label    = "Absolute to WCS";
          key      = "ddvp_abs_wcs";
          mnemonic = "W";
          value    = "1";
        }
        : radio_button {
          label    = "Relative to UCS";
          key      = "ddvp_rel_ucs";
          mnemonic = "U";
        }
      }
    }
    : row {
      fixed_width = true;
      fixed_height = true;
      : image_button {
        alignment = top;
        fixed_width = true;
        fixed_height = true;
        key    = "ddvp_image";
        width  = 39;
        height = 12;
        color  = 0;
        is_tab_stop = false;
      }
    }
    : row {
      : edit_box {
        label       = "From:  X Axis:";
        mnemonic    = "A";
        key         = "ddvp_val_x";
        fixed_width = true;
        edit_width  = 6;
      }
      : edit_box {
        label       = "XY Plane:";
        mnemonic    = "P";
        key         = "ddvp_val_xyp";
        fixed_width = true;
        edit_width  = 6;
      }
    }
    : row {
      : button {
        label = "Set to Plan View";
        key   = "ddvp_set_plan";
        mnemonic = "V";
      }
    }
  }
  spacer_1;
  ok_cancel_help_errtile;
}
