
(defun DXF (code elist)
  (cdr (assoc code elist))
)

(defun refine ( / nsset temp ed )
  (setq ssl   (sslength sset); 
        nsset (ssadd)
  )
  (print ssl)
  (princ "entities found. ")  
  (princ "\nVerifying the selected entities -- please wait. ")
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
      (if (= (DXF 0 ed) "TEXT")
        (progn
          (if (/= (TYPE (READ (DXF 1 ed))) 'SYM) 
            (ssadd temp nsset)
          )
        )
      )
    )
  )
  (setq ssl (sslength nsset)
        sset nsset
  )
  (print ssl)
  (princ "text entities found. ")
  (princ "\n" )
  (if (= tl nil) (setq tl (getreal "\n Input scale: ")))
  (command "OSMODE" "33")
  (setq lcat (getdist "Length of sand bottom :"))
  (setq ntl (/ 1000 tl))
  (setq lcat (/ lcat ntl))
  (setq Scat (* 0.15 lcat))


  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
      (setq old (cons 1 (DXF 1 ed)))
      (setq No (atof (DXF 1 ed)))
      (setq No (+ No Scat))
      (setq new (cons 1 (rtos No 2 2)))
      (setq ed (subst new old ed))

      (setq old (cons 8 (DXF 8 ed)))
      (setq new (cons 8 "100"))
      (setq ed (subst new old ed))

      (entmod ed)  
    )
  )
)

(defun c:cc()
(setq sset (ssget))
(refine)
(princ)
)
