(defun C:COC()
  (if (= Ty_le nil) (progn
    (setq Ty_le (getreal "\nDrawing scale : "))
    (setq he_so (/ 1000 Ty_le))
    (setq he_so2 (* he_so he_so))
    )
  )
  (setq oslast (getvar "OSMODE"))
  (setq lalast (getvar "CLAYER"))
  (initget 1 " Trai Phai")
  (setq Ben (getkword "Ghi ben nao (Trai hay Phai) : "))
  (if (= Ben "Trai") (setq K_ben 1) (setq K_ben -1))
  (setvar "OSMODE" 37)
  (command "layer" "s" "Coc" "")
  (setq L0 50 Dist 20)
  (setq R (getreal "\nBan kinh cong : "))
  (if (/= R nil) (setq R (* R he_so) R1 (* R 2)))
  (setq Dist (* Dist he_so))
  (if (/= R nil) (setq Dist (* (* R (sin (/ Dist R1))) 2)))
  (setq L1 (- L0 10) L2 (+ L0 2))
  (setq pt0 (getpoint "\nTu diem : "))
  (setq L (getreal "\nCu ly le : "))
  (setq L (* L he_so))
  (if (/= R nil) (setq L (* (* R (sin (/ L R1))) 2)))
  (command "circle" pt0 L)
  (setq en (entlast))
  (setvar "OSMODE" 37)
  (setq pt1 (getpoint "\nDiem : "))
  (while (/= pt1 nil)
    (setvar "OSMODE" 0)
    (setq Ten (getstring "\nTen coc : "))
    (setq x0 (car pt0) y0 (cadr pt0))
    (command "erase" en "")
    (setq x1 (car pt1) y1 (cadr pt1))
    (setq uh (- x1 x0) vh (- y1 y0))
    (if (= R nil)
      (progn
        (setq dl (distance pt0 pt1))
        (setq u3 (- 0 (/ vh dl)) v3 (/ uh dl))
      )
      (progn
        (setq pt2 (osnap pt1 "center"))
        (setq R (distance pt1 pt2))
        (setq u3 (/ (- (car pt2) x1) R) v3 (/ (- (cadr pt2) y1) R))
        (setq s (- (* uh v3) (* vh u3)))
        (if (< s 0) (setq u3 (- 0 u3) v3 (- 0 v3)))
      )
    )
    (setq u3 (* K_ben u3) v3 (* K_ben v3))
    (command "circle" pt1 0.5)
    (setq u0 (+ x1 (* L0 u3)) v0 (+ y1 (* L0 v3)))
    (setq u1 (+ x1 (* L1 u3)) v1 (+ y1 (* L1 v3)))
    (setq u2 (+ x1 (* L2 u3)) v2 (+ y1 (* L2 v3)))
    (command "line" (list u0 v0) (list u1 v1) "")
    (setq s3 (* v3 (* K_ben -5)) t3 (* u3 (* K_ben 5)))
    (setq s2 (- u2 s3) t2 (- v2 t3))
    (setq s0 (- u0 s3) t0 (- v0 t3))
    (setq s1 (+ u0 s3) t1 (+ v0 t3))
    (command "line" (list s0 t0) (list s1 t1) "")
    (command "text" "m" (list u2 v2) 2 (list s2 t2) Ten)
    (setq pt0 pt1)
    (command "circle" pt0 Dist)
    (setq en (entlast))
    (setvar "OSMODE" 37)
    (setq pt1 (getpoint "\nDiem : "))
  )
  (command "erase" en "")
  (setvar "OSMODE" oslast)
  (setvar "CLAYER" lalast)
)
