(defun X2T (elist)   
   (car (cadr (textbox elist )))
)
;----------------------------------------
(defun DXF (code elist)
   (cdr (assoc code elist))
)

;-------------------------------------------------------------
(defun c2_u_ssget ( / ssl nsset temp ed  edmin namemin)
   (setq sset (ssget))
   (setq ssl (sslength sset) 
      nsset (ssadd)
   )
   (print ssl)
   (princ "entities found. ")  
   (princ "\nVerifying the selected entities -- please wait. ")
   (while (> ssl 0)
      (progn
         (setq temp (ssname sset (setq ssl (1- ssl))))
         (setq ed (entget temp))
         (if (= (DXF 0 ed) "TEXT") (ssadd temp nsset))
      )
   )
   (setq ssl (sslength nsset)
      sset nsset
      nsset (ssadd)
   )
   (while (/= (sslength sset) 0)                 ;SAP XEP DOI TUONG
      (setq temp  (ssname sset 0))
      (setq namemin temp )
      (setq edmin (entget namemin))
      (while (> ssl 0)
         (progn
            (setq temp (ssname sset (setq ssl (1- ssl))))
            (setq ed (entget temp))
            (if (<= (cadr (DXF 10 ed)) (cadr (DXF 10 edmin )) ) 
               (progn
                  (setq namemin temp)
                  (setq edmin (entget namemin))               
               )
            ) 
         )
      )
      (ssadd namemin nsset)
      (ssdel namemin sset)
      (setq ssl (sslength sset))
   )
   (setq ssl (sslength nsset)
      sset nsset
      nsset (ssadd)
   )
   (print ssl)
   (princ "TEXT entities found. ")
   (princ)
);defun u_ssget

;-------------------------------------------------------------
(defun c:opt ( / sset ssl temp ed)
   (c2_u_ssget)
  (setq fn (getstring "\nInput Data file name: "))
  (setq f (open fn "w"))
   (setq ssl (sslength sset))       
   (while (> ssl 0)
      (progn 
         (setq temp (ssname sset (setq ssl (1- ssl)))
            ed (entget temp)
         )
          (write-line (dxf 1 ed) f)
      )
    )
 (close f)
   (princ)
);defun
