// Next available MSG number is     6 
// MODULE_ID DDRENAME_DCL_
/* Next available MSG number is   9 */

//----------------------------------------------------------------------------
//
//   DDRENAME.DCL   Version 1.0
//
//     Copyright 1991, 1992, 1993, 1994, 1996 by Autodesk, Inc.
//
//     Permission to use, copy, modify, and distribute this software
//     for any purpose and without fee is hereby granted, provided
//     that the above copyright notice appears in all copies and
//     that both that copyright notice and the limited warranty and
//     restricted rights notice below appear in all supporting
//     documentation.
//
//     AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
//     AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
//     MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.
//     DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
//     UNINTERRUPTED OR ERROR FREE.
//
//     Use, duplication, or disclosure by the U.S. Government is subject to
//     restrictions set forth in FAR 52.227-19 (Commercial Computer
//     Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
//     (Rights in Technical Data and Computer Software), as applicable.
//
//.  
//----------------------------------------------------------------------------
// 
// Corresponding dialogue for DDRENAME.LSP which is an AutoLISP implementation
// of the AutoCAD Rename command with wildcard support and a dialogue
// interface.
// 
//----------------------------------------------------------------------------

//dcl_settings : default_dcl_settings { audit_level = 3; }


ddrename : dialog {
    label = "Rename";
    : row {
        : column {
            : list_box {
                label = "Named Objects";
                key = "tables";
                width = 17;
                height = 8;
            }
        }
        : column {
            : list_box {
                label = "&Items";
                key = "table_items";
				alignment = right;
				fixed_width = true;
                width = 35;
                height = 8;
                multiple_select = true;
            }
        }
    }
    : column {
        : row {
			: text {
		        label = "&Old Name:";
			}
	        : edit_box { 
			    key = "old";
				alignment = right;
				fixed_width = true;
				edit_width = 33;
				edit_limit = 217;
			}
		}
        : row {
            : button {
                label = "&Rename To:";
                key = "rename";
            }
            : edit_box { 
                label = "";
                key = "new";
				alignment = right;
				fixed_width = true;
                edit_width = 33;
				edit_limit = 217;
            }
        }
    }
    spacer_1;
    ok_cancel_help_errtile;
}
