/* debug setting */
/*dcl_settings : default_dcl_settings { audit_level = 2;}
*/

/* New available ID for Language is 149 */

/* prototypes for ok... buttons */

my_ok_button : column {
        :ok_button
        {
          /* LANGID 1 */
          label = "  OK  ";
        }
}


my_cancel_button : column {
        :cancel_button
        {
          /* LANGID 2 */
          label = "Cancel";
        }
}

my_about_button :retirement_button {
            /* LANGID 3 */
            label = "About...";
            key="about_button";
}

my_yes_button : retirement_button {
        /* LANGID 4 */
        label = "  YES  ";
        key   = "yes";
        is_default = true;
}

my_no_button : retirement_button {
        /* LANGID 5 */
        label = "  NO  ";
        key   = "no";
}


my_close_button :column {
        :ok_button
        {
          /* LANGID 6 */
          label = "Close";
        }

}


my_help_button :column {
        :help_button
        {
          /* LANGID 7 */
          label = "Help...";
        }

}
 

my_ok_only : column {
    fixed_width = true;
    alignment = centered;
    :my_ok_button {
        is_cancel = true;
    }
}


my_close_help :column {
    : row {
        fixed_width = true;
        alignment = centered;
        my_close_button;
        : spacer { width = 2; }
        my_help_button;
        
    }
}

my_ok_cancel_help : column {
    : row {
        fixed_width = true;
        alignment = centered;
        my_ok_button;
        : spacer { width = 2; }
        my_cancel_button;
        : spacer { width = 2; }
        my_help_button;
    }
}

my_ok_cancel_about_help : column {
    :row {
        my_ok_button;
        : spacer { width = 2; }
        my_cancel_button;
        : spacer { width = 2; }
        my_help_button;
        : spacer { width = 2; }
        my_about_button;
    }
}

my_ok_cancel : column {
    : row {
        fixed_width = true;
        alignment = centered;
        my_ok_button;
        : spacer { width = 2; }
        my_cancel_button;
    }
}



my_yes_no_cancel : column {
    : row {
        fixed_width = true;
        alignment = centered;
        my_yes_button;
        : spacer { width = 2; }
        my_no_button;
        : spacer { width = 2; }
        my_cancel_button;
        : spacer { width = 2; }
        my_help_button;
    }
}


/* main interface screens */

main : dialog 
{
    /* LANGID 8 */
    label = "Oc Configuration Manager";
    :column 
    {
    	children_alignment=top;          
        :boxed_column 
        {
            /* LANGID 17 */
            label = "Settings:";
            key="settings_set";
            :row	 
            {
			  	spacer_1;
		        :column
				{
                    :toggle 
    	            {
    	                key = "rcf_toggle";
    	                /* LANGID 126 */
    	                label = "Remote control header";
    	                value = "0";
    	            }
	                :boxed_column 
	                {
	                	fixed_width = true;
	                    fixed_height = true;
                        /* LANGID 18 */
                        label = "C&opies";
	                    key="copies_set";
						:row 
						{
                            :spacer{width=4;}          
	                     	:edit_box 
	                     	{
	                       		key = "copies";
	                       		edit_width = 3;
	                       		edit_limit = 3;
	                       		value = "1";
	                       		alignment = centered;
	                     	}
                            :spacer{width=6;}          

						}
						spacer_1;
	            	}
	                :boxed_radio_column 
	                {
	                	key = "color_mode_radio";
	                    fixed_width = true;
                        /* LANGID 136 */
                        label = "P&lot colors";
	                    value = "color";
	                    :radio_button 
	                    {
                            /* LANGID 20 */
                            label = "Color";
	                        key  = "color";
	                    }
	                    :radio_button 
	                    {
                            /* LANGID 134 */
                            label = "Grayscale ";
	                        key  = "grey_scale";
	                    }
	                    :radio_button 
	                    {
                            /* LANGID 135 */
                            label = "Black and White";
	                        key  = "monochrome";
	                    }
	             	}
			 	}
	            :column 
	            {
	           		:boxed_radio_column  
	           		{
                        /* LANGID 22 */
                        label="Media sa&ver";
	                   	key="media_saver_radio";                   
	                   	value="bypass_radio";
	                   	:radio_button 
	                   	{
	                     	key="bypass_radio";
                            /* LANGID 23 */
                            label="bypass";
	                   	}  
	                   	:radio_button 
	                   	{
	                     	key="machine_radio";
                            /* LANGID 24 */
                            label="machine mode";
	                   	}  
	               	}
	               	spacer_1;
	               	:boxed_column 
	               	{
                        /* LANGID 25 */
                        label="Plot &quality";
	                   	key="quality_set";
	                   	:popup_list 
	                   	{
	                    	key="quality_list";
	                   	}
	                   	spacer_1;
	               	}
	               	spacer_1;
	               	:boxed_column 
	               	{
    	               	:toggle 
    	               	{
    	               		key = "poster_toggle";
                            /* LANGID 148 */
                            label = "Poster mode";
    	                   	value = "0";
    	               	}
    		           	spacer_1;
    	               	:toggle 
    	               	{
    	               		key = "longplot_toggle";
                            /* LANGID 26 */
                            label = "Long plot mode";
    	                   	value = "0";
    	               	}
	               	    spacer_1;
		           	}
		           	spacer_1;
	          	}
	            spacer_1;
	            spacer_1;
		    	:column 
		    	{
	        	    fixed_height=true;
		            children_alignment=centered;
			  	    spacer_1;
		            :button 
		            {
		            	key = "pens_button";
                        /* LANGID 27 */
                        label = "P&ens...";
		            }
			  	    spacer_1;
		            :button 
		            {
		               	key = "transform_button";
                        /* LANGID 28 */
                        label = "&Transform...";
		            }
			  	    spacer_1;
		            :button 
		            {
		               	key = "finishing_button";
                        /* LANGID 29 */
                        label = "&Finishing...";
		           	}
			  	    spacer_1;
		            :button 
		            {
		            	key = "media_button";
                        /* LANGID 30 */
                        label = "&Media...";
		            } 
			  	    spacer_1;
		            :button 
		            {
		             	key = "labeling_button";
                        /* LANGID 31 */
                        label = "&Labeling...";
		            }
			  	    spacer_1;
		            :button 
		            {
		              	key = "stamping_button";
                        /* LANGID 32 */
                        label = "&Stamping...";
		      	    }    
			  	    spacer_1;
		        }
			}
		    spacer_1;
		}
	}
    :column 
    {
        :row 
        {
               	my_ok_cancel_about_help;  
        }
  	}
}
     

save_as : dialog {
     /* LANGID 33 */
     label = "Save as";
     fixed_width=true;
     initial_focus="save_edit";
     :text {
        width = 45;
        key="save_as_text";
     }
     :edit_box {
        edit_with = 45;
        edit_limit = 40;
        key="save_edit"; 
        allow_accept=true;
     }

     :boxed_row {
        my_ok_cancel_help;
     }

}

import_as : dialog {
     /* LANGID 34 */
     label = "Import as";
     fixed_width=true;
     initial_focus="save_edit";
     :text {
        width = 45;
        key="save_as_text";
     }
     :edit_box {
        edit_with = 45;
        edit_limit = 40;
        key="save_edit"; 
        allow_accept=true;
     }

     :boxed_row {
        my_ok_cancel_help;
     }

}

ok_cancel_show : dialog {
  /* LANGID 35 */
  label="Dialog";
  :text {
    key = "ok_cancel_show_text1";
    width = 50;
  }
  :text {
    key = "ok_cancel_show_text2";
    width = 50;
  }
  my_ok_cancel_help; 
}


yes_no_cancel_show : dialog {
  /* LANGID 36 */
  label="Dialog";
  :text {
    key = "yes_no_cancel_show_text1";
    width = 50;
  }
  :text {
    key = "yes_no_cancel_show_text2";
    width = 50;
  }
  my_yes_no_cancel;
}

about_screen : dialog {
    children_alignment=centered;
    fixed_width=true;
    /* LANGID 37 */
    label="About";
    :text {
      key = "title1_text";
      width=35;
    }
    :text {
      key = "title2_text";
    }
    :text {
      key = "version_text";
    }
    :text {
      key = "copyright_text";
    }
    spacer_1;
    my_ok_button;

}


error : dialog {
  :text {
    key = "error_text";
    width = 80;
  }

  my_ok_only;
}

transform : dialog {
        /* LANGID 38 */
        label = "Transformation";
        :column{
         spacer_1;
         :boxed_radio_row {
           key="rotation_radio";
           /* LANGID 39 */
           label="&Rotation (counter clockwise):";
           value="zero_degree";
           :radio_button {
              key="zero_degree";
              /* LANGID 40 */
              label="0";
           }
           :radio_button {
              key="90_degree";
              /* LANGID 41 */
              label="90";
           }
           :radio_button {
              key="180_degree";
              /* LANGID 42 */
              label="180";
           }
           :radio_button {
              key="270_degree";
              /* LANGID 43 */
              label="270";
           }
           :radio_button {
              key="productive";
              /* LANGID 44 */
              label="Productive";
           }
           :radio_button {
              key="folding";
              /* LANGID 45 */
              label="Folding";
           }
         }
        spacer_1;
        :row {
         fixed_width = true;
            :boxed_column {
               fixed_width=true;
               /* LANGID 46 */
               label="&Origin";
               key="origin_set";
               :popup_list {
                   key="origin_list";
                   edit_width=12;        

               }
               spacer_1;
            }
            :boxed_column {
               /* LANGID 47 */
               label = "&Mirror";
               key="mirror_set";
               :popup_list {
                   key = "mirror_list";
                   edit_width = 12; 
               }
               spacer_1;
            }
        }
        spacer_1;
        :boxed_column {
         /* LANGID 48 */
         label="&Scaling";
         key="scaling_set";
         :row {
            :popup_list {
               key="scaling_list";
               edit_width = 20;
            }
            spacer_1;
            :edit_box {
               key = "xscale";
               /* LANGID 49 */
               label = "X:";
               edit_width = 5;
               edit_limit = 6;
            }
            :text {
               /* LANGID 50 */
               label = "%";
               key = "scalextext";
            }
            :edit_box {
               key = "yscale";
               /* LANGID 51 */
               label = "Y:";
               edit_width = 5;
               edit_limit = 6;
            }
            :text {
               /* LANGID 52 */
               label = "%";
               key = "scaleytext";
            }
          }
          spacer_1;
        }
        spacer_1;
        :toggle {
          key="scale_pen_toggle";
          /* LANGID 53 */
          label="Scale &pen widths";
          value="0";
        }
        spacer_1;
        :boxed_row {
          my_ok_cancel_help;
          
        }
       }
}

/* MONOCHROME pens_mono */
pens_mono : dialog {
             /* LANGID 54 */
             label = "Pens (monochrome mode only)";
             :column{
               spacer_1;
               :boxed_column {
                  :row {
                    :text {
                     /* LANGID 55 */
                     label="Pen"; /*8*/
                     key="pen_text";
                     width=16;
                    }
                    :text {
                     /* LANGID 56 */
                     label="Pattern"; /*9*/
                     key="pattern_text";
                     width=9;
                    }
                    :text {
                     /* LANGID 57 */
                     label="Status"; /*9*/
                     key="status_text";
                     width=9;
                    }
                    :text {
                     /* LANGID 58 */
                     label="Transp."; /*9*/
                     key="transp_text";
                     width=9;
                    }
                  }
                  :list_box {
                     key="pen_list";
                     multiple_select=false;
                     tabs="1 14 25 36 45";
                     fixed_width=true;
                     width=56;
                     fixed_height=true;
                     height=7;
                  }
                  :row {
                    :column {
                      :edit_box {
                        key="from_edit";
                        /* LANGID 60 */
                        label="&From:";
                        edit_width=3;
                        edit_limit=3;
                      }
                      :edit_box {
                        key="to_edit";
                        /* LANGID 61 */
                        label="&To:";
                        edit_width=3;
                        edit_limit=3;
                      }

                    }
                    :popup_list {
                        key="pattern_list";
                        edit_width=5;
                    }
                    :popup_list {
                        key="status_list";
                        edit_width=10;
                    }
                    :popup_list {
                        key="transparency_list";
                    }
                  }
                  spacer_1;
                  :row {
                    :button {
                        key="insert_button";
                        /* LANGID 62 */
                        label="&Insert"; 
                    }
                    :button {
                        key="remove_button";
                        /* LANGID 63 */
                        label="&Remove"; 
                    }
                  }
                  spacer_1;
                }
              }
              :boxed_radio_row {
                   key = "transparency";
                   fixed_width = true;
                   /* LANGID 137 */
                   label = "C&olor merge control";
                   value = "overlay";
                   :radio_button {
                       /* LANGID 138 */
                       label = "Overlay";
                       key  = "overlay";
                   }
                   :radio_button {
                       /* LANGID 139 */
                       label = "Merge";
                       key  = "merge";
                   }
              }
              spacer_0;
              :boxed_row {
               my_ok_cancel_help;

              }
            
}

/* COLOR */
pens_color : dialog {
             /* LANGID 67 */
             label = "Pens  (color mode only)";
             :column{
              :boxed_column {
                  :row {
                    :text {
                     /* LANGID 68 */
                     label="Pen"; /*8*/
                     key="pen_text";
                     width=15;
                    }
                    :text {
                     /* LANGID 69 */
                     label="Color"; /*9*/
                     key="color_text";
                     width=16;
                    }
                    :text {
                     /* LANGID 70 */
                     label="Transp."; /*9*/
                     key="transp_text";
                     width=8;
                    }
                  }
                  :list_box {
                     key="pen_list";
                     multiple_select=false;
                     tabs="1 15 26 37";
                     fixed_width=true;
                     width=49;
                     fixed_height=true;
                     height=7;
                  }
                  :row {
                    :column {
                        fixed_width=true;
                      :edit_box {
                        key="from_edit";
                        /* LANGID 72 */
                        label="&From:";
                        edit_width=3;
                        edit_limit=3;
                      }
                      :edit_box {
                        key="to_edit";
                        /* LANGID 73 */
                        label="&To:";
                        edit_width=3;
                        edit_limit=3;
                      }

                    }
					:column {
                    	:button {
                        	key="color_button";
                        	/* LANGID 140 */
                        	label="&Color"; 
                    	}
						:image {
		        			key = "cur_color";
		        			height = 1;
							width = 10;
	            		}
					}
                    spacer_1;
                    :popup_list {
                        key="transparency_list";
                    }
                  }
                  spacer_1;
                  :row {
                    :button {
                        key="insert_button";
                        /* LANGID 74 */
                        label="&Insert"; 
                    }
                    :button {
                        key="remove_button";
                        /* LANGID 75 */
                        label="&Remove"; 
                    }
                  }
                  spacer_1;
                }
               :row {   
               :boxed_radio_row {
                   key = "transparency";
                   fixed_width = true;
                   /* LANGID 137 */
                   label = "C&olor merge control";
                   value = "overlay";
                   :radio_button {
                       /* LANGID 138 */
                       label = "Overlay";
                       key  = "overlay";
                   }
                   :radio_button {
                       /* LANGID 139 */
                       label = "Merge";
                       key  = "merge";
                   }
               }
              }
              spacer_0;
              :boxed_row {
               my_ok_cancel_help;

              }
            }
    
}

labeling : dialog {
            /* LANGID 82 */
            label="Labeling";
            :column {       
              spacer_1;
              :boxed_row {
                :toggle {
                 key="labeling_toggle";
                 /* LANGID 83 */
                 label="&Add plot label";
                 value="0";
                }
              }
              spacer_1;
              :boxed_column {             
                key="composed_column";
                /* LANGID 84 */
                label="&Composed of";
                :toggle {
                   key="name_toggle";
                   /* LANGID 85 */
                   label="Drawing name";
                }
                :toggle {
                   key="time_toggle";
                   /* LANGID 86 */
                   label="Time";
                }
                :edit_box {
                   key="comment_edit";
                   /* LANGID 87 */
                   label="Comment:";
                   edit_width=20;
                   edit_limit=20;
                   fixed_width=true;
                }
                spacer_1;
              }
              :boxed_row {
               my_ok_cancel_help;

              }

             }
}

media : dialog 
{
    /* LANGID 88 */
    label="Media";
    :column 
    {
        children_fixed_width=true;
        spacer_1;
        :row
        {
            :popup_list 
            {
                key="format_list";
                /* LANGID 89 */
                label="&Paper format:";
                edit_width=11;
            }
            spacer_1;
            spacer_1;
            :toggle 
            {
                key="media_auto_toggle";
                /* LANGID 128 */
                label="Auto";
            }
        }
        spacer_1;
       :popup_list 
        {
            key="media_list";
            /* LANGID 90 */
            label="&Media type:";
            edit_width=12;
        }
        spacer_1;
        :popup_list 
        {
            key="feed_list";
            /* LANGID 91 */
            label="Paper &feed:";
            edit_width=12;
        }
        spacer_1;
        :popup_list 
        {
            key="rollover_list";
            /* LANGID 92 */
            label="&If exact format unavailable:";
            edit_width=17;
        }
        spacer_1;
    }
    :boxed_row 
    {
        my_ok_cancel_help;
    }
} 


finishing : dialog 
{
    /* LANGID 93 */
    label="Finishing";
    :row 
    {
        children_alignment=top;
        :boxed_radio_row 
        {
            key="folding_radio";
            /* LANGID 141 */
            label="&Folding";
            value="no_folding";
            :radio_button 
            {
                key="no_folding";
                /* LANGID 142 */
                label="None";
            }
            :radio_button 
            {
                key="full_folding";
                /* LANGID 143 */
                label="Full";
            }
            :radio_button 
            {
                key="first_fold_only";
                /* LANGID 144 */
                label="First fold only";
            }
        }
		:boxed_column 
		{
			/* LANGID 146 */
			label="P&unching";
			:toggle 
			{
				key="punching_toggle";
				/* LANGID 147 */
				label="Punching";
			}
		}
		:boxed_column 
		{
			/* LANGID 97 */
			label="Folding &method";
			key="method_set";
			:popup_list 
			{
				key="method_list";
			}
			spacer_1;
		}
    }
    :row 
    {
        children_alignment=top;
        :boxed_column 
        {
            /* LANGID 98 */
            label="&Binding edge";
            key="binding_edge_set";

            :row
            {
                :toggle 
                {
                    key="binding_edge_toggle";
                    /* LANGID 99 */
                    label="&activate";
                    value="0";
                }
                :edit_box 
                {
                    fixed_width=true;
                    /* LANGID 127 */
    		        label=" ";
                    key="binding_edge_edit";
                    edit_width=6;
                    edit_limit=6;
                }
                :text_part 
                {
    		        key="binding_edge_unit_text";
    			    width=3;
    			    value="mm";
    		    }  
            }
			spacer_1;
        }
        :boxed_column 
        {
            fixed_height=true;
            key="orientation_set";
            /* LANGID 100 */
            label="Fold &orientation";
            :popup_list 
            {
                key="orientation_list";
            } 
            spacer_1;
        }             
    }
    :boxed_column 
    {
        /* LANGID 101 */
        label="Fold &packet";
        key="folding_lw_set";
        :column 
        {
	        :row 
	        {
	            :edit_box 
	            {
	                key="fold_length_edit";
                    /* LANGID 102 */
                    label="Length:";
	                edit_limit=6;
	                edit_width=6;
	            }
	            :text_part 
	            {
				    key="fold_length_unit_text";
				    value="inch";
			    }
		        spacer_1;
	            :edit_box 
	            {
	                key="fold_width_edit";
                    /* LANGID 103 */
                    label="Width:";
	                edit_limit=6;
	                edit_width=6;
	            }
	            :text_part 
	            {
				    key="fold_width_unit_text";
				    value="inch";
			    }
		    }
        }
        spacer_1;
    }
    :row 
    {
        :boxed_column 
        {
            /* LANGID 104 */
            label="&Delivery";
            key="deposit_set";

            :row
            {
                :popup_list
                {
                    key="deposit_list";
                    /* LANGID 132 */
                    label="Folded";
                    edit_width=10;
                }
                spacer_1;
                :popup_list
                {
                    key="deposit_unfold_list";
                    /* LANGID 130 */
                    label="Not folded";
                    edit_width=15;
                }
                spacer_1;
                :edit_box 
                {
                    key="bin_edit";
                    /* LANGID 131 */
                    label="Bin";
                    edit_limit=2;
                    edit_width=2;
                }
            }
            spacer_1;
        }
    }
    :row
    {
        :boxed_column 
        {
            /* LANGID 106 */
            label="&Cut on";
            key="cut_set";
            :row
            {
                :popup_list 
                {
                    key="cut_list";
                    edit_width=15;
                }
                spacer_1;
                :edit_box 
                {
                    key="custom_length_edit";
                    /* LANGID 129 */
                    label="Length:";
                    edit_limit=6;
                    edit_width=6;
                }
                :text_part 
                {
        		    key="custom_length_text";
        		    value="mm";
        	    }
            }
            spacer_1;
        }
    }
    spacer_0;
    :boxed_row 
    {
        my_ok_cancel_help;
    }
}

stamping : dialog {
              /* LANGID 107 */
              label="Stamping";
              :boxed_row { 
                :toggle {
                   key="stamping_toggle";
                   /* LANGID 108 */
                   label="&use stamping";
                   value="1";
                }
              }
              spacer_1;
              :popup_list {
                key="stamp_list";
                /* LANGID 109 */
                label="Predefined &string:";
                fixed_width=true;
              }
              spacer_1;
              :boxed_radio_row {
                 key="position_radio";
                 /* LANGID 110 */
                 label="&Position";
                 value="bottom";
                 :radio_button {
                   key="bottom";
                   /* LANGID 111 */
                   label="Bottom";
                 }
                 :radio_button {
                   key="middle";
                   /* LANGID 112 */
                   label="Middle";
                 }
                 :radio_button {
                   key="top";
                   /* LANGID 113 */
                   label="Top";
                 }
              }   
              spacer_1;          
              :boxed_radio_row {
                 key="font_radio";
                 /* LANGID 114 */
                 label="&Font size";
                 value="small";
                 :radio_button {
                   key="small";
                   /* LANGID 115 */
                   label="Small";
                 }
                 :radio_button {
                   key="large";
                   /* LANGID 116 */
                   label="Large";
                 }
              }   
              spacer_1;          
              :boxed_radio_row {
                 key="grayscale_radio";
                 /* LANGID 117 */
                 label="&Grayscale ";
                 value="black";
                 :radio_button {
                   key="black";
                   /* LANGID 118 */
                   label="Black";
                 }
                 :radio_button {
                   key="darkgray";
                   /* LANGID 119 */
                   label="Darkgray";
                 }
                 :radio_button {
                   key="gray";
                   /* LANGID 120 */
                   label="Gray";
                 }
                 :radio_button {
                   key="lightgray";
                   /* LANGID 121 */
                   label="Lightgray";
                 }
              }   
              

              spacer_1;
              :boxed_row {
                 my_ok_cancel_help;
              }

}


