(prompt "\n\nL O A D I N G    D I M _ U T I . L S P")

(defun DXF (code elist)
  (cdr (assoc code elist))
)

;-----------------------------------------------------------------------------------------------
(defun DIM_ssget ( / ssl  nsset temp ed )
  (setq sset (ssget))
  (setq ssl (sslength sset) 
        nsset (ssadd)
  )
  (print ssl)
  (princ "entities found. ")  
  (princ "\nVerifying the selected entities -- please wait. ")
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))
      (setq ed (entget temp))
      (if (= (DXF 0 ed) "DIMENSION") (ssadd temp nsset))
    )
  )
  (setq ssl (sslength nsset)
        sset nsset
  )
  (print ssl)
  (princ "DIMENSION entities found. ")
  (princ)
);defun DIM_ssget
;-----------------------------------------------------------------

(prompt "\n		DUP : Change DIMENSION to its original properties")

(defun c:DUP( / sset ssl temp ed old new )
(DIM_ssget)
(setq ssl (sslength sset))
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))

      (setq ed (entget temp))
      (setq old (cons 1 (DXF 1 ed)))
      (setq new (cons 1 ""))
      (setq ed (subst new old ed))

;      (setq old (cons 70 (DXF 70 ed)))
;      (setq new (cons 70 0))
;      (setq ed (subst new old ed))

      (entmod ed)  

      (COMMAND "DIMEDIT" "H" temp "")
    )
  )
 (princ)
);defun

;-----------------------------------------------------------------

(prompt "\n		ChD : Detect changed DIMENSIONS")

(defun c:ChD ( / sset ssl temp old new ed )

  (setvar "DIMCLRE" 1)      ;Color
  (setvar "DIMCLRD" 3)      ;Color
  (setvar "DIMCLRT" 4)      ;Color

  (DIM_ssget)
  (setq ssl (sslength sset))
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))

      (setq ed (entget temp))
      
      (if (/= (DXF 1 ed) "")
	  (command "dimstyle" "a" temp "")
      )
    )
  )
  (setvar "DIMCLRE" 2)      ;Color
  (setvar "DIMCLRD" 2)      ;Color
  (setvar "DIMCLRT" 2)      ;Color
  (princ)
);defun

;-----------------------------------------------------------------

(prompt "\n		DCL : To change the DIMENSIONS to Layer 1")

(defun c:DCL ( / sset ssl temp ed old new )
(DIM_ssget)
(setq ssl (sslength sset))
  (while (> ssl 0)
    (progn
      (setq temp (ssname sset (setq ssl (1- ssl))))

      (setq ed (entget temp))
      (setq old (cons 8 (DXF 8 ed)))
      (setq new (cons 8 "1"))
      (setq ed (subst new old ed))

      (entmod ed)  
    )
  )
 (princ)
);defun

;-----------------------------------------------------------------
(prompt "\n		H: to use new horizontal dim method")
(defun c:H ( )
  (prompt "\nNew dim method. ")
  (setq pt1 (getpoint "\nSelect first extension line origin : ")
        pt2 (getpoint "\nSelect second extension line origin : " pt1) 
  )
 (if (= (car pt1) (car pt2)) 
      (VE pt1 pt2)
      (HO pt1 pt2) 
  )
)
;-----------------------------------------------------------------
(prompt "\n		V: to use new vertical dim method")
(defun c:V()
  (prompt "\nNew dim method. ")
  (setq OS (getvar "OSMODE"))
  (setq pt1 (getpoint "\nSelect first extension line origin : ")
             pt2 (getpoint "\nSelect second extension line origin : " pt1) 
  ) 
 (if (= (cadr pt1) (cadr pt2)) 
      (HO pt1 pt2)
      (VE pt1 pt2) 
  )
)
;-----------------------------------------------------------------
(defun HO ( pt1 pt2 )
  (setq #DIM 1)
  (setq OS (getvar "OSMODE"))
  (setvar "OSMODE" 0)
  (setq #pt3 (getpoint "\nExtension line origin location :")
        pt11 (list (car pt1) (cadr #pt3))
        pt22 (list (car pt2) (cadr #pt3))
   )
  (command "DIM1" "HOR" pt11 pt22)
  (setvar "OSMODE" OS) 
)
;-----------------------------------------------------------------
(defun VE ( pt1 pt2 )
  (setq OS (getvar "OSMODE"))
  (setq #DIM 2)
  (setvar "OSMODE" 0) 
  (setq #pt3 (getpoint "\nExtension line origin location :")
        pt11 (list (car #pt3) (cadr pt1))
        pt22 (list (car #pt3) (cadr pt2))
  )
  (command "DIM1" "VER" pt11 pt22)
  (setvar "OSMODE" OS) 
)
;-----------------------------------------------------------------

(prompt "\n		CON: to use new continuos dim method")
(defun c:con( / pt1 pt11 pt4 pt5 A dis pt11 pt22)
 (setq OS (getvar "OSMODE"))
 (if (= #DIM 1)
   (progn
      (prompt "\nNew dim method.")
      (setq pt1 (getpoint "\nSelect next extension line origin : ")
            pt11 (list (car pt1) (cadr #pt3))
      )
      (setvar "OSMODE" 0) 
      (command "DIM1" "CON" pt11)
   )
 )
 (if (= #DIM 2)
   (progn
     (prompt "\nNew dim method. ")
     (setq pt1 (getpoint "\nSelect next extension line origin : ")
           pt11 (list (car #pt3) (cadr pt1))
     )
     (setvar "OSMODE" 0) 
     (command "DIM1" "CON" pt11)
   )
 )
 (if (= #DIM 3)
   (progn
     (prompt "\nNew dim method. ")
     (setq pt1 (getpoint "\nSelect next extension line origin : ")
           pt2 (polar #pt22 #A 100)
           pt3 (polar pt1 (+ #A 1.570796) 100)
           pt5 (inters #pt22 pt2 pt1 pt3 seg)
     )
     (setvar "OSMODE" 0) 
     (command "dim1" "con" pt5)
   )
 )
 (setvar "OSMODE" OS) 
)
;-----------------------------------------------------------------

(defun c:ali()
(command "dim1" "ali"))
;----------------------------------------------------------------------------------------------------------

(defun c:TL()
  (setvar "REGENMODE" 0)
  (setq SCALE (getreal "Input current scale : "))
  (setvar "DIMCLRE" 2)      ;Color
  (setvar "DIMCLRD" 2)      ;Color
  (setvar "DIMCLRT" 2)      ;Color
  (setvar "DIMZIN" 8)       ;Trailing
  (command "STYLE" "5" "VNI-helve" (* T5_H SCALE) T5_W "0" "N" "N")
  (command "STYLE" "3" "VNI-helve" (* T3_H SCALE) T3_W "0" "N" "N")
  (command "STYLE" "2" "vn_vni" (* T2_H SCALE) T2_W "0" "N" "N" "N")
  (setvar "DIMEXE" SCALE)             ;Extension above line
  (setvar "DIMEXO" 0)                 ;Feature offset
  (setvar "DIMASZ" (* 1.8 SCALE))     ;Arrow size 
  (setvar "DIMTSZ" 0)                 ;Tick size 1.0
  (setvar "DIMDLE" SCALE)             ;Tick extension 
  (setvar "DIMTXT" (* 1.5 SCALE))       ;Text height 2
  (setvar "DIMTAD" 1)                 ;Verical (defauft)
  (setvar "DIMTIH" 0)                 ;Horizontal
  (setvar "DIMTOH" 0)                 ;Horizontal
  (setvar "DIMTIX" 1)                 ;Force text inside   
  (setvar "DIMSOXD" 0)                ;Force text inside
  (setvar "DIMDEC" 1) 		      ;
  (setvar "DIMSCALE" 0)               ;
  (setvar "DIMGAP" (* SCALE 0.5))     ; 
  (setvar "DIMTXSTY" "2")
  (setvar "DIMFIT" 5)                ;No Leader
  (setvar "DIMSE1" 0)                ;Suppress
  (setvar "REGENMODE" 1)
)
;-----------------------------------------------------------------
(prompt "\n		H: to use new horizontal dim method")
(defun c:HB ( )
  (prompt "\nNew dim method. ")
  (setq pt1 (getpoint "\nSelect first extension line origin : ")
        pt2 (getpoint "\nSelect second extension line origin : " pt1) 
  )
 (if (= (car pt1) (car pt2)) 
      (VERB pt1 pt2)
      (HORB pt1 pt2) 
  )
)
;-----------------------------------------------------------------
(prompt "\n		V: to use new vertical dim method")
(defun c:VB()
  (prompt "\nNew dim method. ")
  (setq OS (getvar "OSMODE"))
  (setq pt1 (getpoint "\nSelect first extension line origin : ")
             pt2 (getpoint "\nSelect second extension line origin : " pt1) 
  ) 
 (if (= (cadr pt1) (cadr pt2)) 
      (HORB pt1 pt2)
      (VERB pt1 pt2) 
  )
)
;-----------------------------------------------------------------
(defun HORB ( pt1 pt2 )
  (setq #DIM 1)
  (setq OS (getvar "OSMODE"))
  (setvar "OSMODE" 0)
  (setq #pt3 (getpoint "\nExtension line origin location :"))
  (setvar "OSMODE" OS) 
  (setq pt4 (getpoint "\nDimension line location :" #pt3)
        pt11 (list (car pt1) (cadr #pt3))
        pt22 (list (car pt2) (cadr #pt3))
   )
   (setvar "OSMODE" 0)
   (if (> (cadr pt4) (cadr #pt3))
	(setq pt4 (list (car pt1) (+ (cadr pt4) (* 3.5 scale))))	
  	(setq pt4 (list (car pt1) (- (cadr pt4) (* 3.5 scale))))	
   )
  (command "DIM1" "HOR" pt11 pt22 pt4)
  (setvar "OSMODE" OS) 
)
;-----------------------------------------------------------------
(defun VERB ( pt1 pt2 )
  (setq OS (getvar "OSMODE"))
  (setq #DIM 2)
  (setvar "OSMODE" 0) 
  (setq #pt3 (getpoint "\nExtension line origin location :"))
  (setvar "OSMODE" OS) 
  (setq pt4 (getpoint "\nDimension line location :" #pt3)
        pt11 (list (car #pt3) (cadr pt1))
        pt22 (list (car #pt3) (cadr pt2))
  )
   (setvar "OSMODE" 0)
   (if (> (car pt4) (car #pt3))
	(setq pt4 (list (+ (car pt4) (* 3.5 scale)) (cadr pt1) ))	
  	(setq pt4 (list (- (car pt4) (* 3.5 scale)) (cadr pt1) ))	
   )
  (command "DIM1" "VER" pt11 pt22 pt4)
  (setvar "OSMODE" OS) 
)
;-----------------------------------------------------------------
;-----------------------------------------------------------------
;***************************************************************************
;*                                                                         *
;* NAME     :        X-DIMEXT.LSP                                          *
;*                                                                         *
;* FUNCTION :        ALLOWS TOU TO REVISE POSITION OF DIMENSION EXTENSION  *
;*                   "DEFINING POINT" ALONG ITS "X" AXIS                   *
;*                                                                         *
;* WRITTEN  :        D. RENNIE  ACER ENGINEERING  (SCOTLAND)               *
;*                   JANUARY 1992                                          *
;*                                                                         *
;***************************************************************************
(DEFUN C:xx ()
 (SETQ CMD (GETVAR "CMDECHO"))
 (SETVAR "CMDECHO" 0)
 (COMMAND "UCS" "W")
 (SETVAR "CMDECHO" 1)
 (PROMPT"\nSelect vertical dimension(s) extensions to be aligned")
 (SETQ S_SET (SSGET))
 (PROMPT"\nSelect new extension position")
 (SETQ P1 (GETPOINT))
 (SETQ X3 (CAR P1))
 (SETQ QUANT (SSLENGTH S_SET))
 (SETQ INDEX 0)
  (WHILE (< INDEX QUANT)
   (IF (AND(= "DIMENSION" (CDR (ASSOC 0 (SETQ A (ENTGET (SSNAME S_SET INDEX))))))
       )
    (PROGN
     (SETQ L13 (ASSOC 13 A))
     (SETQ M13 (CDR L13))
     (SETQ L14 (ASSOC 14 A))
     (SETQ M14 (CDR L14))
     (SETQ P13 (LIST 13 X3 (CADR M13) (CADDR M13)))
     (SETQ P14 (LIST 14 X3 (CADR M14) (CADDR M14)))
     (SETQ A (SUBST P13 L13 A))
     (SETQ A (SUBST P14 L14 A))
     (ENTMOD A)			
    )
   )
  (SETQ INDEX (+ INDEX 1))
 )
 (SETVAR "CMDECHO" 0)
 (COMMAND "UCS" "P")
 (SETVAR "CMDECHO" CMD)
 (PRINC)
)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;*************************************************************************
;*                                                                       *
;* NAME     :        Y-ALDIM.LSP                                         *
;*                                                                       *
;* FUNCTION :        ALLOWS GROUPS OF DIMENSIONS TO BE ALIGNED ALONG A   *
;*                   COMMON "Y" AXIS.                                    *
;*                                                                       *
;* WRITTEN  :        D. RENNIE  ACER ENGINEERING  (SCOTLAND)             *
;*                   JANUARY 1992                                        *
;*                                                                       *
;*************************************************************************
(DEFUN C:y2 ()
 (SETQ CMD (GETVAR "CMDECHO"))
 (SETVAR "CMDECHO" 0)
 (COMMAND "UCS" "W")
 (SETVAR "CMDECHO" 1)
 (PROMPT"\nSelect dimension(s) to be aligned")
 (SETQ S_SET (SSGET))
 (PROMPT"\nSelect new dimension position")
 (SETQ P1 (GETPOINT))
 (SETQ Y3 (CADR P1))
 (SETQ QUANT (SSLENGTH S_SET))
 (SETQ INDEX 0)
  (WHILE (< INDEX QUANT)
   (IF (AND(= "DIMENSION" (CDR (ASSOC 0 (SETQ A (ENTGET (SSNAME S_SET INDEX))))))
       )
    (PROGN
     (SETQ L10 (ASSOC 10 A))
     (SETQ M10 (CDR L10))
     (SETQ P10 (LIST 10 (CAR M10) Y3 (CADDR M10)))
     (SETQ A (SUBST P10 L10 A))
     (ENTMOD A)			
    )
   )
  (SETQ INDEX (+ INDEX 1))
 )
 (SETVAR "CMDECHO" 0)
 (COMMAND "UCS" "P")
 (SETVAR "CMDECHO" CMD)
)
;***************************************************************************
;*                                                                         *
;* NAME     :        Y-DIMEXT.LSP                                          *
;*                                                                         *
;* FUNCTION :        ALLOWS TOU TO REVISE POSITION OF DIMENSION EXTENSION  *
;*                   "DEFINING POINT" ALONG ITS "Y" AXIS                   *
;*                                                                         *
;* WRITTEN  :        D. RENNIE  ACER ENGINEERING  (SCOTLAND)               *
;*                   JANUARY 1992                                          *
;*                                                                         *
;***************************************************************************
(DEFUN C:yy ()
 (SETQ CMD (GETVAR "CMDECHO"))
 (SETVAR "CMDECHO" 0)
 (COMMAND "UCS" "W")
 (SETVAR "CMDECHO" 1)
 (PROMPT"\nSelect dimension(s) to be aligned")
 (SETQ SS_SET (SSGET))
 (PROMPT"\nSelect new dimension position")
 (SETQ P1 (GETPOINT))
 (SETQ Y3 (CADR P1))
 (SETQ QUANT (SSLENGTH SS_SET))
 (SETQ INDEX 0)
  (WHILE (< INDEX QUANT)
   (IF (AND(= "DIMENSION" (CDR (ASSOC 0 (SETQ A (ENTGET (SSNAME SS_SET INDEX))))))
       )
    (PROGN
     (SETQ L13 (ASSOC 13 A))
     (SETQ M13 (CDR L13))
     (SETQ L14 (ASSOC 14 A))
     (SETQ M14 (CDR L14))
     (SETQ P13 (LIST 13 (CAR M13) Y3 (CADDR M13)))
     (SETQ T13 (CDR P13))
     (SETQ P14 (LIST 14 (CAR M14) Y3 (CADDR M14)))
     (SETQ A (SUBST P13 L13 A))
     (SETQ A (SUBST P14 L14 A))
     (ENTMOD A)			
    )
   )
  (SETQ INDEX (+ INDEX 1))
 )
 (SETVAR "CMDECHO" 0)
 (COMMAND "UCS" "P")
 (SETVAR "CMDECHO" CMD)
)
