(setq dlg_post '(-1 -1))

(defun C:testdlg( / dcl_id )

  (setq dcl_id (load_dialog "testdlg.dcl"))  	
  (if (< dcl_id 0) (exit))   

  (if (not (new_dialog "dlgname" dcl_id "" dlg_post)) (exit))

  (action_tile "accept" "(ok)")
  
  (setq mlist (list "Ngo Tran Trong Le" "Nguyen Hung Dung" "Doan Vinh Khiem"))
  (start_list "list")
  (mapcar 'add_list mlist)
  (end_list)

  (set_tile "enable1" "1") 
  (set_tile "enable2" "1") 

  (action_tile "add" "(fadd)")
  (action_tile "list" "(flist $value)")
  (action_tile "enable1" "(fenable1)")
  (action_tile "enable2" "(fenable2)")

  (mode_tile "list" 2);


  (start_dialog)                           	
  (unload_dialog dcl_id)                   	

  (princ)
)
;-----------------------------------------------
(defun fenable1 ()
   (if (= (get_tile "enable1") "1")
     (progn
        ( mode_tile "toggle1" 0 )
        ( mode_tile "toggle2" 0 )
     )
     (progn
        ( mode_tile "toggle1" 1 )
        ( mode_tile "toggle2" 1 )
     )
   )
)
;-----------------------------------------------
(defun fenable2 ()
   (if (= (get_tile "enable2") "1")
     (progn
        ( mode_tile "radio1" 0 )
        ( mode_tile "radio2" 0 )
     )
     (progn
        ( mode_tile "radio1" 1 )
        ( mode_tile "radio2" 1 )
     )
   )
)
;-----------------------------------------------
(defun ok ()
  (setq dlg_post (done_dialog 1))
)
;-----------------------------------------------
(defun flist ( value )
  (setq str (nth (atoi value) mlist))
  (set_tile "text" str)
)
;-----------------------------------------------
(defun fadd ()
  (setq name (get_tile "edit"))
  (set_tile "edit" "")
  (setq mlist (append mlist (list name)))
  (start_list "list" 3)
  (mapcar 'add_list mlist)
  (end_list)
)